/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride          *
 *   kevin@planetsaphire.com            *
 *             *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as  *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.        *
 *             *
 *   This program is distributed in the hope that it will be useful,  *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of   *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    *
 *   GNU General Public License for more details.      *
 *             *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the       *
 *   Free Software Foundation, Inc.,         *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.   *
 ***************************************************************************/

#define	LIBTEKLTI_EXPORT	(0)

#ifndef	_cplusplus
#define	_cplusplus
#endif	/* _cplusplus */
#include "teklti.h"


#ifdef	USE_386_ASM

#include <limits.h>
#include <errno.h>

static const void * _tfbtmp = NULL;

const char TekFileASCIIBare_ReadOnly[] = "rb";
const char TekFileASCIIBare_WriteOnly[] = "wb";
const char TekFileASCIIBare_Append[] = "ab";
const char TekFileASCIIBare_ReadWrite[] = "r+b";
const char TekFileASCIIBare_ReadWriteTrunc[] = "w+b";
const char TekFileASCIIBare_ReadAppend[] = "a+b";

/*extern const char TekFileASCIIBare_ReadOnly[] = "r";
extern const char TekFileASCIIBare_WriteOnly[] = "w";
extern const char TekFileASCIIBare_Append[] = "a";
extern const char TekFileASCIIBare_ReadWrite[] = "r+";
extern const char TekFileASCIIBare_ReadWriteTrunc[] = "w+";
extern const char TekFileASCIIBare_ReadAppend[] = "a+";*/


#ifdef	TEKLTI_DEFINE_OUTSIDECODE_FUNC
static void tekfileasciibare_dummyreturn ( void )
{
#endif	/* TEKLTI_DEFINE_OUTSIDECODE_FUNC */
	__asm__ ( " tekfileasciibare_dummyreturn: " );
	/* On error, raise int 3 (Trace/Breakpoint Trap). */
	__asm__ ( " int $3 " );
	/* Restore the stack pointer. */
	__asm__ ( " movl %ebp, %esp " );
	/* Pop the base pointer. */
	__asm__ ( " popl %ebp " );
	/* Return to caller. */
	__asm__ ( " ret " );
#ifdef	TEKLTI_DEFINE_OUTSIDECODE_FUNC
}
#endif	/* TEKLTI_DEFINE_OUTSIDECODE_FUNC */

/**
    Instantizer.
 */

TekFileASCIIBare::TekFileASCIIBare()
{
	TEKSTD_IMPLEMENT_INTERFACE(UTekFile)
	TEKSTD_IMPLEMENT_INTERFACE(UTekFileASCII)
	TEKSTD_IMPLEMENT_INTERFACE(UTekFileASCIIBare)
	TEKSTD_IMPLEMENT_ENDBASE

#ifdef	USE_386_ASM_MMX
#ifdef	USE_386_ASM_MMX_RESET_MM7
	/* Copy the nullified quadword to mm0. */
	__asm__ ( " movq %0, %%mm7 " : "=m" (tekzerovar) );
#endif	/* USE_386_ASM_MMX_RESET_MM7 */
	/* Obtain our private section of local variables. */
	__asm__ ( " movl 8(%ebp), %ecx " );

#ifdef	UNICODE
	/* Copy the null quadword to the ascii variables. */
	__asm__ ( " movq %mm7, 112(%ecx) " );
	/* Copy the null quadword to the unicode variables. */
	__asm__ ( " movq %mm7, 120(%ecx) " );
	/* then into PrivFileDesc/PrivFileMode */
	__asm__ ( " movq %mm7, 128(%ecx) " );
	/* and finally into PrivTekFileType. */
	__asm__ ( " movl %1, 136(%%ecx) " : "=m" (_tfbtmp) : "i" (TekFileType_ASCII) );
#else	/* not UNICODE */
	/* Copy the null quadword to the ascii variables. */
	__asm__ ( " movq %mm7, 112(%ecx) " );
	/* then into PrivFileDesc/PrivFileMode */
	__asm__ ( " movq %mm7, 120(%ecx) " );
	/* and finally into PrivTekFileType. */
	__asm__ ( " movl %1, 128(%%ecx) " : "=m" (_tfbtmp) : "i" (TekFileType_ASCII) );
#endif	/* not UNICODE */

	/* Run malloc(TEKFILEASCII_STDBUFLEN) */
	/* Make sure ecx can be saved. */
	__asm__ ( " subl $8, %esp " );
	/* FIXME: Possible duplicate instruction, */
	/* Set the TekBufferLen to zero. */
	__asm__ ( " movd %mm7, 136(%ecx) " );
	/* Save ecx. */
	__asm__ ( " movl %ecx, 4(%esp) " );
	/* Put TEKFILEASCII_STDBUFLEN on the stack as param 0 of malloc(). */
	__asm__ ( " movl %1, (%%esp) " : "=m" (_tfbtmp) : "i" (TEKFILEASCII_STDBUFLEN) );
	/* Call malloc(). */
	__asm__ ( " call malloc " );
	/* Restore %ecx. */
	__asm__ ( " movl 4(%esp), %ecx " );
	/* Restore the stack. */
	__asm__ ( " addl $8, %esp " );

	/* Test result of %eax. */
	__asm__ ( " testl %eax, %eax " );
	/* Check to see what to do. */
	__asm__ ( " je tekfileasciibare_dummyreturn " );
	/* FIXME: Needs to become UNICODE ready. */
	/* Put %eax into the private value. */
	__asm__ ( " movl %eax, 132(%ecx) " );

	/* Copy the null dword to the ascii length var of PrivBuffer. */
	/* FIXME: Possible duplicate instruction, */
	__asm__ ( " movd %mm7, 136(%ecx) " );
#ifdef	UNICODE
	/* Copy the null quadword to the unicode variables. */
	__asm__ ( " movq %mm7, 140(%ecx) " );
	/* Put %eax into the private value pointer. */
	__asm__ ( " movl %eax, 148(%ecx) " );
	/* Copy the null dword to the ascii length var of PrivBufferPtr. */
	/* NOTE: Commented out, zeroing not necessary at this time. */
	/* __asm__ ( " movd %mm7, 152(%ecx) " ); */
	/* Copy the null quadword to the unicode variables. */
	__asm__ ( " movq %mm7, 160(%ecx) " );
#else	/* not UNICODE */
	/* Put %eax into the private value pointer. */
	__asm__ ( " movl %eax, 140(%ecx) " );
	__asm__ ( " movl %eax, 144(%ecx) " );
	/* Copy the null dword to the ascii length var of PrivBufferPtr. */
	/* NOTE: Commented out, zeroing not necessary at this time. */
	/* __asm__ ( " movd %mm7, 144(%ecx) " ); */
#endif	/* not UNICODE */

	/* Be sure to exit the mmx state before leaving. */
	__asm__ ( " emms " );

#else	/* not USE_386_ASM_MMX */
	/* If we're here, we are not using mmx. */
#ifdef	USE_386_ASM_PUSHPOP
	/* Save the current value of edi if necessary. */
	__asm__ ( " pushl %edi " );
#endif	/* USE_386_ASM_PUSHPOP */

	/* Obtain our private section of local variables. */
	__asm__ ( " movl 8(%ebp), %edi " );

	/* Set ax = 0. */
	__asm__ ( " xorl %eax, %eax " );

	/* Add 112 to edi for alignment with our private members. */
	__asm__ ( " addl $112, %edi " );

	/* Set up ecx as appropriate. */
#ifdef	UNICODE
	__asm__ ( " movl $6, %ecx " );
#else	/* not UNICODE */
	__asm__ ( " movl $4, %ecx " );
#endif	/* not UNICODE */

	/* Call the stosl function until the area in edi is nullified. */
	__asm__ ( " rep stosl " );

	/* Set up the TekFileType value. */
	__asm__ ( " movl %1, (%%edi) " : "=m" (_tfbtmp) : "i" (TekFileType_ASCII) );

	/* Run malloc(TEKFILEASCII_STDBUFLEN) */
	/* Make sure edi is saved. */
	__asm__ ( " subl $8, %esp " );
	/* Save edi. */
	__asm__ ( " movl %edi, 4(%esp) " );
	/* Put TEKFILEASCII_STDBUFLEN on the stack as param 0 of malloc(). */
	__asm__ ( " movl %1, (%%esp) " : "=m" (_tfbtmp) : "i" (TEKFILEASCII_STDBUFLEN) );
	/* Call malloc(). */
	__asm__ ( " call malloc " );
	/* Restore %edi. */
	__asm__ ( " movl 4(%esp), %edi " );
	/* Restore the stack. */
	__asm__ ( " addl $8, %esp " );

	/* Test result of %eax. */
	__asm__ ( " testl %eax, %eax " );
	/* Check to see what to do. */
	__asm__ ( " je tekfileasciibare_dummyreturn " );
	/* Put %eax into the private value. */
	__asm__ ( " movl %eax, 4(%edi) " );
	/* Re-align edi. */
	__asm__ ( " addl $8, %edi " );

	/* Set up ecx as appropriate. */
#ifdef	UNICODE
	__asm__ ( " movl $7, %ecx " );
#else	/* not UNICODE */

	__asm__ ( " movl $0, (%edi) " );
	/* Set BufferPtr's ascii. */
	__asm__ ( " movl %eax, 4(%edi) " );
	/* Set BufferPtr's asciilen. */
	__asm__ ( " movl %eax, 8(%edi) " );
	/* Re-align edi. */
	//__asm__ ( " addl $8, %edi " );
	//__asm__ ( " movl $2, %ecx " );
#endif	/* not UNICODE */

	/* NULLify eax again. */
	//__asm__ ( " xorl %eax, %eax " );
	/* Call the stosl function until the area in ecx is nullified. */
	//__asm__ ( " rep stosl " );

#ifdef	USE_386_ASM_PUSHPOP
	/* Be sure to pop edi off the stack if we saved it earlier. */
	__asm__ ( " popl %edi " );
#endif	/* USE_386_ASM_PUSHPOP */
#endif	/* not USE_386_ASM_MMX */
}


/**
    Destructor.
    
    FIXME: Convert this function to assembly.
 */

TekFileASCIIBare::~TekFileASCIIBare()
{
	__asm__ ( " int $3 " );
	if ( this->PrivFileDesc != NULL )
		fclose(this->PrivFileDesc);
	if ( this->PrivFileName.uchar_t_ascii != NULL )
		free(this->PrivFileName.uchar_t_ascii);
#ifdef	TEKLTI_ENFORCE_PRIVACY
	memset(this->PrivBuffer.uchar_t_ascii, '\0', TEKFILEASCII_STDBUFLEN);
#endif	/* TEKLTI_ENFORCE_PRIVACY */
	free((void *)this->PrivBufferPtr.uchar_t_asciilen);
}


/**
    \fn TekFileASCIIBare::ReadLine(uchar_t** Buffer, unsigned long ReadMax)
    
    Reads up to ReadMax characters from a file and puts it in a
    uchar_t.  The Buffer can be an already-created uchar_t, or
    can be a pointer to a uchar_t* to store the new uchar_t in.

    NOTE: It is best to let this function create a uchar_t for
    your program/library to read from.  The uchar_t passed in
    must be at least TEKFILEASCII_STDBUFLEN + 1 bytes long.
    This is for optimization reasons, so it is best to use only
    uchar_t's that were created from this function.
 */

TEKERR TekFileASCIIBare::ReadLine(uchar_t** Buffer, unsigned long ReadMax)
{
/*
 ***************************
 * CRITICAL CHECKS SECTION *
 ***************************
 */

#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Get our private section of local variables. */
	__asm__ ( " movl 8(%ebp), %eax " );
#ifdef	UNICODE
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 128(%eax), %ecx " );
#else	/* UNICODE */
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 120(%eax), %ecx " );
#endif	/* UNICODE */
	/* Test to see if %ecx is NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If it isn't, resume. */
	__asm__ ( " jne .TekFileASCIIBare_ReadLine_internalchkpass " );

	/* Set return value appropriately. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Return to caller. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_ret2 " );

	/* Used to bypass error set. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_internalchkpass: " );
#endif	/* not NO_INTERNAL_NULL_CHECKS */

#ifdef	USE_386_ASM_PUSHPOP
	/* Set up our own stack space. */
	__asm__ ( " subl $24, %esp " );
	/* Save esi to %esi+16. */
	__asm__ ( " movl %esi, 20(%esp) " );
	/* Save edi to %esi+12. */
	__asm__ ( " movl %edi, 16(%esp) " );
#else	/* USE_386_ASM_PUSHPOP */
	/* Set up our own stack space. */
	__asm__ ( " subl $16, %esp " );
#endif	/* USE_386_ASM_PUSHPOP */

/*
 ********************
 * ALLOCATE SECTION *
 ********************
 */

	/* Retrieve the pointer to Buffer. */
	__asm__ ( " movl %0, %%ecx " : "=m" ( Buffer ) );
	/* Retrieve the value Buffer points to. */
	__asm__ ( " movl (%ecx), %esi " );
	/* Test to see if it is NULL. */
	__asm__ ( " testl %esi, %esi " );
	/* If it isn't, skip the malloc() section. */
	__asm__ ( " jne .TekFileASCIIBare_ReadLine_nomalloc " );

	/* Set param 0 to $8 or $16. */
#ifdef	UNICODE
	__asm__ ( " movl $16, (%esp) " );
#else	/* not UNICODE */
	__asm__ ( " movl $8, (%esp) " );
#endif	/* not UNICODE */
	/* Call malloc(). */
	__asm__ ( " call malloc " );
	/* Test the result. */
	__asm__ ( " testl %eax, %eax " );
	/* If successful, allocate the string. */
	__asm__ ( " jne .TekFileASCIIBare_ReadLine_mallocstr " );
	/* If failed, report error to caller. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_MEMORY) );
	/* Jump to appropriate label for cleanup. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_ret " );

	/* Label for allocating the string. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_mallocstr: " );
	/* Retrieve the pointer to Buffer. */
	__asm__ ( " movl %0, %%ecx " : "=m" ( Buffer ) );
	/* Store %eax into it. */
	__asm__ ( " movl %eax, (%ecx) " );
	/* Move %eax to 12(%esp) for later use. */
	__asm__ ( " movl %eax, 12(%esp) " );

	/* Set param 0 to TEKFILEASCII_STDBUFLEN. */
	__asm__ ( " movl %1, (%%esp) " : "=m" (_tfbtmp) : "i" (TEKFILEASCII_STDBUFLEN) );
	/* Set param 1 to sizeof(char). */
	__asm__ ( " movl $1, 4(%esp) " );
	/* Call calloc(). */
	__asm__ ( " call calloc " );
	/* Test the result. */
	__asm__ ( " testl %eax, %eax " );
	/* If successful, we are done allocating. */
	__asm__ ( " jne .TekFileASCIIBare_ReadLine_mallocfinish " );
	/* If failed, put 12(%esp) on the stack for cleanup. */
	__asm__ ( " movl 12(%esp), %eax " );
	__asm__ ( " movl %eax, (%esp) " );
	/* Call free(). */
	__asm__ ( " call free " );
	/* Retrieve the pointer to Buffer. */
	__asm__ ( " movl %0, %%ecx " : "=m" ( Buffer ) );
	/* Store NULL into it. */
	__asm__ ( " movl $0, (%ecx) " );
	/* Report error to caller. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_MEMORY) );
	/* Jump to appropriate label for cleanup. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_ret " );

	/* Used to finish the setup of the new Buffer. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_mallocfinish: " );
	/* Retrieve uchar buffer. */
	__asm__ ( " movl 12(%esp), %esi " );
	/* Store %eax into (%esi). */
	__asm__ ( " movl %eax, (%esi) " );
	/* Store count into 4(%esi). */
	__asm__ ( " movl %1, 4(%%esi) " :
		"=m" (_tfbtmp) :
		"i" (TEKFILEASCII_STDBUFLEN + 1) );

	/* Used to bypass malloc() area. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_nomalloc: " );

/*
 ****************************
 * READ FROM BUFFER SECTION *
 ****************************
 */

	/* Now, we need to see if we haven't cleared the buffer yet. */
	__asm__ ( " cld " );
	/* Get the private variable area. */
	__asm__ ( " movl 8(%ebp), %eax " );
#ifdef	UNICODE
	/* Move a section of memory that contains the string len. */
	__asm__ ( " movl 144(%eax), %ecx " );
#else	/* UNICODE */
	/* Move a section of memory that contains the string len. */
	__asm__ ( " movl 136(%eax), %ecx " );
#endif	/* UNICODE */
	/* Get the pointer to the string. */
	__asm__ ( " movl (%esi), %edi " );
	/* Compare the len. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If zero, we need to read more data from the file. */
	__asm__ ( " je .TekFileASCIIBare_ReadLine_readmore " );

#ifdef	USE_386_ASM_ENFORCE_PRIVACY
	/* Set %eax to zero. */
	__asm__ ( " xorl %eax, %eax " );
	/* Put value of %ecx into %esi temporairily. */
	__asm__ ( " movl %ecx, %esi " );
	/* Set %ecx to TEKFILEASCII_STDBUFLEN / 4 */
	__asm__ ( " movl %1, %%ecx " :
		"=m" (_tfbtmp) :
		"i" (TEKFILEASCII_STDBUFLEN / 4) );
	/* Store (TEKFILEASCII_STDBUFLEN / 4) $0 dwords into edi. */
	__asm__ ( " rep stosl " );
	/* Restore edi. */
	__asm__ ( " subl %1, %%edi " :
		"=m" (_tfbtmp) :
		"i" (TEKFILEASCII_STDBUFLEN) );
	/* Restore ecx. */
	__asm__ ( " movl %esi, %ecx " );
	/* Restore eax. */
	__asm__ ( " movl 8(%ebp), %eax " ) ;
#endif	/* USE_386_ASM_ENFORCE_PRIVACY */

	/* We need to get the pointer to the buffer. */
#ifdef	UNICODE
	__asm__ ( " movl 140(%eax), %esi " );
#else	/* UNICODE */
	__asm__ ( " movl 132(%eax), %esi " );
#endif	/* UNICODE */

	/* Save %ebx to %esp+12. */
	__asm__ ( " movl %ebx, 12(%esp) " );

	/* Put asciilen into %ebx. */
	__asm__ ( " movl %ecx, %ebx " );
	/* Put ReadMax into eax. */
	__asm__ ( " movl 16(%ebp), %ecx " );
	/* Get ready to enter a loop. */
	__asm__ ( " incl %ecx " );
	/* See if we need to enter the loop. */
	__asm__ ( " loop .TekFileASCIIBare_ReadLine_readmax_loop " );
	/* If we don't, return an error. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_readmax_ntd " );

	/* This label is a loop for copying from buffer to passed-in ptr. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_readmax_loop: " );
	/* Check to see if we have already read the last bit. */
	__asm__ ( " testl %ebx, %ebx " );
	/* If we have, we need to bail out of this loop. */
	__asm__ ( " je .TekFileASCIIBare_ReadLine_readmax_bailout3 " );

	/* Check to see if we have read a /r or /n. */
	/* Start with '/r'. */
	__asm__ ( " cmpb $13, (%esi) " );
	__asm__ ( " je .TekFileASCIIBare_ReadLine_readmax_bailout2 " );
	/* Then with '/n'. */
	__asm__ ( " cmpb $10, (%esi) " );
	__asm__ ( " je .TekFileASCIIBare_ReadLine_readmax_bailout2 " );

	/* Move a character from (%esi) to (%edi). */
	__asm__ ( " movsb " );
	/* Decrement ebx. */
	__asm__ ( " decl %ebx " );
	/* See if we need to stay in the loop. */
	__asm__ ( " loop .TekFileASCIIBare_ReadLine_readmax_loop " );
	/* If we don't, and we're here, we haven't reached EOS. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_readmax_bailout " );

	/* This label is used to bail out of the ReadMax loop. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_readmax_bailout2: " );

	/* This label is also used to bail out of the ReadMax loop. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_readmax_bailout3: " );
	/* Restore private value's string pointer. */
#ifdef	UNICODE
	__asm__ ( " movl 148(%eax), %edi " );
	__asm__ ( " movl %edi, 140(%eax), " );
#else	/* not UNICODE */
	__asm__ ( " movl 140(%eax), %edi " );
	__asm__ ( " movl %edi, 132(%eax) " );
#endif	/* not UNICODE */
	/* Reset Buffer's len. */
#ifdef	UNICODE
	__asm__ ( " movl $0, 144(%eax) " );
#else	/* UNICODE */
	__asm__ ( " movl $0, 136(%eax) " );
#endif	/* UNICODE */

	/* Restore %ebx from %esp+12. */
	__asm__ ( " movl 12(%esp), %ebx " );

#ifdef	USE_386_ASM_ENFORCE_PRIVACY
	/* Set %ecx to .TEKFILEASCII_STDBUFLEN. */
	__asm__ ( " movl %1, %%ecx " :
		"=m" (_tfbtmp) :
		"i" (TEKFILEASCII_STDBUFLEN / 4) );
	/* NULLify eax. */
	__asm__ ( " xorl %eax, %eax " );
	/* Fry the buffer. */
	__asm__ ( " rep stosl " );
#endif	/* not USE_386_ASM_ENFORCE_PRIVACY */

	/* Set %ecx to TEKERR_FILE_EOF. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_EOF) );
	/* Jump to cleanup area. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_ret " );

	/* This label is also used to bail out of the ReadMax loop. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_readmax_bailout: " );
#ifndef	USE_386_ASM_ENFORCE_PRIVACY
	/* Put a NULL character into %edi. */
	__asm__ ( " movb $0, (%edi) " );
#endif	/* not USE_386_ASM_ENFORCE_PRIVACY */
	/* Move ebx to memory that contains the Buffer len. */
#ifdef	UNICODE
	__asm__ ( " movl %ebx, 144(%eax) " );
#else	/* UNICODE */
	__asm__ ( " movl %ebx, 136(%eax) " );
#endif	/* UNICODE */
	/* Move edi to area containing the Buffer pointer. */
#ifdef	UNICODE
	__asm__ ( " movl %esi, 140(%eax), " );
#else	/* not UNICODE */
	__asm__ ( " movl %esi, 132(%eax) " );
#endif	/* not UNICODE */
	/* Restore %ebx from %esp+12. */
	__asm__ ( " movl 12(%esp), %ebx " );

	/* Jump to success area. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_success " );

	/* This label is used to skip the ReadMax loop for "nothing to do". */
	__asm__ ( " .TekFileASCIIBare_ReadLine_readmax_ntd: " );
	/* Restore %ebx from %esi+12. */
	__asm__ ( " movl 12(%esp), %ebx " );
	/* Set return value appropriately. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FAIL) );
	/* Return to caller. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_ret " );

	/* This label is used to make a call to fread(). */
	__asm__ ( " .TekFileASCIIBare_ReadLine_readmore: " );

/*
 *********************
 * READ FILE SECTION *
 *********************
 */

#ifdef	NO_INTERNAL_NULL_CHECKS
	/* Get our private section of local variables. */
	__asm__ ( " movl 8(%ebp), %eax " );
#endif	/* NO_INTERNAL_NULL_CHECKS */
#ifdef	UNICODE
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 128(%eax), %ecx " );
#else	/* UNICODE */
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 120(%eax), %ecx " );
#endif	/* UNICODE */
	/* Put the FILE * onto the stack. */
	__asm__ ( " movl %ecx, 8(%esp) " );
	/* Put "TEKFILEASCII_STDBUFLEN + 1" onto the stack. */
	__asm__ ( " movl %1, 4(%%esp) " :
		"=m" (_tfbtmp) :
		"i" (TEKFILEASCII_STDBUFLEN + 1) );
#ifdef	UNICODE
	/* Move a section of memory that contains the PrivBuffer. */
	__asm__ ( " movl 140(%eax), %ecx " );
#else	/* UNICODE */
	/* Move a section of memory that contains the PrivBuffer. */
	__asm__ ( " movl 132(%eax), %ecx " );
#endif	/* UNICODE */
	/* Move the buffer string onto the stack. */
	__asm__ ( " movl %ecx, (%esp) " );
	/* Be sure to save the passed-in dest. pointer for later. */
	__asm__ ( " movl %edi, 12(%esp) " );
	/* Call fgets(). */
	__asm__ ( " call fgets " );
	/* Test for failure. */
	__asm__ ( " testl %eax, %eax " );
	/* If fgets() passed, let's parse the input. */
	__asm__ ( " jne .TekFileASCIIBare_ReadLine_read_done " );

	/* Otherwise, check for EOF error. */
	/* Get our private section of local variables. */
	__asm__ ( " movl 8(%ebp), %eax " );
#ifdef	UNICODE
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 128(%eax), %ecx " );
#else	/* UNICODE */
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 120(%eax), %ecx " );
#endif	/* UNICODE */
	/* Put %ecx onto the stack as param 0. */
	__asm__ ( " movl %ecx, (%esp) " );
	/* Call feof(). */
	__asm__ ( " call feof " );
	/* If not EOF, check the errno from errno. */
	__asm__ ( " jne .TekFileASCIIBare_ReadLine_read_errno " );

	/* Set retval to TEKERR_FILE_EOF. */
	__asm__ ( " movl %1, %%eax " :
		"=m" (_tfbtmp) :
		"i" (TEKERR_FILE_EOF) );
	/* Go to cleanup area. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_ret " );

	/* This label is used to get errno from failed fgets() call. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_read_errno: " );
	/* Get the errno. */
	__asm__ ( " movl %0, %%eax " : "=m" (errno) );
	/* Check for EPIPE error. */
	__asm__ ( " movl %1, %%eax " :
		"=m" (_tfbtmp) :
		"i" (EPIPE) );
	/* If not EPIPE, then this is an IO error. */
	__asm__ ( " jne .TekFileASCIIBare_ReadLine_read_errno_io " );

	/* Set retval to TEKERR_FILE_PIPE. */
	__asm__ ( " movl %1, %%eax " :
		"=m" (_tfbtmp) :
		"i" (TEKERR_FILE_PIPE) );
	/* Go to cleanup area. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_ret " );

	/* This label is used to return IO error to caller. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_read_errno_io: " );
	/* Set retval to TEKERR_FILE_IO. */
	__asm__ ( " movl %1, %%eax " :
		"=m" (_tfbtmp) :
		"i" (TEKERR_FILE_IO) );
	/* Go to cleanup area. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_ret " );

	/* This label is used to bypass the fgets() error handling area. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_read_done: " );

/*
 ***************************
 * COPY WHOLE DATA SECTION *
 ***************************
 */

	/* From this point, we are ready to clear the flag. */
	__asm__ ( " cld " );
	/* Get pointer to our private variables (again) */
	__asm__ ( " movl 8(%ebp), %eax " );
	/* We need to get the pointer to the buffer. */
#ifdef	UNICODE
	__asm__ ( " movl 140(%eax), %esi " );
#else	/* UNICODE */
	__asm__ ( " movl 132(%eax), %esi " );
#endif	/* UNICODE */
	/* Let's restore the %edi. */
	__asm__ ( " movl 12(%esp), %edi " );

#ifdef	USE_386_ASM_ENFORCE_PRIVACY
	/* Set ecx to TEKFILEASCII_STDBUFLEN / 4 */
	__asm__ ( " movl %1, %%ecx " :
		"=m" (_tfbtmp) :
		"i" (TEKFILEASCII_STDBUFLEN / 4) );
	/* Set eax to zero. */
	__asm__ ( " xorl %eax, %eax " );
	/* NULLify %edi. */
	__asm__ ( " rep stosl " );
	/* Restore %edi. */
	__asm__ ( " subl %1, %%edi " :
		"=m" (_tfbtmp) :
		"i" (TEKFILEASCII_STDBUFLEN) );
#endif	/* USE_386_ASM_ENFORCE_PRIVACY */

	/* Save %ebx to %esp+12. */
	__asm__ ( " movl %ebx, 12(%esp) " );
	/* Put "TEKFILEASCII_STDBUFLEN + 1" into ecx for a loop. */
	__asm__ ( " movl %1, %%ecx " :
		"=m" (_tfbtmp) :
		"i" (TEKFILEASCII_STDBUFLEN) );
	/* Set ebx to 0. */
	__asm__ ( " xorl %ebx, %ebx " );
	/* Set eax to ReadMax. */
	__asm__ ( " movl 16(%ebp), %eax " );

	/* Start the loop. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_readwhole_loop: " );

	/* Check if we have reached ReadMax. */
	__asm__ ( " cmpl %eax, %ebx " );
	/* If equal, we are going to use partial copying. */
	__asm__ ( " je .TekFileASCIIBare_ReadLine_read_partdata " );

	/* Check to see if (%esi) is '\r' or '\n'. */
	/* Start with '/r'. */
	__asm__ ( " cmpb $13, (%esi) " );
	__asm__ ( " je .TekFileASCIIBare_ReadLine_readwhole_bailout " );
	/* Then with '/n'. */
	__asm__ ( " cmpb $10, (%esi) " );
	__asm__ ( " je .TekFileASCIIBare_ReadLine_readwhole_bailout " );

	/* Move a character from (%esi) to (%edi). */
	__asm__ ( " movsb " );
	/* Increment length. */
	__asm__ ( " incl %ebx " );
	/* See if we need to stay in the loop. */
	__asm__ ( " loop .TekFileASCIIBare_ReadLine_readwhole_loop " );
#ifndef	USE_386_ASM_ENFORCE_PRIVACY
	/* If not, let's bail out. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_readwhole_bailout2 " );
#endif	/* not USE_386_ASM_ENFORCE_PRIVACY */

	/* If we're here, we reached a termination. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_readwhole_bailout: " );
#ifndef	USE_386_ASM_ENFORCE_PRIVACY
	/* NULLify the byte of (%edi). */
	__asm__ ( " movb $0, (%edi) " );

	__asm__ ( " .TekFileASCIIBare_ReadLine_readwhole_bailout2: " );
#endif	/* not USE_386_ASM_ENFORCE_PRIVACY */

	/* Restore %ebx from %esp+12. */
	__asm__ ( " movl 12(%esp), %ebx " );
	/* Jump to success return area. */
	__asm__ ( " jmp .TekFileASCIIBare_ReadLine_success " );

	/* This label is used to go to partial data section. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_read_partdata: " );

/*
 *****************************
 * COPY PARTIAL DATA SECTION *
 *****************************
 */

	/* Get pointer to our private variables (again) */
	__asm__ ( " movl 8(%ebp), %edi " );
	/* We need to save the pointer to the PrivBuffer. */
#ifdef	UNICODE
	__asm__ ( " movl %esi, 140(%edi) " );
#else	/* UNICODE */
	__asm__ ( " movl %esi, 132(%edi) " );
#endif	/* UNICODE */

	/* Reset ebx (again). */
	__asm__ ( " xorl %ebx, %ebx " );

	/* Look for '\0' in the string. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_read_partnull: " );
	/* Retrieve the next character. */
	__asm__ ( " lodsb " );
	/* Check to see if it is NULL. */
	__asm__ ( " testb %al, %al " );
	/* If it is, we stop here. */
	__asm__ ( " je .TekFileASCIIBare_ReadLine_read_partnullbail " );

	/* Increment length. */
	__asm__ ( " incl %ebx " );
	/* Loop to next available byte. */
	__asm__ ( " loop .TekFileASCIIBare_ReadLine_read_partnull " );
	/* Bail-out mechanism. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_read_partnullbail: " );

#ifdef	UNICODE
	/* Move a section of memory that contains the string len. */
	__asm__ ( " movl %ebx, 144(%edi) " );
#else	/* UNICODE */
	/* Move a section of memory that contains the string len. */
	__asm__ ( " movl %ebx, 136(%edi) " );
#endif	/* UNICODE */

	/* Restore %ebx from %esp+12. */
	__asm__ ( " movl 12(%esp), %ebx " );

/*
 ***********************************
 * END-OF-FUNCTION CLEANUP SECTION *
 ***********************************
 */

	/* Used for success returns. */
	__asm__ ( " .TekFileASCIIBare_ReadLine_success: " );
	/* Set retval to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK

	/* Used to free stack on failure.  */
	__asm__ ( " .TekFileASCIIBare_ReadLine_ret: " );
#ifdef	USE_386_ASM_PUSHPOP
	/* Restore esi from %esi+20. */
	__asm__ ( " movl 20(%esp), %esi " );
	/* Restore edi from %esi+16. */
	__asm__ ( " movl 16(%esp), %edi " );
	/* Get rid of our own stack space. */
	__asm__ ( " addl $24, %esp " );
#else	/* USE_386_ASM_PUSHPOP */
	/* Get rid of our own stack space. */
	__asm__ ( " addl $16, %esp " );
#endif	/* USE_386_ASM_PUSHPOP */

#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Used to return on internal check failure.  */
	__asm__ ( " .TekFileASCIIBare_ReadLine_ret2: " );
#endif	/* not NO_INTERNAL_NULL_CHECKS */
}

#ifdef	TEKLTI_WRITELINE_CRLF
const char tekfileasciibare_writeline_crlf[] = "\r\n";
#endif	/* TEKLTI_WRITELINE_CRLF */


/**
    \fn TekFileASCIIBare::WriteLine(const uchar_t* Buffer)
    
    Writes a ascii-part of a uchar_t to the file.

    WARNING!  On Intel platforms, this function may utilize MMX
    for optimization purposes!  Register mm6 can be
    modified by this function!
 */
TEKERR TekFileASCIIBare::WriteLine(const uchar_t* Buffer)
{
	/* Get the value of buffer. */
	__asm__ ( " movl %0, %%ecx " : "=m" ( Buffer ) );
#ifndef	NO_SIZE_T_CHECKS
	/* Test to see if it is NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If it isn't, we're ok. */
	__asm__ ( " jne .TekFileASCIIBare_WriteLine_BufferOK " );

	/* If it is, set the error value. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_POINTER) );
	/* Return to caller. */
	__asm__ ( " jmp .TekFileASCIIBare_WriteLine_ret " );

	/* For successful test. */
	__asm__ ( " .TekFileASCIIBare_WriteLine_BufferOK: " );
#endif	/* not NO_SIZE_T_CHECKS */

	/* Get our private section of local variables. */
	__asm__ ( " movl 8(%ebp), %eax " );

#if	defined(USE_386_ASM_MMX_FPUTS_SAFE) && defined(USE_386_ASM_FPUTS_FIX1)
#ifdef	UNICODE
	/* Move a section of memory to %mm6 that contains the FILE *. */
	__asm__ ( " movd 128(%eax), %mm6 " );
#else	/* UNICODE */
	/* Move a section of memory to %mm6 that contains the FILE *. */
	__asm__ ( " movd 120(%eax), %mm6 " );
#endif	/* UNICODE */
#endif	/* defined(USE_386_ASM_MMX_FPUTS_SAFE) && defined(USE_386_ASM_FPUTS_FIX1) */

	/* Set up the stack for the params. */
	__asm__ ( " subl $8, %esp " );

#if	defined(USE_386_ASM_MMX_FPUTS_SAFE) && defined(USE_386_ASM_FPUTS_FIX1)
	/* Put param 1 onto the stack. */
	__asm__ ( " movd %mm6, 4(%esp) " );
#else	/* not defined(USE_386_ASM_MMX_FPUTS_SAFE) && defined(USE_386_ASM_FPUTS_FIX1) */
#ifdef	UNICODE
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 128(%eax), %eax " );
#else	/* UNICODE */
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 120(%eax), %eax " );
#endif	/* UNICODE */
	/* and over to the stack. */
	__asm__ ( " movl %eax, 4(%esp) " );
#endif	/* not defined(USE_386_ASM_MMX_FPUTS_SAFE) && defined(USE_386_ASM_FPUTS_FIX1) */

	/* Move the buffer to eax. */
	__asm__ ( " movl (%ecx), %eax " );
	/* and over to the stack. */
	__asm__ ( " movl %eax, (%esp) " );

#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Get our private section of local variables. */
	__asm__ ( " movl 8(%ebp), %eax " );
#ifdef	UNICODE
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 128(%eax), %ecx " );
#else	/* UNICODE */
	/* Move a section of memory that contains the FILE *. */
	__asm__ ( " movl 120(%eax), %ecx " );
#endif	/* UNICODE */
	/* Test to see if %ecx is NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If it isn't, resume. */
	__asm__ ( " jne .TekFileASCIIBare_WriteLine_internalchkpass " );

	/* Set return value appropriately. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Return to caller. */
	__asm__ ( " jmp .TekFileASCIIBare_WriteLine_ret2 " );

	/* Used to bypass error set. */
	__asm__ ( " .TekFileASCIIBare_WriteLine_internalchkpass: " );
#endif	/* not NO_INTERNAL_NULL_CHECKS */

	/* Call fputs(). */
	__asm__ ( " call fputs " );

	/* Check for an error. */
	__asm__ ( " cmpl %1, %%eax " : "=m" (_tfbtmp) : "i" (EOF) );
	__asm__ ( " jne .TekFileASCIIBare_WriteLine_terminate " );

	__asm__ ( " .TekFileASCIIBare_WriteLine_checkerrno: " );

	/* Get the errno. */
	__asm__ ( " movl %0, %%eax " : "=m" (errno) );

	/* Check to see what the errno was. */
	__asm__ ( " cmpl %1, %%eax " : "=m" (_tfbtmp) : "i" (EPIPE) );
	__asm__ ( " je .TekFileASCIIBare_WriteLine_EPIPE " );
	__asm__ ( " cmpl %1, %%eax " : "=m" (_tfbtmp) : "i" (ENOSPC) );
	__asm__ ( " je .TekFileASCIIBare_WriteLine_EPIPE " );
	__asm__ ( " cmpl %1, %%eax " : "=m" (_tfbtmp) : "i" (EBADF) );
	__asm__ ( " je .TekFileASCIIBare_WriteLine_EBADF " );

	/* Process the error code appropriately. */
	__asm__ ( " .TekFileASCIIBare_WriteLine_EIO: " );
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_IO) );
	__asm__ ( " je .TekFileASCIIBare_WriteLine_ret2 " );

	__asm__ ( " .TekFileASCIIBare_WriteLine_EPIPE: " );
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_PIPE) );
	__asm__ ( " je .TekFileASCIIBare_WriteLine_ret2 " );

	__asm__ ( " .TekFileASCIIBare_WriteLine_ENOSPC: " );
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_DISKFULL) );
	__asm__ ( " je .TekFileASCIIBare_WriteLine_ret2 " );

	__asm__ ( " .TekFileASCIIBare_WriteLine_EBADF: " );
	/* Test to see if the file was opened read-only. */
	__asm__ ( " testl %1, %1 " : "=m" (_tfbtmp) : "r" (this->PrivFileMode) );
	/* If not, this is an I/O error. */
	__asm__ ( " jne .TekFileASCIIBare_WriteLine_EIO " );
	/* Set %eax to TEKERR_FILE_READONLY. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_READONLY) );
	__asm__ ( " je .TekFileASCIIBare_WriteLine_ret2 " );

	/* This label is used to bypass error return area. */
	__asm__ ( " .TekFileASCIIBare_WriteLine_terminate: " );

	/* Terminate the line. */
#ifdef	USE_386_ASM_FPUTS_FIX1
	/* Put param 1 onto the stack. */
#ifdef	USE_386_ASM_MMX_FPUTS_SAFE
	__asm__ ( " movd %mm6, 4(%esp) " );
	__asm__ ( " emms " );
#else	/* USE_386_ASM_MMX_FPUTS_SAFE */
	__asm__ ( " movl %1, 4(%%esp) "
	 : "=m" (_tfbtmp)
	 : "r" (this->PrivFileDesc)
	);
#endif	/* USE_386_ASM_MMX_FPUTS_SAFE */
#endif	/* USE_386_ASM_FPUTS_FIX1 */
#ifdef	TEKLTI_WRITELINE_CRLF
	/* Move the buffer to param 0. */
	__asm__ ( " movl %1, (%%esp) " : "=m" (_tfbtmp) : "X" (tekfileasciibare_writeline_crlf) );
	/* Call fputs(). */
	__asm__ ( " call fputs " );
#else	/* not TEKLTI_WRITELINE_CRLF */
	/* Move the buffer to param 0. */
	__asm__ ( " movl $10, (%esp) " );
	/* Call fputc(). */
	__asm__ ( " call fputc " );
#endif	/* not TEKLTI_WRITELINE_CRLF */

	/* Check for an error. */
	__asm__ ( " cmpl %1, %%eax " : "=m" (_tfbtmp) : "i" (EOF) );
	__asm__ ( " je .TekFileASCIIBare_WriteLine_checkerrno " );

	TEKLTI_RETVAL_TEKERR_OK

	__asm__ ( " .TekFileASCIIBare_WriteLine_ret2: " );

	/* Restore the stack. */
	__asm__ ( " addl $8, %esp " );

	__asm__ ( " .TekFileASCIIBare_WriteLine_ret: " );
}

/**
    \fn TekFileASCIIBare::get_FILE(FILE ** FileDescriptor)
    
    Obtains the handle used to access the open file.
 */
TEKERR TekFileASCIIBare::get_FILE(FILE ** FileDescriptor)
{
#ifndef	NO_SIZE_T_CHECKS
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Get the value of eax. */
	__asm__ ( " movl %0, %%esi " : "=m" (FileDescriptor) );
	/* Test to see if it is null. */
	__asm__ ( " testl %esi, %esi " );
	/* Set the worst-case scenario for return. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_POINTER) );
	/* If NULL, go to PointerFail. */
	__asm__ ( " je .TekFileASCIIBare_get_FILE_PointerFail " );
#endif	/* not NO_SIZE_T_CHECKS */

#ifdef	NO_SIZE_T_CHECKS
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Get the file pointer if we haven't yet retrieved it. */
	__asm__ ( " movl %0, %%esi " : "=m" (FileDescriptor) );
#endif	/* NO_SIZE_T_CHECKS */

	/* Put the PrivTekFileType into the ecx register. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileDesc) );
	/* And then into *FileTypePointer. */
	__asm__ ( " movl %ecx, (%esi) " );
	/* Set return value to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK
#ifndef	NO_SIZE_T_CHECKS
	__asm__ ( " .TekFileASCIIBare_get_FILE_PointerFail: " );
#endif	/* not NO_SIZE_T_CHECKS */

#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " popl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
}


/**
    \fn TekFileASCIIBare::get_Filename(uchar_t ** Name)
    
    Obtains the filename in the form of a uchar.
 */
TEKERR TekFileASCIIBare::get_Filename(uchar_t ** Name)
{
#ifndef	NO_SIZE_T_CHECKS
	/* Put FileDescriptor into the eax register. */
	__asm__ ( " movl %0, %%eax " : "=m" (Name) );
	/* Test to see if Name == NULL */
	__asm__ ( " testl %eax, %eax " );
	/* If Name == NULL, there's nothing to do. */
	__asm__ ( " jne .TekFileASCIIBare_get_Filename_getstr " );

	/* Set retval to TEKERR_POINTER. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_POINTER) );
	/* Jump to fatal return. */
	__asm__ ( " jmp .TekFileASCIIBare_get_Filename_fatal " );

	/* Label for continuing on. */
	__asm__ ( " .TekFileASCIIBare_get_Filename_getstr: " );
#endif	/* not NO_SIZE_T_CHECKS */

#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	__asm__ ( " movl %0, %%esi " : "=m" (this->PrivFileName.uchar_t_ascii) );

#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Make sure it isn't NULL. */
	__asm__ ( " testl %esi, %esi " );
	/* If it isn't, start scanning. */
	__asm__ ( " jne .TekFileASCIIBare_get_Filename_scas " );

	/* Set retval to TEKERR_SEQUENCE. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Jump to fatal return. */
	__asm__ ( " jmp .TekFileASCIIBare_get_Filename_fatal2 " );

	/* If uchar_t_ascii was not NULL, we should be here. */
	__asm__ ( " .TekFileASCIIBare_get_Filename_scas: " );
#endif	/* not NO_INTERNAL_NULL_CHECKS */

#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %edi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Copy it to edi. */
	__asm__ ( " movl %esi, %edi " );

	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "i" (PATH_MAX) );
	/* Put null character into al. */
	__asm__ ( " xorb %al, %al " );
	/* Set direction flag to forwards. */
	__asm__ ( " cld " );
	/* And look for the first null character. */
	__asm__ ( " repne scasb " );

	/* Negate ecx. */
	__asm__ ( " negl %ecx " );
	/* Add PATH_MAX to get the final result. */
	__asm__ ( " addl %1, %%ecx " : "=m" (_tfbtmp) : "i" (PATH_MAX) );

	/* Make sure esi is saved. */
	__asm__ ( " pushl %esi " );
#ifdef	USE_386_ASM_MALLOC_FIX1
	/* We are directed by macros to put ecx in eax prior to saving eax, */
	/* probably to work around a malloc() bug. */
	__asm__ ( " movl %ecx, %eax " );
#endif	/* USE_386_ASM_MALLOC_FIX1 */
	/* Push ecx onto the stack. */
	__asm__ ( " pushl %ecx " );
#ifdef	USE_386_ASM_MALLOC_FIX1
	/* To complete the pre-call workaround, set up a blank parameter. */
	__asm__ ( " subl $4, %esp " );
	/* Then copy eax into the parameter. */
	__asm__ ( " movl %eax, (%esp) " );
#endif	/* USE_386_ASM_MALLOC_FIX1 */
	/* Call malloc(). */
	__asm__ ( " call malloc " );
#ifdef	USE_386_ASM_MALLOC_FIX1
	/* Restore the stack if the workaround is compiled by macros. */
	__asm__ ( " addl $4, %esp " );
#endif	/* USE_386_ASM_MALLOC_FIX1 */

	/* Is malloc() == NULL? */
	__asm__ ( " testl %eax, %eax " );
	/* If not, continue on. */
	__asm__ ( " jne .TekFileASCIIBare_get_Filename_mkucharstruct " );

	/* malloc() returned NULL if we're here instead. */
	/* Set the error code. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_MEMORY) );
	/* Pop esi and ecx. */
	__asm__ ( " popl %ecx " );
	__asm__ ( " popl %esi " );
	/* Go to fatal return. */
	__asm__ ( " jmp .TekFileASCIIBare_get_Filename_fatal3 " );

	/* Process string label. */
	__asm__ ( " .TekFileASCIIBare_get_Filename_mkucharstruct: " );
	/* Put malloc's result into edi. */
	__asm__ ( " movl %eax, %edi " );

	/* Put new count into esp. */
	/* Call malloc, while making sure edi is saved. */
	__asm__ ( " pushl %edi " );
	/* Make space for our parameter, or edi will be overwritten. */
	__asm__ ( " subl $4, %esp " );
	/* Set up param 0 with intermediate value 8. */
	__asm__ ( " movl $8, (%esp) " );
	/* Call malloc. */
	__asm__ ( " call malloc " );
	__asm__ ( " addl $4, %esp " );
	__asm__ ( " popl %edi " );
	/* Restore the pointers we saved above. */
	__asm__ ( " popl %ecx " );
	__asm__ ( " popl %esi " );
	/* Is malloc() == NULL? */
	__asm__ ( " testl %eax, %eax " );
	/* If not, continue on. */
	__asm__ ( " jne .TekFileASCIIBare_get_Filename_finish " );

	/* Set up esp for free(). */
	__asm__ ( " movl %edi, (%esp) " );
	/* Call free(). */
	__asm__ ( " call free " );
	/* Set the error code. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_MEMORY) );
	/* Go to fatal return. */
	__asm__ ( " jmp .TekFileASCIIBare_get_Filename_fatal2 " );

	/* Jump that executes all final code. */
	__asm__ ( " .TekFileASCIIBare_get_Filename_finish: " );
	/* Copy edi register to new Name->uchar_t_ascii. */
	__asm__ ( " movl %edi, (%eax) " );
	/* Copy value of ecx to new Name->uchar_t_asciilen. */
	__asm__ ( " movl %ecx, 4(%eax) " );

#ifdef	USE_386_ASM_MALLOC_FIX2
	/* malloc() calls std and leaves direction flag set, so... */
	/* Clear the direction flag again - malloc() may have reset it. */
	__asm__ ( " cld " );
#endif	/* USE_386_ASM_MALLOC_FIX2 */
	/* We can finally copy ecx characters from esi to edi! */
	__asm__ ( " rep movsb " );

	/* Last, but not least, we have to hand over the pointer. */
	/* Get the pointer (again). */
	__asm__ ( " movl %0, %%ecx " : "=m" (Name) );
	/* Copy eax to ecx. */
	__asm__ ( " movl %eax, (%ecx) " );

	/* Set return value to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK

	/* Used for fatal returns. */
	__asm__ ( " .TekFileASCIIBare_get_Filename_fatal3: " );
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " popl %edi " );
#endif	/* USE_386_ASM_PUSHPOP */
	__asm__ ( " .TekFileASCIIBare_get_Filename_fatal2: " );
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " popl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	__asm__ ( " .TekFileASCIIBare_get_Filename_fatal: " );
}


/**
    \fn TekFileASCIIBare::put_FILE(FILE * FileDescriptor)
    
    Sets the handle used to access a file.\n
    \n
    WARNING!!!!!  DO NOT USE THE FILE DESCRIPTOR YOU PASS IN \n
    TO THIS FUNCTION UNLESS YOU HAVE RE-RETRIEVED IT USING \n
    TekFileASCIIBare::get_FILE()!  Utilizing the descriptor in a direct fashion after a \n
    successful call to put_FILE() will result in undefined results!!!!!
 */
TEKERR TekFileASCIIBare::put_FILE(FILE * FileDescriptor)
{
	/* Put FileDescriptor into the ecx register. */
	__asm__ ( " movl %0, %%ecx " : "=m" (FileDescriptor) );
	/* And then into the PrivTekFileType. */
	__asm__ ( " movl %%ecx, %0 " : "=m" (this->PrivFileDesc) );

	/* Set return value to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK
}


/**
    \fn TekFileASCIIBare::put_Filename(uchar_t * Name)
    
    Sets the filename to access.
 */
TEKERR TekFileASCIIBare::put_Filename(uchar_t * Name)
{
/* Put FileDescriptor into the eax register. */
	__asm__ ( " movl %0, %%eax " : "=m" (Name) );
	/* Test to see if Name == NULL */
	__asm__ ( " testl %eax, %eax " );
	/* If Name == NULL, there's nothing to do. */
	__asm__ ( " je .TekFileASCIIBare_put_Filename_donothing " );

	/* Put file name pointer into esi, pushing if defined to do so. */
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	__asm__ ( " movl (%eax), %esi " );

#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %edi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Copy esi into edi; scasb uses edi, not esi. */
	__asm__ ( " movl %esi, %edi " );
	/* Put PATH_MAX into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "i" (PATH_MAX) );
	/* Put null character into al. */
	__asm__ ( " xorb %al, %al " );
	/* Set direction flag to forwards. */
	__asm__ ( " cld " );
	/* And look for the first null character. */
	__asm__ ( " repne scasb " );
	/* If found, call malloc. */
	__asm__ ( " je .TekFileASCIIBare_put_Filename_malloc " );

	/* If we get here, there was no null character within PATH_MAX bytes */
	/* Set return value. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Go to fatal error. */
	__asm__ ( " jmp .TekFileASCIIBare_put_Filename_fatal " );

	__asm__ ( " .TekFileASCIIBare_put_Filename_malloc: " );
	/* Negate ecx. */
	__asm__ ( " negl %ecx " );
	/* Add PATH_MAX to get the final result. */
	__asm__ ( " addl %1, %%ecx " : "=m" (_tfbtmp) : "i" (PATH_MAX) );

#ifdef	USE_386_ASM_MALLOC_FIX3
	/* Make sure esi is saved. */
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_MALLOC_FIX3 */

#ifdef	USE_386_ASM_MALLOC_FIX1
	/* We are directed by macros to put ecx in eax prior to saving eax, */
	/* probably to work around a malloc() bug. */
	__asm__ ( " movl %ecx, %eax " );
#endif	/* USE_386_ASM_MALLOC_FIX1 */
	/* Push ecx onto the stack. */
	__asm__ ( " pushl %ecx " );
#ifdef	USE_386_ASM_MALLOC_FIX1
	/* To complete the pre-call workaround, set up a blank parameter. */
	__asm__ ( " subl $4, %esp " );
	/* Then copy eax into the parameter. */
	__asm__ ( " movl %eax, (%esp) " );
#endif	/* USE_386_ASM_MALLOC_FIX1 */
	/* Call malloc(). */
	__asm__ ( " call malloc " );
#ifdef	USE_386_ASM_MALLOC_FIX1
	/* Restore the stack if the workaround is compiled by macros. */
	__asm__ ( " addl $4, %esp " );
#endif	/* USE_386_ASM_MALLOC_FIX1 */

	/* Restore esi and ecx. */
	__asm__ ( " popl %ecx " );
#ifdef	USE_386_ASM_MALLOC_FIX3
	__asm__ ( " popl %esi " );
#endif	/* USE_386_ASM_MALLOC_FIX3 */

	/* Is malloc() == NULL? */
	__asm__ ( " testl %eax, %eax " );
	/* If not, continue on. */
	__asm__ ( " jne .TekFileASCIIBare_put_Filename_proc " );
	/* Set the error code. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_MEMORY) );
	/* Go to fatal return. */
	__asm__ ( " jmp .TekFileASCIIBare_put_Filename_fatal " );

	/* Process string label. */
	__asm__ ( " .TekFileASCIIBare_put_Filename_proc: " );

	/* Move dest string to edi. */
	__asm__ ( " movl %eax, %edi " );
#ifdef	USE_386_ASM_MALLOC_FIX2
	/* malloc() calls std and leaves direction flag set, so... */
	/* Clear the direction flag again - malloc() may have reset it. */
	__asm__ ( " cld " );
#endif	/* USE_386_ASM_MALLOC_FIX2 */
	/* And copy it. */
	__asm__ ( " rep movsb " );
	/* Get the pointer to the instance's variables. */
	__asm__ ( " movl 8(%ebp), %ecx " );
	/* Move result to PrivTekFileName. */
	__asm__ ( " movl %eax, 112(%ecx) " );

	/* Used for do-nothing returns. */
	__asm__ ( " .TekFileASCIIBare_put_Filename_ret: " );
	/* Set the return value to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK

	/* Used for error returns. */
	__asm__ ( " .TekFileASCIIBare_put_Filename_fatal: " );

	/* Clean up - pointer, then stack. */
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " addl $8, %esp " );
#endif	/* USE_386_ASM_PUSHPOP */

	__asm__ ( " .TekFileASCIIBare_put_Filename_donothing: " );
}


/*!
    \fn TekFileASCIIBare::get_Type(TekFileType * FileTypePointer)
    
    Gets the file type.
 */
TEKERR TekFileASCIIBare::get_Type(TekFileType * FileTypePointer)
{
#ifndef	NO_SIZE_T_CHECKS
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Get the value of eax. */
	__asm__ ( " movl %0, %%esi " : "=m" (FileTypePointer) );
	/* Test to see if it is null. */
	__asm__ ( " testl %esi, %esi " );
	/* Set the worst-case scenario for return. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_POINTER) );
	/* If NULL, go to PointerFail. */
	__asm__ ( " je .TekFileASCIIBare_get_Type_PointerFail " );
#endif	/* not NO_SIZE_T_CHECKS */

#ifdef	NO_SIZE_T_CHECKS
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Get the file pointer if we haven't yet retrieved it. */
	__asm__ ( " movl %0, %%esi " : "=m" (FileTypePointer) );
#endif	/* NO_SIZE_T_CHECKS */

	/* Put the PrivTekFileType into the ecx register. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivTekFileType) );
	/* And then into *FileTypePointer. */
	__asm__ ( " movl %ecx, (%esi) " );
	/* Set return value to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK
#ifndef	NO_SIZE_T_CHECKS
	__asm__ ( " .TekFileASCIIBare_get_Type_PointerFail: " );
#endif	/* not NO_SIZE_T_CHECKS */

#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " popl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
}


/*!
    \fn TekFileASCIIBare::Close()
    
    Closes the file.
 */
TEKERR TekFileASCIIBare::Close()
{
	/* First, let's get the value of PrivFileDesc. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileDesc) );
#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Test to see if it is not zero. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If it isn't, close the descriptor. */
	__asm__ ( " jne .TekFileASCIIBare_Close_close " );
	/* Otherwise, set retval to TEKERR_SEQUENCE. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Goto fatal error. */
	__asm__ ( " jmp .TekFileASCIIBare_Close_fatal " );

	/* Label for closing the descriptor. */
	__asm__ ( " .TekFileASCIIBare_Close_close: " );
#endif	/* not NO_INTERNAL_NULL_CHECKS */

	/* Prepare to close the descriptor. */
	__asm__ ( " pushl %ecx " );
	/* Call fclose(). */
	__asm__ ( " call fclose " );
	/* Throw out the pointer. */
	__asm__ ( " addl $4, %esp " );

	/* Check to see if eax is zero. */
	__asm__ ( " testl %eax, %eax " );
	/* If it is, fclose() was successful. */
	__asm__ ( " je .TekFileASCIIBare_Close_done " );

	/* fclose() was not successful if we're here. */
	/* So, get value of errno. */
	__asm__ ( " movl %0, %%ecx " : "=m" (errno) );
	/* Perform a comparison for ENOSPC (disk full error) */
	__asm__ ( " cmpl %1, %%ecx " : "=m" (_tfbtmp) : "i" (ENOSPC) );
	/* Jump if ENOSPC is the error. */
	__asm__ ( " je .TekFileASCIIBare_Close_DiskFull " );
	/* Perform a comparison for EIO (device input/output error) */
	__asm__ ( " cmpl %1, %%ecx " : "=m" (_tfbtmp) : "i" (EIO) );
	/* Jump if EIO is the error. */
	__asm__ ( " je .TekFileASCIIBare_Close_IO " );
	/* Perform a comparison for EPIPE (pipe broken error) */
	__asm__ ( " cmpl %1, %%ecx " : "=m" (_tfbtmp) : "i" (EPIPE) );
	/* Jump if EIO is the error. */
	__asm__ ( " je .TekFileASCIIBare_Close_Pipe " );
	/* All other errors will be returned as TEKERR_UNEXPECTED. */

	/* For setting TEKERR_UNEXPECTED */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_UNEXPECTED) );
	__asm__ ( " jmp .TekFileASCIIBare_Close_fatal " );
	/* For setting TEKERR_FILE_DISKFULL */
	__asm__ ( " .TekFileASCIIBare_Close_DiskFull: " );
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_DISKFULL) );
	__asm__ ( " jmp .TekFileASCIIBare_Close_fatal " );
	/* For setting TEKERR_FILE_IO */
	__asm__ ( " .TekFileASCIIBare_Close_IO: " );
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_IO) );
	__asm__ ( " jmp .TekFileASCIIBare_Close_fatal " );
	/* For setting TEKERR_FILE_PIPE */
	__asm__ ( " .TekFileASCIIBare_Close_Pipe: " );
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_PIPE) );
	__asm__ ( " jmp .TekFileASCIIBare_Close_fatal " );

	/* We should now be here if fclose() was successful. */
	__asm__ ( " .TekFileASCIIBare_Close_done: " );
	/* NULLify the descriptor; it's no longer valid. */
	__asm__ ( " movl $0, %0 " : "=m" (this->PrivFileDesc) );
	/* Set return value to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK

	/* Used for fatal returns. */
	__asm__ ( " .TekFileASCIIBare_Close_fatal: " );
}


/*!
    \fn TekFileASCIIBare::get_Mode(TekFileMode * ModeID)
    
    Retrieves the mode currently set.
 */
TEKERR TekFileASCIIBare::get_Mode(TekFileMode * ModeID)
{
#ifndef	NO_SIZE_T_CHECKS
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Get the value of eax. */
	__asm__ ( " movl %0, %%esi " : "=m" (ModeID) );
	/* Test to see if it is null. */
	__asm__ ( " testl %esi, %esi " );
	/* Set the worst-case scenario for return. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_POINTER) );
	/* If NULL, go to PointerFail. */
	__asm__ ( " je .TekFileASCIIBare_get_Mode_PointerFail " );
#endif	/* not NO_SIZE_T_CHECKS */

#ifdef	NO_SIZE_T_CHECKS
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Get the file pointer if we haven't yet retrieved it. */
	__asm__ ( " movl %0, %%esi " : "=m" (ModeID) );
#endif	/* NO_SIZE_T_CHECKS */

	/* Put the PrivTekFileType into the ecx register. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileMode) );
	/* And then into *FileTypePointer. */
	__asm__ ( " movl %ecx, (%esi) " );
	/* Set return value to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK
#ifndef	NO_SIZE_T_CHECKS
	__asm__ ( " .TekFileASCIIBare_get_Mode_PointerFail: " );
#endif	/* not NO_SIZE_T_CHECKS */

#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " popl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
}


/*!
    \fn TekFileASCIIBare::Flush()
    
    Flushes the buffer.
 */
TEKERR TekFileASCIIBare::Flush()
{
	/* First, let's get the value of PrivFileDesc. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileDesc) );
#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Test to see if it is not zero. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If it isn't, flush the descriptor. */
	__asm__ ( " jne .TekFileASCIIBare_Flush_flush " );
	/* Otherwise, set retval to TEKERR_SEQUENCE. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Goto fatal error. */
	__asm__ ( " jmp .TekFileASCIIBare_Flush_fatal " );
#endif	/* not NO_INTERNAL_NULL_CHECKS */

	/* Label for closing the descriptor. */
	__asm__ ( " .TekFileASCIIBare_Flush_flush: " );
	/* Prepare to close the descriptor. */
	__asm__ ( " pushl %ecx " );
	/* Call fflush(). */
	__asm__ ( " call fflush " );
	/* Throw out the parameter. */
	__asm__ ( " addl $4, %esp " );

	/* Check to see if eax is zero. */
	__asm__ ( " testl %eax, %eax " );
	/* If it is, fflush() was successful. */
	__asm__ ( " je .TekFileASCIIBare_Flush_done " );

	/* fflush() was not successful if we're here. */
	/* So, get value of errno. */
	__asm__ ( " movl %0, %%ecx " : "=m" (errno) );
	/* Perform a comparison for ENOSPC (disk full error) */
	__asm__ ( " cmpl %1, %%ecx " : "=m" (_tfbtmp) : "i" (ENOSPC) );
	/* Jump if ENOSPC is the error. */
	__asm__ ( " je .TekFileASCIIBare_Flush_DiskFull " );
	/* Perform a comparison for EIO (device input/output error) */
	__asm__ ( " cmpl %1, %%ecx " : "=m" (_tfbtmp) : "i" (EIO) );
	/* Jump if EIO is the error. */
	__asm__ ( " je .TekFileASCIIBare_Flush_IO " );
	/* Perform a comparison for EPIPE (pipe broken error) */
	__asm__ ( " cmpl %1, %%ecx " : "=m" (_tfbtmp) : "i" (EPIPE) );
	/* Jump if EIO is the error. */
	__asm__ ( " je .TekFileASCIIBare_Flush_Pipe " );
	/* All other errors will be returned as TEKERR_UNEXPECTED. */

	/* For setting TEKERR_UNEXPECTED */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_UNEXPECTED) );
	__asm__ ( " jmp .TekFileASCIIBare_Flush_fatal " );
	/* For setting TEKERR_FILE_DISKFULL */
	__asm__ ( " .TekFileASCIIBare_Flush_DiskFull: " );
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_DISKFULL) );
	__asm__ ( " jmp .TekFileASCIIBare_Flush_fatal " );
	/* For setting TEKERR_FILE_IO */
	__asm__ ( " .TekFileASCIIBare_Flush_IO: " );
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_IO) );
	__asm__ ( " jmp .TekFileASCIIBare_Flush_fatal " );
	/* For setting TEKERR_FILE_PIPE */
	__asm__ ( " .TekFileASCIIBare_Flush_Pipe: " );
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_PIPE) );
	__asm__ ( " jmp .TekFileASCIIBare_Flush_fatal " );

	/* We should now be here if fclose() was successful. */
	__asm__ ( " .TekFileASCIIBare_Flush_done: " );
#if	TEKERR_OK != 0x00000000
	/* If TEKERR_OK is set to something non-standard, reset eax. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_OK) );
#endif	/* TEKERR_OK != 0x00000000 */

	/* Used for fatal returns. */
	__asm__ ( " .TekFileASCIIBare_Flush_fatal: " );
}


/*!
    \fn TekFileASCIIBare::Open()
    
    Open the file.
 */
TEKERR TekFileASCIIBare::Open()
{
	#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Make sure this instance does not have a file already open. */
	/* Grab the PrivFileDesc. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileDesc) );
	/* Test to see if it is NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If PrivFileDesc != NULL, go to step 2. */
	__asm__ ( " je .TekFileASCIIBare_Open_RetrieveFilename " );

	/* If PrivFileDesc == NULL, report the error to eax. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Jump to the end of this function for cleanup. */
	__asm__ ( " jmp .TekFileASCIIBare_Open_fatal " );

	/* Second, we need a file name to use. */
	__asm__ ( " .TekFileASCIIBare_Open_RetrieveFilename: " );
#endif	/* not NO_INTERNAL_NULL_CHECKS */
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Grab the filename from this->PrivFileName.uchar_t_ascii. */
	__asm__ ( " movl %0, %%esi " : "=m" (this->PrivFileName.uchar_t_ascii) );
	/* Test to see if it is NULL. */
	__asm__ ( " testl %esi, %esi " );
	/* If PrivFileDesc != NULL, go to step 2. */
	__asm__ ( " jne .TekFileASCIIBare_Open_DetermineParam " );

#ifdef	USE_386_ASM_PUSHPOP
	/* We really don't need esi at all. */
	__asm__ ( " popl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* If PrivFileName.uchar_t_ascii == NULL, report the error to eax. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Jump to the end of this function for cleanup. */
	__asm__ ( " jmp .TekFileASCIIBare_Open_fatal " );

	/* We should be here if the preliminary tests above passed. */
	__asm__ ( " .TekFileASCIIBare_Open_DetermineParam: " );
	/* Figure out what fopen() op are going to do. */
	/* We need to pull the PrivFileMode value first. */
	__asm__ ( " movw %0, %%cx " : "=m" (this->PrivFileMode) );

	/* Third, let's see what mode we will run fopen() on. */
	__asm__ ( " bt $2, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open_ReadWrite " );
	__asm__ ( " bt $3, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open_ReadWriteTrunc " );
	__asm__ ( " bt $0, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open_WriteOnly " );
	__asm__ ( " bt $1, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open_Append " );
	__asm__ ( " bt $4, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open_ReadAppend " );

	/* If we are here, ReadOnly was set. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_ReadOnly) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open_fopen " );

	/* Now, to insert a string parameter for param 1 of fopen(). */
	/* --- FOR MODE WRITEONLY --- */
	__asm__ ( " .TekFileASCIIBare_Open_WriteOnly: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_WriteOnly) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open_fopen " );

	/* --- FOR MODE APPEND --- */
	__asm__ ( " .TekFileASCIIBare_Open_Append: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_Append) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open_fopen " );

	/* --- FOR MODE READWRITE --- */
	__asm__ ( " .TekFileASCIIBare_Open_ReadWrite: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_ReadWrite) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open_fopen " );

	/* --- FOR MODE READWRITETRUNC --- */
	__asm__ ( " .TekFileASCIIBare_Open_ReadWriteTrunc: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_ReadWriteTrunc) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open_fopen " );

	/* --- FOR MODE APPEND --- */
	__asm__ ( " .TekFileASCIIBare_Open_ReadAppend: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_ReadAppend) );

	__asm__ ( " .TekFileASCIIBare_Open_fopen: " );
	/* Push param 1 onto the stack first. */
	__asm__ ( " pushl %ecx " );
	/* Now push param 0 onto the stack. */
	__asm__ ( " pushl %esi " );
	/* Call fopen(). */
	__asm__ ( " call fopen " );
	/* Restore the stack pointer. */
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " addl $12, %esp " );
#else
	__asm__ ( " addl $8, %esp " );
#endif	/* USE_386_ASM_PUSHPOP */

	/* Test the return value. */
	__asm__ ( " testl %eax, %eax " );
	/* Did fopen() fail? */
	__asm__ ( " jne .TekFileASCIIBare_Open_finish " );

	/* If we get here, fopen() has failed. */
	/* Set our retval to TEKERR_FAIL. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FAIL) );
	/* Do a failure cleanup. */
	__asm__ ( " jmp .TekFileASCIIBare_Open_fatal " );

	/* If fopen() != NULL, we should be here. */
	__asm__ ( " .TekFileASCIIBare_Open_finish: " );
	/* Finally, move the result to our PrivFileDesc. */
	__asm__ ( " movl 8(%ebp), %ecx " );
	/* Move result to PrivFileDesc. */
#ifdef	UNICODE
	__asm__ ( " movl %eax, 128(%ecx) " );
#else	/* not UNICODE */
	__asm__ ( " movl %eax, 120(%ecx) " );
#endif	/* not UNICODE */

	/* Set retval to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK

	/* Used for fatal returns. */
	__asm__ ( " .TekFileASCIIBare_Open_fatal: " );
}


/*!
    \fn TekFileASCIIBare::Open64()
    
    Open the file using 64 bit semantics.
 */
TEKERR TekFileASCIIBare::Open64()
{
#ifdef	OPEN64_NOT_SUPPORTED
	return TEKERR_NOTIMPL;
#else	/* OPEN64_NOT_SUPPORTED */
#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Make sure this instance does not have a file already open. */
	/* Grab the PrivFileDesc. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileDesc) );
	/* Test to see if it is NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If PrivFileDesc != NULL, go to step 2. */
	__asm__ ( " je .TekFileASCIIBare_Open64_RetrieveFilename " );

	/* If PrivFileDesc == NULL, report the error to eax. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Jump to the end of this function for cleanup. */
	__asm__ ( " jmp .TekFileASCIIBare_Open64_fatal " );

	/* Second, we need a file name to use. */
	__asm__ ( " .TekFileASCIIBare_Open64_RetrieveFilename: " );
#endif	/* not NO_INTERNAL_NULL_CHECKS */
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Grab the filename from this->PrivFileName.uchar_t_ascii. */
	__asm__ ( " movl %0, %%esi " : "=m" (this->PrivFileName.uchar_t_ascii) );
	/* Test to see if it is NULL. */
	__asm__ ( " testl %esi, %esi " );
	/* If PrivFileDesc != NULL, go to step 2. */
	__asm__ ( " jne .TekFileASCIIBare_Open64_DetermineParam " );

	/* If PrivFileName.uchar_t_ascii == NULL, report the error to eax. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Jump to the end of this function for cleanup. */
	__asm__ ( " jmp .TekFileASCIIBare_Open64_fatal " );

	/* We should be here if the preliminary tests above passed. */
	__asm__ ( " .TekFileASCIIBare_Open64_DetermineParam: " );
	/* Figure out what fopen() op are going to do. */
	/* We need to pull the PrivFileMode value first. */
	__asm__ ( " movw %0, %%cx " : "=m" (this->PrivFileMode) );

	/* Third, let's see what mode we will run fopen() on. */
	__asm__ ( " bt $2, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open64_ReadWrite " );
	__asm__ ( " bt $3, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open64_ReadWriteTrunc " );
	__asm__ ( " bt $0, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open64_WriteOnly " );
	__asm__ ( " bt $1, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open64_Append " );
	__asm__ ( " bt $4, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Open64_ReadAppend " );

	/* If we are here, ReadOnly was set. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_ReadOnly) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open64_fopen " );

	/* Now, to insert a string parameter for param 1 of fopen(). */
	/* --- FOR MODE WRITEONLY --- */
	__asm__ ( " .TekFileASCIIBare_Open64_WriteOnly: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_WriteOnly) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open64_fopen " );

	/* --- FOR MODE APPEND --- */
	__asm__ ( " .TekFileASCIIBare_Open64_Append: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_Append) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open64_fopen " );

	/* --- FOR MODE READWRITE --- */
	__asm__ ( " .TekFileASCIIBare_Open64_ReadWrite: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_ReadWrite) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open64_fopen " );

	/* --- FOR MODE READWRITETRUNC --- */
	__asm__ ( " .TekFileASCIIBare_Open64_ReadWriteTrunc: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_ReadWriteTrunc) );
	/* Jump to the fopen calling area. */
	__asm__ ( " jmp .TekFileASCIIBare_Open64_fopen " );

	/* --- FOR MODE APPEND --- */
	__asm__ ( " .TekFileASCIIBare_Open64_ReadAppend: " );
	/* Insert the string into ecx. */
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "X" (TekFileASCIIBare_ReadAppend) );

	__asm__ ( " .TekFileASCIIBare_Open64_fopen: " );
	/* Push param 1 onto the stack first. */
	__asm__ ( " pushl %ecx " );
	/* Now push param 0 onto the stack. */
	__asm__ ( " pushl %esi " );
	/* Call fopen(). */
	__asm__ ( " call fopen64 " );
	/* Restore the stack pointer. */
	__asm__ ( " addl $8, %esp " );

	/* Test the return value. */
	__asm__ ( " testl %eax, %eax " );
	/* Did fopen() fail? */
	__asm__ ( " jne .TekFileASCIIBare_Open64_finish " );

	/* If we get here, fopen() has failed. */
	/* Set our retval to TEKERR_FAIL. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FAIL) );
	/* Do a failure cleanup. */
	__asm__ ( " jmp .TekFileASCIIBare_Open64_fatal2 " );

	/* If fopen() != NULL, we should be here. */
	__asm__ ( " .TekFileASCIIBare_Open64_finish: " );
	/* Finally, move the result to our PrivFileDesc. */
	__asm__ ( " movl 8(%ebp), %ecx " );
	/* Move result to PrivFileDesc. */
#ifdef	UNICODE
	__asm__ ( " movl %eax, 128(%ecx) " );
#else	/* not UNICODE */
	__asm__ ( " movl %eax, 120(%ecx) " );
#endif	/* not UNICODE */

	/* Set retval to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK

	/* Used for fatal returns where esi has already been pushed. */
	__asm__ ( " .TekFileASCIIBare_Open64_fatal2: " );
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " popl %esi " );
#endif	/* USE_386_ASM_PUSHPOP */

	/* Used for fatal returns. */
	__asm__ ( " .TekFileASCIIBare_Open64_fatal: " );
#endif	/* OPEN64_NOT_SUPPORTED */
}


/*!
    \fn TekFileASCIIBare::put_Mode(TekFileMode ModeID)
    
    Sets the mode used to open the file.
 */
TEKERR TekFileASCIIBare::put_Mode(TekFileMode ModeID)
{
#ifndef	NO_INTERNAL_NULL_CHECKS
	__asm__ ( " movl 8(%ebp), %eax ");
#ifdef	UNICODE
	__asm__ ( " movl 128(%eax), %ecx " );
#else	/* not UNICODE */
	__asm__ ( " movl 120(%eax), %ecx " );
#endif	/* not UNICODE */

	/* Make sure it isn't NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* Jump to processor if test shows esi != NULL. */
	__asm__ ( " je .TekFileASCIIBare_put_Mode_NullCheckPass " );

	/* If esi == NULL, set retval to TEKERR_SEQUENCE. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_ACCESS) );
	/* Return to caller. */
	__asm__ ( " jmp .TekFileASCIIBare_put_Mode_fatal " );

	/* Used to bypass error 1. */
	__asm__ ( " .TekFileASCIIBare_put_Mode_NullCheckPass: " );

#endif	/* not NO_INTERNAL_NULL_CHECKS */

	/* Get the value that is stored in ModeID. */
	__asm__ ( " movl %0, %%ecx " : "=m" (ModeID) );

	/* Put ModeID in this->PrivFileDesc. */
#ifdef	NO_INTERNAL_NULL_CHECKS
	__asm__ ( " movl 8(%ebp), %eax ");
#endif	/* NO_INTERNAL_NULL_CHECKS */
#ifdef	UNICODE
	__asm__ ( " movl %ecx, 132(%eax) " );
#else	/* not UNICODE */
	__asm__ ( " movl %ecx, 124(%eax) " );
#endif	/* not UNICODE */

	/* Set retval to TEKERR_OK. */
	TEKLTI_RETVAL_TEKERR_OK

#ifndef	NO_INTERNAL_NULL_CHECKS
	/* If this->PrivFileDesc was NULL, this label is jumped to. */
	__asm__ ( " .TekFileASCIIBare_put_Mode_fatal: " );
#endif	/* not NO_INTERNAL_NULL_CHECKS */
}


/*!
    \fn TekFileASCIIBare::Read64(void * Buffer, uint64_t BytesToRead, uint64_t * BytesRead)
    
    Read from the file using 64 bit semantics.
 */
TEKERR TekFileASCIIBare::Read64(void * Buffer, uint64_t BytesToRead, uint64_t * BytesRead)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileASCIIBare::Read(void * Buffer, unsigned long BytesToRead, unsigned long * BytesRead)
    
    Read from the file.
 */
TEKERR TekFileASCIIBare::Read(void * Buffer, unsigned long BytesToRead, unsigned long * BytesRead)
{
	/* Retrieve the private file descriptor. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileDesc) );

#ifdef	NO_SIZE_T_CHECKS
	/* Prepare our stack. */
	__asm__ ( " subl $16, %esp " );

	/* and put the descriptor on the stack as parameter 3. */
	__asm__ ( " movl %ecx, 12(%esp) " );

	/* Retrieve the Buffer pointer. */
	__asm__ ( " movl %0, %%eax " : "=m" (Buffer) );
#else	/* not NO_SIZE_T_CHECKS */
	/* Put the file descriptor on the stack as parameter 3. */
	__asm__ ( " pushl %ecx " );

	/* Retrieve the Buffer pointer. */
	__asm__ ( " movl %0, %%ecx " : "=m" (Buffer) );

	/* Test to see if the Buffer pointer is null. */
	__asm__ ( " testl %ecx, %ecx " );
	/* Set the worst-case scenario for return. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_POINTER) );
	/* If NULL, go to PointerFail. */
	__asm__ ( " je .TekFileASCIIBare_Read_done " );

	/* Prepare our stack. */
	__asm__ ( " subl $12, %esp " );

	/* Put the pointer to eax; we'll push it later. */
	__asm__ ( " movl %ecx, %eax " );
#endif	/* not NO_SIZE_T_CHECKS */

	/* Get the amount of bytes to read. */
	__asm__ ( " movl %0, %%ecx " : "=m" (BytesToRead) );
	/* and put it on the stack as parameter 2. */
	__asm__ ( " movl %ecx, 8(%esp) " );

	/* Put a 1 onto the stack as parameter 1. */
	__asm__ ( " movl $1, 4(%esp) " );

	/* Put the Buffer onto the stack. */
	__asm__ ( " movl %eax, (%esp) " );

	/* Finally, call fread. */
	__asm__ ( " call fread " );
	/* Clean up the stack. */
	__asm__ ( " addl $12, %esp " );

	/* Determine what happened. */
	__asm__ ( " testl %eax, %eax " );
	/* If we succeeded, we are ready to post how many characters were read. */
	__asm__ ( " jne .TekFileASCIIBare_Read_postres " );

	/* If we're here, something failed. */
	/* Call feof() to see if we reached the EOF. */
	__asm__ ( " call feof " );
	/* Check the return value. */
	__asm__ ( " testl %eax, %eax " );
	/* Set our return value for this error condition. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_EOF) );
	/* If the eof was reached, we're done. */
	__asm__ ( " jne .TekFileASCIIBare_Read_done " );

	/* If we're here, we have to process the error code. */
	__asm__ ( " movl %0, %%eax " : "=m" (errno) );

	/* Check for "broken pipe" error. */
	__asm__ ( " cmpl %1, %%eax " : "=m" (_tfbtmp) : "i" (EPIPE) );
	/* Jump as appropriate. */
	__asm__ ( " je .TekFileASCIIBare_Read_EPIPE " );

	/* Set our return value. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_IO) );
	/* We're done. */
	__asm__ ( " jmp .TekFileASCIIBare_Read_done " );

	/* Used for setting up retval on EPIPE.. */
	__asm__ ( " .TekFileASCIIBare_Read_EPIPE: " );
	/* Set our return value for this error condition. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_PIPE) );
	/* We're done. */
	__asm__ ( " jmp .TekFileASCIIBare_Read_done " );

	/* Used for setting up BytesRead. */
	__asm__ ( " .TekFileASCIIBare_Read_postres: " );
	/* Retrieve BytesRead. */
	__asm__ ( " movl %0, %%ecx " : "=m" (BytesRead) );
	/* Test to see if it is NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If it is NULL, there's nothing else to do. */
	__asm__ ( " je .TekFileASCIIBare_Read_succeeded " );

	/* Set the memory located by BytesRead to the result. */
	__asm__ ( " movl %eax, (%ecx) " );

	/* Used for returns. */
	__asm__ ( " .TekFileASCIIBare_Read_succeeded: " );
	/* Set our return value for success. */
	TEKLTI_RETVAL_TEKERR_OK

	/* Used for returns. */
	__asm__ ( " .TekFileASCIIBare_Read_done: " );
	/* Clear the file descriptor off the stack. */
	__asm__ ( " addl $4, %esp " );
}


/*!
    \fn TekFileASCIIBare::Seek64(TekFileSeek SeekWhere, int64_t NewLocation)
    
    Seek to another position of the file using 64 bit semantics.
 */
TEKERR TekFileASCIIBare::Seek64(TekFileSeek SeekWhere, int64_t NewLocation)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileASCIIBare::Seek(TekFileSeek SeekWhere, signed long NewLocation)
    
    Seek to another position of the file.
 */
TEKERR TekFileASCIIBare::Seek(TekFileSeek SeekWhere, signed long NewLocation)
{
	/* Retrieve the SeekWhere value. */
	__asm__ ( " movl %0, %%ecx " : "=m" (SeekWhere) );

#if	!((TEKFILESEEK_BEGIN == SEEK_SET) && \
(TEKFILESEEK_CURRENT == SEEK_CUR) && \
(TEKFILESEEK_END == SEEK_END))
	/* Do a series of bit tests on SeekWhere. */
	__asm__ ( " bt $0, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Seek_Cur " );
	__asm__ ( " bt $1, %cx " );
	__asm__ ( " jc .TekFileASCIIBare_Seek_End " );

	/* If we're here, SeekWhere was set to BEGIN of file. */
#if	TEKFILESEEK_BEGIN != SEEK_SET
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "i" (SEEK_SET) );
#endif	/* TEKFILESEEK_BEGIN != SEEK_SET */
	__asm__ ( " jmp .TekFileASCIIBare_Seek_Where_Resume " );

	/* If we're here, SeekWhere was set to CURRENT of file. */
	__asm__ ( " .TekFileASCIIBare_Seek_Cur: " );
#if	TEKFILESEEK_CURRENT != SEEK_CUR
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "i" (SEEK_CUR) );
#endif	/* TEKFILESEEK_CURRENT != SEEK_CUR */
	__asm__ ( " jmp .TekFileASCIIBare_Seek_Where_Resume " );

	/* If we're here, SeekWhere was set to END of file. */
	__asm__ ( " .TekFileASCIIBare_Seek_End: " );
#if	TEKFILESEEK_END != SEEK_END
	__asm__ ( " movl %1, %%ecx " : "=m" (_tfbtmp) : "i" (SEEK_END) );
#endif	/* TEKFILESEEK_CURRENT != SEEK_END */

	__asm__ ( " .TekFileASCIIBare_Seek_Where_Resume: " );
#endif	/* !((TEKFILESEEK_BEGIN == SEEK_SET) && \
(TEKFILESEEK_CURRENT == SEEK_CUR) && \
(TEKFILESEEK_END == SEEK_END)) */

	/* Push ecx (param 2 of fseek()) onto the stack. */
	__asm__ ( " pushl %ecx " );

	/* Retrieve the NewLocation value. */
	__asm__ ( " movl %0, %%ecx " : "=m" (NewLocation) );
	/* and push it onto the stack as param1 of fseek(). */
	__asm__ ( " pushl %ecx " );

	/* Retrieve the private file descriptor. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileDesc) );

#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Make sure it isn't NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* Set retval to TEKERR_SEQUENCE. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* Push the file descriptor onto the stack. */
	__asm__ ( " pushl %ecx " );
	/* Jump to fatal return if test shows esi == NULL. */
	__asm__ ( " je .TekFileASCIIBare_Seek_fail " );
#else	/* NO_INTERNAL_NULL_CHECKS */
	/* Push the file descriptor onto the stack. */
	__asm__ ( " pushl %ecx " );
#endif	/* NO_INTERNAL_NULL_CHECKS */

	/* Call fseek(). */
	__asm__ ( " call fseek " );
	/* Test the return value. */
	__asm__ ( " testl %eax, %eax " );
	/* If retval == 0, we succeeded. */
	__asm__ ( " je .TekFileASCIIBare_Seek_ret " );
	/* If the function failed, set the value properly. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FAIL) );

	/* Used for normal returns. */
	__asm__ ( " .TekFileASCIIBare_Seek_ret: " );

	/* Used for fatal returns. */
	__asm__ ( " .TekFileASCIIBare_Seek_fail: " );

	/* Throw params 1, 2, and 3 off the stack and into the trash. */
	__asm__ ( " addl $12, %esp " );
}


/*!
    \fn TekFileASCIIBare::Write64(void * Buffer, uint64_t BytesToWrite, uint64_t * BytesWrote)
    
    Write to the file using 64 bit semantics.
 */
TEKERR TekFileASCIIBare::Write64(void * Buffer, uint64_t BytesToWrite, uint64_t * BytesWrote)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileASCIIBare::Write(void * Buffer, unsigned long BytesToWrite, unsigned long * BytesWrote)
    
    Write to the file.
 */
TEKERR TekFileASCIIBare::Write(void * Buffer, unsigned long BytesToWrite, unsigned long * BytesWrote)
{
	/* Retrieve the private file descriptor. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileDesc) );

#ifdef	NO_SIZE_T_CHECKS
	/* Prepare our stack. */
	__asm__ ( " subl $16, %esp " );

	/* and put the descriptor on the stack as parameter 3. */
	__asm__ ( " movl %ecx, 12(%esp) " );

	/* Retrieve the Buffer pointer. */
	__asm__ ( " movl %0, %%eax " : "=m" (Buffer) );
#else	/* not NO_SIZE_T_CHECKS */
	/* Put the file descriptor on the stack as parameter 3. */
	__asm__ ( " pushl %ecx " );

	/* Retrieve the Buffer pointer. */
	__asm__ ( " movl %0, %%ecx " : "=m" (Buffer) );

	/* Test to see if the Buffer pointer is null. */
	__asm__ ( " testl %ecx, %ecx " );
	/* Set the worst-case scenario for return. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_POINTER) );
	/* If NULL, go to PointerFail. */
	__asm__ ( " je .TekFileASCIIBare_Write_done " );

	/* Prepare our stack. */
	__asm__ ( " subl $12, %esp " );

	/* Put the pointer to eax; we'll push it later. */
	__asm__ ( " movl %ecx, %eax " );
#endif	/* not NO_SIZE_T_CHECKS */

	/* Get the amount of bytes to read. */
	__asm__ ( " movl %0, %%ecx " : "=m" (BytesToWrite) );
	/* and put it on the stack as parameter 2. */
	__asm__ ( " movl %ecx, 8(%esp) " );

	/* Put a 1 onto the stack as parameter 1. */
	__asm__ ( " movl $1, 4(%esp) " );

	/* Put the Buffer onto the stack. */
	__asm__ ( " movl %eax, (%esp) " );

	/* Finally, call fwrite. */
	__asm__ ( " call fwrite " );
	/* Clean up the stack. */
	__asm__ ( " addl $12, %esp " );

	/* Determine what happened. */
	__asm__ ( " testl %eax, %eax " );
	/* If we succeeded, we are ready to post how many characters were written. */
	__asm__ ( " jne .TekFileASCIIBare_Write_postres " );

	/* If we're here, something failed. */
	/* We have to process the error code. */
	__asm__ ( " movl %0, %%eax " : "=m" (errno) );

	/* Check for "broken pipe" error. */
	__asm__ ( " cmpl %1, %%eax " : "=m" (_tfbtmp) : "i" (EPIPE) );
	/* Jump as appropriate. */
	__asm__ ( " je .TekFileASCIIBare_Write_EPIPE " );

	/* Check for "out of space on device" error. */
	__asm__ ( " cmpl %1, %%eax " : "=m" (_tfbtmp) : "i" (ENOSPC) );
	/* Jump as appropriate. */
	__asm__ ( " je .TekFileASCIIBare_Write_EPIPE " );

	/* Check for "read only" error. */
	__asm__ ( " cmpl %1, %%eax " : "=m" (_tfbtmp) : "i" (EBADF) );
	/* Jump as appropriate. */
	__asm__ ( " je .TekFileASCIIBare_Write_EBADF " );

	/* Used for IO errors. */
	__asm__ ( " .TekFileASCIIBare_Write_EIO: " );
	/* Set our return value. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_IO) );
	/* We're done. */
	__asm__ ( " jmp .TekFileASCIIBare_Write_done " );

	/* Used for setting up retval on EPIPE.. */
	__asm__ ( " .TekFileASCIIBare_Write_EPIPE: " );
	/* Set our return value for this error condition. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_PIPE) );
	/* We're done. */
	__asm__ ( " jmp .TekFileASCIIBare_Write_done " );

	/* Used for setting up retval on ENOSPC. */
	__asm__ ( " .TekFileASCIIBare_Write_ENOSPC: " );
	/* Set our return value for this error condition. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_DISKFULL) );
	/* We're done. */
	__asm__ ( " jmp .TekFileASCIIBare_Write_done " );

	/* Used for setting up retval on EBADF. */
	__asm__ ( " .TekFileASCIIBare_Write_EBADF: " );
	/* Test to see if this file was open read-only. */
	/* We need to pull the PrivFileMode value first. */
	__asm__ ( " movw %0, %%cx " : "=m" (this->PrivFileMode) );
	/* Test the PrivFileMode to see if it was open for read-only. */
	__asm__ ( " testw %cx, %cx " );
	/* Error returned will be TEKERR_FILE_IO if test fails. */
	__asm__ ( " jne .TekFileASCIIBare_Write_EIO " );

	/* Set our return value for this error condition. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_READONLY) );
	/* We're done. */
	__asm__ ( " jmp .TekFileASCIIBare_Write_done " );
	/* END OF EBADF PROCESSING */

	/* Used for setting up BytesRead. */
	__asm__ ( " .TekFileASCIIBare_Write_postres: " );
	/* Retrieve BytesRead. */
	__asm__ ( " movl %0, %%ecx " : "=m" (BytesWrote) );
	/* Test to see if it is NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* If it is NULL, there's nothing else to do. */
	__asm__ ( " je .TekFileASCIIBare_Write_succeeded " );

	/* Set the memory located by BytesRead to the result. */
	__asm__ ( " movl %eax, (%ecx) " );

	/* Used for returns. */
	__asm__ ( " .TekFileASCIIBare_Write_succeeded: " );
	/* Set our return value for success. */
	TEKLTI_RETVAL_TEKERR_OK

	/* Used for returns. */
	__asm__ ( " .TekFileASCIIBare_Write_done: " );
	/* Clear the file descriptor off the stack. */
	__asm__ ( " addl $4, %esp " );
}


/*!
    \fn TekFileASCIIBare::get_Location(unsigned long * Location)

    Retrieves the location.
 */

TEKERR TekFileASCIIBare::get_Location(unsigned long * Location)
{
	/* Retrieve the private file descriptor. */
	__asm__ ( " movl %0, %%ecx " : "=m" (this->PrivFileDesc) );

#ifndef	NO_INTERNAL_NULL_CHECKS
	/* Test to see if ecx is NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* See retval for worst case scenario. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_SEQUENCE) );
	/* If it is NULL, there's nothing to do. */
	__asm__ ( " je .TekFileBinary_get_Location_ret " );
#endif	/* NO_INTERNAL_NULL_CHECKS */

	/* Put the descriptor on the stack as parameter 0. */
	__asm__ ( " pushl %ecx " );
	/* Call ftell. */
	__asm__ ( " call ftell " );
	/* Reset the stack. */
	__asm__ ( " addl $4, %esp " );

	/* Get the Location pointer. */
	__asm__ ( " movl %0, %%ecx " : "=m" (Location) );
	/* Put result into Location. */
	__asm__ ( " movl %eax, (%ecx) " );
	/* cmp the result. */
	__asm__ ( " cmpl $-1, %eax " );
	/* Jump to end if we succeeded. */
	__asm__ ( " jg .TekFileBinary_get_Location_ret " );

	/* Set retval for failure. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_FILE_IO) );
	/* Leave and return to caller. */
	__asm__ ( " leave " );
	__asm__ ( " ret " );

	/* Used for returns. */
	__asm__ ( " .TekFileBinary_get_Location_ret: " );
	/* Set retval for success. */
	TEKLTI_RETVAL_TEKERR_OK
}


/*!
    \fn TekFileASCIIBare::get_Location64(uint64_t * Location)

    Retrieves the location and stores it in a 64-bit variable.
 */

TEKERR TekFileASCIIBare::get_Location64(uint64_t * Location)
{
	return TEKERR_NOTIMPL;
}


#endif	/* not USE_386_ASM */


