/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#define	LIBTEKLTI_EXPORT	(0)
//#define	TEKFILEBZ2_INTERNAL	(0)
//#define	TEKFILE_INTERNAL	(0)
//#define	TEKSTD_INTERNAL	(0)

#ifndef	_cplusplus
#define	_cplusplus
#endif	/* _cplusplus */
#include "teklti.h"


#ifndef	TEKLTI_USE_BZIP2
#error You can not compile the BZIP2 interfaces unless TEKLTI_USE_BZIP2 is defined.
#endif	/* TEKLTI_USE_BZIP2 */


#ifdef	NULL
#undef	NULL
#endif	/* NULL */

#define	NULL	0


MKTEKUUID(UTekFileBZ2, "D5A00EBC-2C7F-11DA-9138-000BDBC434D9")
MKTEKDEBUGSTRING(DBTekFileBZ2, "TekFileBZ2")


/**
Instantizer.
*/
TekFileBZ2::TekFileBZ2()
{
}


/**
Destructor.
*/
TekFileBZ2::~TekFileBZ2()
{
}


#if	NULL != 0
//TEKSTD_SOURCE_FUNC(TekFileBZ2);
//TEKSTD_SOURCE_FUNC_CALLFUNC(TekFileBZ2);



/**
    \fn TekFileBZ2::get_BytesIn(uint64_t * RetVal)
    
    Retrieves the amount of bytes bzip2 recieved. \n
    \n
    <b>NOTE:</b> You will get a TEKERR_UNAVAILABLE if you try calling
    this function while the BytesIn data is unavailable.
 */

TEKERR TekFileBZ2::get_BytesIn(uint64_t * RetVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::get_BytesOut(uint64_t * RetVal)
    
    Retrieves the amount of bytes bzip2 put out. \n
    \n
    <b>NOTE:</b> You will get a TEKERR_UNAVAILABLE if you try calling
    this function while the BytesIn data is unavailable.
 */
 

TEKERR TekFileBZ2::get_BytesOut(uint64_t * RetVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::put_UseLessMemory(unsigned int NewVal)
    
    Sets or resets the UseLessMemory flag. \n
    \n
    <b>NOTE:</b> You will get a TEKERR_ACCESS if you try calling
    this function while the internally held BZFILE structure is
    opened.
 */

TEKERR TekFileBZ2::put_UseLessMemory(unsigned int NewVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::get_UseLessMemory(unsigned int * RetVal)
    
    Retrieves the UseLessMemory flag. \n
 */

TEKERR TekFileBZ2::get_UseLessMemory(unsigned int * RetVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::put_WorkFactor(unsigned int NewVal)
    
    Sets the work factor number.\n
    \n
    <b>NOTE:</b> You will get a TEKERR_ACCESS if you try calling
    this function while the internally held BZFILE structure is
    opened. \n
    \n
    <b>WARNING:</b> It is best that you not set this yourself.
    The bzip2 library handles this on its own.
 */

TEKERR TekFileBZ2::put_WorkFactor(unsigned int NewVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::get_WorkFactor(unsigned int * RetVal)
    
    Retrieves the work factor number.\n
 */

TEKERR TekFileBZ2::get_WorkFactor(unsigned int * RetVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::put_Verbosity(unsigned int NewVal)
    
    Sets the current verbosity value.\n
    \n
    <b>NOTE:</b> You will get a TEKERR_ACCESS if you try calling
    this function while the internally held BZFILE structure is
    opened.
 */

TEKERR TekFileBZ2::put_Verbosity(unsigned int NewVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::get_Verbosity(unsigned int * RetVal)
    
    Retrieves the current verbosity value.
 */

TEKERR TekFileBZ2::get_Verbosity(unsigned int * RetVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::put_BlockSize(unsigned int NewVal)
    
    Sets the block size to use for writing.  Allowed
    values are 1-9.\n
    \n
    <b>NOTE:</b> You will get a TEKERR_ACCESS if you try calling
    this function while the internally held BZFILE structure is
    opened.
 */
TEKERR TekFileBZ2::put_BlockSize(unsigned int NewVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::get_BlockSize(unsigned int * RetVal)
    
    Retrieves the block size to use for writing.
 */
TEKERR TekFileBZ2::get_BlockSize(unsigned int * RetVal)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::CloseStream()
    
    Tells the BZIP2 library to close the stream currently
    open for the internally held FILE *\n
    \n
    <b>NOTE:</b> TekFileBZ2::Close() should be used instead.
    TekFileBZ2::CloseStream() will not close the internally
    held FILE *
 */
TEKERR TekFileBZ2::CloseStream()
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::OpenStream()
    
    Tells the BZIP2 library to open a stream for the internally
    held FILE *
 */
TEKERR TekFileBZ2::OpenStream()
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::get_FILE(FILE ** FileDescriptor)
    
    Obtains the handle used to access the open file.
 */
TEKERR TekFileBZ2::get_FILE(FILE ** FileDescriptor)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::get_Filename(uchar_t ** Name)
    
    Obtains the filename in the form of a uchar.
 */
TEKERR TekFileBZ2::get_Filename(uchar_t ** Name)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::put_FILE(FILE * FileDescriptor)
    
    Sets the handle used to access a file.\n
    \n
    WARNING!!!!!  DO NOT USE THE FILE DESCRIPTOR YOU PASS IN \n
    TO THIS FUNCTION UNLESS YOU HAVE RE-RETRIEVED IT USING \n
    TekFileBZ2::get_FILE()!  Utilizing the descriptor in a direct fashion after a \n
    successful call to put_FILE() will result in undefined results!!!!!
 */
TEKERR TekFileBZ2::put_FILE(FILE * FileDescriptor)
{
	return TEKERR_NOTIMPL;
}


/**
    \fn TekFileBZ2::put_Filename(uchar_t * Name)
    
    Sets the filename to access.
 */
TEKERR TekFileBZ2::put_Filename(uchar_t * Name)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::get_Type(TekFileType * FileTypePointer)
    
    Gets the file type.
 */
TEKERR TekFileBZ2::get_Type(TekFileType * FileTypePointer)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Close()
    
    Closes the file.
 */
TEKERR TekFileBZ2::Close()
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::get_Mode(TekFileMode * ModeID)
    
    Retrieves the mode currently set.
 */
TEKERR TekFileBZ2::get_Mode(TekFileMode * ModeID)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Flush()
    
    Flushes the buffer.
 */
TEKERR TekFileBZ2::Flush()
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Open()
    
    Open the file.
 */
TEKERR TekFileBZ2::Open()
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Open64()
    
    Open the file using 64 bit semantics.
 */
TEKERR TekFileBZ2::Open64()
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::put_Mode(TekFileMode ModeID)
    
    Sets the mode used to open the file.
 */
TEKERR TekFileBZ2::put_Mode(TekFileMode ModeID)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Read64(void * Buffer, uint64_t BytesToRead, uint64_t * BytesRead)
    
    Read from the file using 64 bit semantics.
 */
TEKERR TekFileBZ2::Read64(void * Buffer, uint64_t BytesToRead, uint64_t * BytesRead)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Read(void * Buffer, unsigned long BytesToRead, unsigned long * BytesRead)
    
    Read from the file.
 */
TEKERR TekFileBZ2::Read(void * Buffer, unsigned long BytesToRead, unsigned long * BytesRead)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Seek64(TekFileSeek SeekWhere, int64_t NewLocation)
    
    This is not implemented.
 */
TEKERR TekFileBZ2::Seek64(TekFileSeek SeekWhere, int64_t NewLocation)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Seek(TekFileSeek SeekWhere, signed long NewLocation)
    
    This is not implemented.
 */
TEKERR TekFileBZ2::Seek(TekFileSeek SeekWhere, signed long NewLocation)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Write64(void * Buffer, uint64_t BytesToWrite, uint64_t * BytesWrote)
    
    Write to the file using 64 bit semantics.
 */
TEKERR TekFileBZ2::Write64(void * Buffer, uint64_t BytesToWrite, uint64_t * BytesWrote)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::Write(void * Buffer, unsigned long BytesToWrite, unsigned long * BytesWrote)
    
    Write to the file.
 */
TEKERR TekFileBZ2::Write(void * Buffer, unsigned long BytesToWrite, unsigned long * BytesWrote)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::get_Location(unsigned long * Location)

    Retrieves the location.\n
    \n
    <b>CAUTION!</b> This function may not be implemented due to
    optimization settings, so watch out for TEKERR_NOTIMPL
    return value.
 */

TEKERR TekFileBZ2::get_Location(unsigned long * Location)
{
	return TEKERR_NOTIMPL;
}


/*!
    \fn TekFileBZ2::get_Location64(uint64_t * Location)

    Retrieves the location and stores it in a 64-bit variable.\n
    \n
    <b>CAUTION!</b> This function may not be implemented due to
    optimization settings, so watch out for TEKERR_NOTIMPL
    return value.
 */

TEKERR TekFileBZ2::get_Location64(uint64_t * Location)
{
	return TEKERR_NOTIMPL;
}

#endif	/* NULL != 0 */


