/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 

#define	LIBTEKLTI_EXPORT	(0)

#ifndef	_cplusplus
#define	_cplusplus
#endif	/* _cplusplus */

#include "teklti.h"


MKTEKUUID(UTekStatFilePOSIX, "E369BDA-3789-11DA-8436-000BDBC434D9");
MKTEKDEBUGSTRING(DBTekStatFilePOSIX, "DBTekStatFilePOSIX");


/**
Instantizer.
*/
TekStatFilePOSIX::TekStatFilePOSIX()
{
}

/**
Destructor.
*/
TekStatFilePOSIX::~TekStatFilePOSIX()
{
}


/**
    \fn TekStatFilePOSIX::put_Filename(const uchar_t * Filename)
    
    Retrieves information from named file.
 */
TEKERR TekStatFilePOSIX::put_Filename(const uchar_t * Filename)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::put_FILE(FILE * FileDescriptor)
    
    Retrieves information from file descriptor.
 */
TEKERR TekStatFilePOSIX::put_FILE(FILE * FileDescriptor)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::put_UserInfoToAccess(uuid_t * UUIDOfUserInfo)
    
    Sets the userinfo access interface to read usernames from.\n
    \n
    <b>NOTE:</b> If this is not called, this interface will
    choose the scheme on its own, which could vary from operating system
    to operating system.  So, unless you don't mind of the inheriting
    interface choosing the scheme for you, you should utilize setting
    this parameter.\n
    \n
    This interface will choose the /etc/passwd scheme, and if that scheme
    is unavailable, a TEKERR_UNAVAILABLE will be returned.
 */
TEKERR TekStatFilePOSIX::put_UserInfoToAccess(uuid_t * UUIDOfUserInfo)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::MakeTekFile(TekFileType TekType, TekFile ** RetVal)
    
    Makes an unopened instance of a TekFile, type TekType.  This function
    is included here as a timesaver inside conditional blocks.
 */
TEKERR MakeTekFile(TekFileType TekType, TekFile ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_Dev(dev_t * Dev)
    
    Retrieves the device.
 */
TEKERR TekStatFilePOSIX::get_Dev(dev_t * Dev)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_DevNo(dev_t * DevNo)
    
    Retrieves the device number.
 */
TEKERR TekStatFilePOSIX::get_DevNo(dev_t * DevNo)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_FileSerialNo(ino_t * SerialNo)
    
    Retrieves the file serial number.
 */
TEKERR TekStatFilePOSIX::get_FileSerialNo(ino_t * SerialNo)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_Mode(mode_t * FileMode)
    
    Retrieves the raw mode.
 */
TEKERR TekStatFilePOSIX::get_Mode(mode_t * FileMode)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_ModeString(uchar_t ** FileModeString)
    
    Retrieves the mode string.
 */
TEKERR TekStatFilePOSIX::get_ModeString(uchar_t ** FileModeString)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::put_Mode(mode_t NewFileMode)
    
    Sets the mode in raw form.
 */
TEKERR TekStatFilePOSIX::put_Mode(mode_t NewFileMode)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::put_ModeString(const uchar_t * NewFileModeString)
    
    Sets the mode using POSIX string format, e.g. "rwxr-xr-x".
 */
TEKERR TekStatFilePOSIX::put_ModeString(const uchar_t * NewFileModeString)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_LinkCount(nlink_t * LinkCount)
    
    Retrieves the mode string.
 */
TEKERR TekStatFilePOSIX::get_LinkCount(nlink_t * LinkCount)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_UID(uid_t * UID)
    
    Retrieves the user ID in raw form.
 */
TEKERR TekStatFilePOSIX::get_UID(uid_t * UID)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::put_UID(uid_t UID)
    
    Sets the user ID in raw form.
 */
TEKERR TekStatFilePOSIX::put_UID(uid_t UID)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_GID(gid_t * GID)
    
    Retrieves the group ID in raw form.
 */
TEKERR TekStatFilePOSIX::get_GID(gid_t * GID)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::put_GID(gid_t GID)
    
    Sets the group ID in raw form.
 */
TEKERR TekStatFilePOSIX::put_GID(gid_t GID)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_UIDString(uchar_t ** UIDString)
    
    Retrieves the Username behind the UID.
 */
TEKERR TekStatFilePOSIX::get_UIDString(uchar_t ** UIDString)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::put_UIDString(const uchar_t * UIDString)
    
    Sets the Username.
 */
TEKERR TekStatFilePOSIX::put_UIDString(const uchar_t * UIDString)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_GIDString(uchar_t ** GIDString)
    
    Retrieves the Groupname behind the GID.
 */
TEKERR TekStatFilePOSIX::get_GIDString(uchar_t ** GIDString)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::put_GIDString(const uchar_t * GIDString)
    
    Sets the Groupname.
 */
TEKERR TekStatFilePOSIX::put_GIDString(const uchar_t * GIDString)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_Size(unsigned long * FileSize)
    
    Retrieves the file size.
 */
TEKERR TekStatFilePOSIX::get_Size(unsigned long * FileSize)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_Size64(uint64_t * FileSize)
    
    Retrieves the file size, cast to a uint64_t.
 */
TEKERR TekStatFilePOSIX::get_Size64(uint64_t * FileSize)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_BlockSize(blksize_t * FileBlockSize)
    
    Retrieves the block size to use for optimum performance.
 */
TEKERR TekStatFilePOSIX::get_BlockSize(blksize_t * FileBlockSize)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_BlockCount(blkcnt64_t * FileBlockCount)
    
    Retrieves the amount of blocks the file is taking.
 */
TEKERR TekStatFilePOSIX::get_BlockCount(blkcnt64_t * FileBlockCount)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_TimeOfLastAccessRaw(unsigned long ** RetVal)
    
    Retrieves the time of last access to file, in raw form.
 */
TEKERR TekStatFilePOSIX::get_TimeOfLastAccessRaw(unsigned long ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_TimeOfLastModificationRaw(unsigned long ** RetVal)
    
    Retrieves the time of last modification to file, in raw form.
 */
TEKERR TekStatFilePOSIX::get_TimeOfLastModificationRaw(unsigned long ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_TimeOfLastStatChangeRaw(unsigned long ** RetVal)
    
    Retrieves the time of last stat change to file, in raw form.
 */
TEKERR TekStatFilePOSIX::get_TimeOfLastStatChangeRaw(unsigned long ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_TimeOfLastAccess(uchar_t ** RetVal)
    
    Retrieves the time of last access to file.
 */
TEKERR TekStatFilePOSIX::get_TimeOfLastAccess(uchar_t ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_TimeOfLastModification(uchar_t ** RetVal)
    
    Retrieves the time of last modification to file.
 */
TEKERR TekStatFilePOSIX::get_TimeOfLastModification(uchar_t ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
    \fn TekStatFilePOSIX::get_TimeOfLastStatChange(uchar_t ** RetVal)
    
    Retrieves the time of last stat change to file.
 */
TEKERR TekStatFilePOSIX::get_TimeOfLastStatChange(uchar_t ** RetVal)
{
	return TEKERR_NOTIMPL;
}


#ifndef	LIBTEKLTI_EXPORT
/**
This interface allows the user to access file statistics using the POSIX methods.\n
\n
This interface is <b>FINAL</b>.

@author Kevin McBride
*/
/*class TekStatFilePOSIX : public TekStatFile
{
public:
  TekStatFilePOSIX();
  ~TekStatFilePOSIX();

  virtual TEKERR put_Filename(const uchar_t * Filename) = 0;
  virtual TEKERR put_FILE(FILE * FileDescriptor) = 0;
  virtual TEKERR put_UserInfoToAccess(uuid_t * UUIDOfUserInfo) = 0;

  virtual TEKERR MakeTekFile(TekFileType TekType, TekFile ** RetVal) = 0;

  virtual TEKERR get_Dev(dev_t * Dev) = 0;
  virtual TEKERR get_DevNo(dev_t * DevNo) = 0;
  virtual TEKERR get_FileSerialNo(ino_t * SerialNo) = 0;
  virtual TEKERR get_Mode(mode_t * FileMode) = 0;
  virtual TEKERR get_ModeString(uchar_t ** FileModeString) = 0;
  virtual TEKERR put_Mode(mode_t NewFileMode) = 0;
  virtual TEKERR put_ModeString(const uchar_t * NewFileModeString) = 0;
  virtual TEKERR get_LinkCount(nlink_t * LinkCount) = 0;
  virtual TEKERR get_UID(uid_t * UID) = 0;
  virtual TEKERR put_UID(uid_t UID) = 0;
  virtual TEKERR get_GID(gid_t * GID) = 0;
  virtual TEKERR put_GID(gid_t GID) = 0;
  virtual TEKERR get_UIDString(uchar_t ** UIDString) = 0;
  virtual TEKERR put_UIDString(const uchar_t * UIDString) = 0;
  virtual TEKERR get_GIDString(uchar_t ** GIDString) = 0;
  virtual TEKERR put_GIDString(const uchar_t * GIDString) = 0;
  virtual TEKERR get_Size(unsigned long * FileSize) = 0;
  virtual TEKERR get_Size64(uint64_t * FileSize) = 0;
  virtual TEKERR get_BlockSize(blksize_t * FileBlockSize) = 0;
  virtual TEKERR get_BlockCount(blkcnt64_t * FileBlockCount) = 0;
  virtual TEKERR get_TimeOfLastAccessRaw(unsigned long ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastModificationRaw(unsigned long ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastStatChangeRaw(unsigned long ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastAccess(uchar_t ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastModification(uchar_t ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastStatChange(uchar_t ** RetVal) = 0;
};*/
#endif	/* not LIBTEKLTI_EXPORT */

