/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#define LIBTEKLTI_EXPORT

#ifndef _cplusplus
#define _cplusplus
#endif /* _cplusplus */

#include "teklti.h"
#include "tekuserunixrw.h"


MKTEKUUID(UTekUser, "061B46F4-3D58-11DA-9D30-000BDBC434D9")
MKTEKDEBUGSTRING(DBTekUser, "DBTekUser")


/*class TekUserUnixRW : public TekUser
{
public:
  TekUserUnixRW();
  ~TekUserUnixRW();

  virtual TEKERR put_TekUserInfo(struct TekUserInfo * SUInfo);

  virtual TEKERR get_Description(uchar_t** RetVal);
  virtual TEKERR get_GroupID(gid_t* RetVal);
  virtual TEKERR get_HomeDir(uchar_t** RetVal);
  virtual TEKERR get_UserID(uid_t* RetVal);
  virtual TEKERR get_Username(uchar_t** RetVal);
  virtual TEKERR put_Description(const uchar_t* NewDescription);
  virtual TEKERR put_GroupID(gid_t NewGroupID);
  virtual TEKERR put_HomeDir(const uchar_t* NewHomeDir);
  virtual TEKERR put_Password(uchar_t* NewPassword);
  virtual TEKERR put_UserID(uid_t NewID);
  virtual TEKERR put_Username(const uchar_t* NewUsername);
  virtual TEKERR Save();

private:
    struct TekUserInfo Priv_UserInfo;
};*/


TEKERR TekUserInfoCreate(
	struct TekUserInfo * UserInfo,
	TekUser ** RetVal,
	TekUserType UserType
)
{
	TekUser * NewVal;
	TEKERR terr;

#ifndef	NO_SIZE_T_CHECKS
	if ( RetVal == NULL )
		return TEKERR_POINTER;
#endif	/* NO_SIZE_T_CHECKS */

#ifdef	_WINDOWS
	return TEKERR_NOTIMPL;
#else	/* not _WINDOWS */
	switch ( UserType )
	{
		case TekUserType_Any:
		case TekUserType_POSIX:
		case TekUserType_Linux:
			/* Create a new TekUserUnix instance. */
			NewVal = new TekUserUnixRW;
			terr = NewVal->put_TekUserInfo(UserInfo);

			/* Set the retval. */
			*RetVal = NewVal;

			/* We're done. */
			break;
		case TekUserType_POSIX_RO:
		case TekUserType_Linux_RO:
#ifndef	NO_SIZE_T_CHECKS
			if ( UserInfo == NULL )
				return TEKERR_POINTER;
#endif	/* NO_SIZE_T_CHECKS */
			/* Create a new TekUserUnix instance. */
			NewVal = new TekUserUnixRO;
			terr = NewVal->put_TekUserInfo(UserInfo);

			/* Set the retval. */
			*RetVal = NewVal;

			/* We're done. */
			break;
		case TekUserType_Windows:
		default:
			return TEKERR_UNAVAILABLE;
	}
#endif	/* not _WINDOWS */

	return TEKERR_OK;
}


#ifdef	NULL
#undef	NULL
#endif	/* NULL */
#define	NULL	(0)


/**
Instantizer.
*/
TekUser::TekUser()
{
	;
}

/**
Destructor.
*/
TekUser::~TekUser()
{
	;
}



#if	NULL != 0
/**
\fn TekUser::put_TekUserInfo(struct TekUserInfo * SUInfo)

Sets a new set of user information into the instance.
*/
TEKERR TekUser::put_TekUserInfo(struct TekUserInfo * SUInfo)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::put_Description(const uchar_t * RetVal)

Sets a description, usually a real name, of the user in question.
*/
TEKERR TekUser::put_Description(const uchar_t * NewDescription)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::get_Description(uchar_t ** RetVal)

Retrieves a description, usually a real name, of the user in question.
*/
TEKERR TekUser::get_Description(uchar_t ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::get_GroupID(gid_t * RetVal)

Retrieves the primary Group ID of the user in question.
*/
TEKERR TekUser::get_GroupID(gid_t * RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::get_HomeDir(uchar_t ** RetVal)

Retrieves the home directory of the user in question.
*/
TEKERR TekUser::get_HomeDir(uchar_t ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::get_UserID(uid_t * RetVal)

Retrieves the User ID of the user in question.
*/
TEKERR TekUser::get_UserID(uid_t * RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::get_Username(uchar_t ** RetVal)

Retrieves the username of the user in question.
*/
TEKERR TekUser::get_Username(uchar_t ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::put_GroupID(gid_t NewGroupID)

Sets the primary Group ID of the user in question.
*/
TEKERR TekUser::put_GroupID(gid_t NewGroupID)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::put_HomeDir(const uchar_t * RetVal)

Sets the home directory of the user in question.
*/
TEKERR TekUser::put_HomeDir(const uchar_t * NewHomeDir)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::put_Password(uchar_t * NewPassword)

Sets the password of the user in question.
*/
TEKERR TekUser::put_Password(uchar_t * NewPassword)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::put_UserID(uid_t RetVal)

Sets the User ID of the user in question.\n
\n
<b>NOTE:</b> Most interfaces won't ever allow setting the user id.
*/
TEKERR TekUser::put_UserID(uid_t NewID)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::put_Username(const uchar_t * NewUsername)

Sets a new username of the user in question.
*/
TEKERR TekUser::put_Username(const uchar_t * NewUsername)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUser::Save()

Saves the information to the provided TekUserDB.
*/
TEKERR TekUser::Save()
{
	return TEKERR_NOTIMPL;
}

#endif	/* NULL != 0 */

