/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#define LIBTEKLTI_EXPORT (1)

#ifndef _cplusplus
#define _cplusplus (1)
#endif /* _cplusplus */


#include "teklti.h"


#ifdef	NULL
#undef	NULL
#endif	/* NULL */
#define	NULL	(0)


MKTEKUUID(UTekUserDB, "8E4AC624-3D1E-11DA-83AF-000BDBC434D9")
MKTEKDEBUGSTRING(DBTekUserDB, "TekUserDB")



TEKLTI_DECLSPEC TEKERR TekOpenUserDB(TekUserDB ** RetVal)
{
#ifdef	_WINDOWS
	return TEKERR_NOTIMPL;
#else	/* not _WINDOWS */
	return TEKERR_NOTIMPL;
#endif	/* not _WINDOWS */
}



/**
Instantizer.
*/
TekUserDB::TekUserDB()
{
	;
}


/**
Destructor.
*/
TekUserDB::~TekUserDB()
{
	;
}



#if	NULL != 0

/**
\fn TekUserDB::Clone(TekEnum ** RetVal)

Clones the current enumeration.
*/
TEKERR TekUserDB::Clone(TekEnum ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::Back(void ** RetVal)

Goes backward by an element.
*/
TEKERR TekUserDB::Back(void ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::EnumNo(unsigned long ItemNo)

Retrieves a particular element in the enum.
*/
TEKERR TekUserDB::EnumNo(unsigned long ItemNo)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::Next(void ** RetVal)

Retrieves the next item in the enum.
*/
TEKERR TekUserDB::Next(void ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::Reset()

Resets the current item pointer.
*/
TEKERR TekUserDB::Reset()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::Open()

Opens the user database.
*/
TEKERR TekUserDB::Open()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::Close()

Closes the user database.
*/
TEKERR TekUserDB::Close()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::Flush()

Writes everything to the user database.
*/
TEKERR TekUserDB::Flush()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::OpenAndLoadAll()

Opens the user database and loads the database into a temporary file
or directly into memory.
*/
TEKERR TekUserDB::OpenAndLoadAll()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::FindUser(const uchar_t * Username, TekUser * RetVal)

Looks for a user in the opened user database.
*/
TEKERR TekUserDB::FindUser(const uchar_t * Username, TekUser * RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::FindUsers(const uchar_t * SearchString, TekUserDBFunc * FuncToCall, struct TekArray ** RetVal)

Looks for users in the opened user database matching the query string.\n
\n
Query format is standardized as follows:\n
\n
BOOLEAN syntax is used, so you may use AND and OR operators in the query,
as well as the * wildcard.\n
\n
In addition, NULL characters will be accepted, so be careful with NULLs.\n
\n
Username=<i>username</i>\n
<i>The username to look for.  Use double quotes for usernames with spaces.</i>\n
\n
ID=<i>userid</i>\n
<i>the user id to look for</i>\n
\n
There might be more supported by inheriting interfaces. \n
\n
\n
This function can call a user-defined callback function on every successful
match, return an array of users, or both.  However, this function will return
TEKERR_POINTER if both FuncToCall and RetVal are NULL.\n
\n
The TekUserDBFunc callback implementation standard is:\n
<b><i>int TekUserDBFunc(TekUser *) {}</i></b>
The called function can view the TekUser * variable, and from there,
decide what to do with it.  However, the return value must be one of the
following:\n
\n
- <b>0</b> - to stop the search.\n
- <b>1</b> - to continue on with the search.
*/
TEKERR TekUserDB::FindUsers(
  const uchar_t * SearchString,
  TekUserDBFunc * FuncToCall,
  struct TekArray ** RetVal
)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::FindUsersFree(TekUser ** UserInfoArray)

Frees a UserInfoArray.  This function should always be called to destroy
the array.
*/
TEKERR TekUserDB::FindUsersFree(TekUser ** UserInfoArray)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::WriteUsers(TekUser ** UserInfoArray, unsigned long Count)

Writes users in the opened user database from an array.
*/
TEKERR TekUserDB::WriteUsers(TekUser ** UserInfoArray, unsigned long Count)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::WriteUser(TekUser * UserInfo)

Writes a new user or updates one in the opened user database.
*/
TEKERR TekUserDB::WriteUser(TekUser * UserInfo)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::DeleteUser(TekUser * UserInfo)

Deletes a user from the opened user database.
*/
TEKERR TekUserDB::DeleteUser(TekUser * UserInfo)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::DeleteUsers(const uchar_t * SearchString, TekUserDBFunc * FuncToCall, struct TekArray ** RetVal)

Deletes users in the opened user database that match the query string.\n
\n
Query format is standardized as follows:\n
\n
BOOLEAN syntax is used, so you may use AND and OR operators in the query,
as well as the * wildcard.\n
\n
In addition, NULL characters will be accepted, so be careful with NULLs.\n
\n
Username=<i>username</i>\n
<i>The username to look for.  Use double quotes for usernames with spaces.</i>\n
\n
ID=<i>userid</i>\n
<i>the user id to look for</i>\n
\n
There might be more supported by inheriting interfaces. \n
\n
\n
This function can call a user-defined callback function on every failed
deletion, return an array of users that were successfully deleted, or both.
Unlike FindUsers(), this function will not fail if both FuncToCall and
RetVal are NULL, unless one of the following happen:

- A catastrophic error occurs
- No users matched the query string
- The user executing this function does not have write access to the DB.
\n
The TekUserDBFunc callback implementation standard is:\n
<b><i>int TekUserDBFunc(TekUser *) {}</i></b>\n
The called function can view the TekUser * variable, and from there,
decide what to do with it.  However, the return value must be one of the
following:\n
\n
- <b>0</b> - to stop the search and deletion.\n
- <b>1</b> - to continue on with the search and deletion.
*/
TEKERR TekUserDB::DeleteUsers(
  const uchar_t * SearchString,
  TekUserDBFunc * FuncToCall,
  struct TekArray ** RetVal
)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::put_Filename(const uchar_t * NewFilename)

Sets the filename to access.  If this is not set before Open()
is called, the inheriting interfaces can choose a default
filename, or fail.
*/
TEKERR TekUserDB::put_Filename(const uchar_t * NewFilename)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::get_Filename(uchar_t ** Filename)

Retrieves the filename to access.
*/
TEKERR TekUserDB::get_Filename(uchar_t ** Filename)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::get_ReadOnly(bool * ReadOnlyStat)

Retrieves the read-only status of the entire User DB.
*/
TEKERR TekUserDB::get_ReadOnly(bool * ReadOnlyStat)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::get_FileInterfaceUUID(uuid_t * FileUUID)

Retrieves the uuid of the interface to access.\n
\n
NOTE: On unknown final interfaces, you should first attempt
to use get_GenericFileType first.  It is more efficient in
the long run, in most cases.
*/
TEKERR TekUserDB::get_FileInterfaceUUID(uuid_t * FileUUID)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::put_FileInterfaceUUID(const uuid_t * FileUUID)

Sets the uuid of the interface to access.
*/
TEKERR TekUserDB::put_FileInterfaceUUID(const uuid_t * FileUUID)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::get_GenericFileType(TekFileType * CurrentFileType)

Retrieves the generic file type, if available.
*/
TEKERR TekUserDB::get_GenericFileType(TekFileType * CurrentFileType)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDB::put_GenericFileType(TekFileType CurrentFileType)

Sets the generic file type, if allowed by the inheriting interface.
*/
TEKERR TekUserDB::put_GenericFileType(TekFileType CurrentFileType)
{
	return TEKERR_NOTIMPL;
}

#endif	/* NULL != 0 */


