/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#define LIBTEKLTI_EXPORT (1)

#ifndef _cplusplus
#define _cplusplus
#endif /* _cplusplus */

#include "teklti.h"

MKTEKUUID(UTekUserDBUnix, "714F5DDE-4280-11DA-9100-000BDBC434D9")
MKTEKDEBUGSTRING(DBTekUserDBUnix, "TekUserDBUnix")

TekUserDBUnix::TekUserDBUnix()
{
	;
}


TekUserDBUnix::~TekUserDBUnix()
{
	;
}


/**
\fn TekUserDBUnix::Clone(TekEnum ** RetVal)

Clones the current enumeration.
*/
TEKERR TekUserDBUnix::Clone(TekEnum ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::Back(void ** RetVal)

Goes backward by an element.
*/
TEKERR TekUserDBUnix::Back(void ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::EnumNo(unsigned long ItemNo)

Retrieves a particular element in the enum.
*/
TEKERR TekUserDBUnix::EnumNo(unsigned long ItemNo)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::Next(void ** RetVal)

Retrieves the next item in the enum.
*/
TEKERR TekUserDBUnix::Next(void ** RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::Reset()

Resets the current item pointer.
*/
TEKERR TekUserDBUnix::Reset()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::Open()

Opens the user database.
*/
TEKERR TekUserDBUnix::Open()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::Close()

Closes the user database.
*/
TEKERR TekUserDBUnix::Close()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::Flush()

Writes everything to the user database.
*/
TEKERR TekUserDBUnix::Flush()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::OpenAndLoadAll()

Opens the user database and loads the database into a temporary file
or directly into memory.
*/
TEKERR TekUserDBUnix::OpenAndLoadAll()
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::FindUser(const uchar_t * Username, TekUser * RetVal)

Looks for a user in the opened user database.
*/
TEKERR TekUserDBUnix::FindUser(const uchar_t * Username, TekUser * RetVal)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::FindUsers(const uchar_t * SearchString, TekUserDBFunc * FuncToCall, struct TekArray ** RetVal)

Looks for users in the opened user database matching the query string.\n
\n
Query format is standardized as follows:\n
\n
BOOLEAN syntax is used, so you may use AND and OR operators in the query,
as well as the * wildcard.\n
\n
In addition, NULL characters will be accepted, so be careful with NULLs.\n
\n
Username=<i>username</i>\n
<i>The username to look for.  Use double quotes for usernames with spaces.</i>\n
\n
ID=<i>userid</i>\n
<i>the user id to look for</i>\n
\n
There might be more supported by inheriting interfaces. \n
\n
\n
This function can call a user-defined callback function on every successful
match, return an array of users, or both.  However, this function will return
TEKERR_POINTER if both FuncToCall and RetVal are NULL.\n
\n
The TekUserDBFunc callback implementation standard is:\n
<b><i>int TekUserDBFunc(TekUser *) {}</i></b>
The called function can view the TekUser * variable, and from there,
decide what to do with it.  However, the return value must be one of the
following:\n
\n
- <b>0</b> - to stop the search.\n
- <b>1</b> - to continue on with the search.
*/
TEKERR TekUserDBUnix::FindUsers(
  const uchar_t * SearchString,
  TekUserDBFunc * FuncToCall,
  struct TekArray ** RetVal
)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::FindUsersFree(TekUser ** UserInfoArray)

Frees a UserInfoArray.  This function should always be called to destroy
the array.
*/
TEKERR TekUserDBUnix::FindUsersFree(TekUser ** UserInfoArray)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::WriteUsers(TekUser ** UserInfoArray, unsigned long Count)

Writes users in the opened user database from an array.
*/
TEKERR TekUserDBUnix::WriteUsers(TekUser ** UserInfoArray, unsigned long Count)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::WriteUser(TekUser * UserInfo)

Writes a new user or updates one in the opened user database.
*/
TEKERR TekUserDBUnix::WriteUser(TekUser * UserInfo)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::DeleteUser(TekUser * UserInfo)

Deletes a user from the opened user database.
*/
TEKERR TekUserDBUnix::DeleteUser(TekUser * UserInfo)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::DeleteUsers(const uchar_t * SearchString, TekUserDBFunc * FuncToCall, struct TekArray ** RetVal)

Deletes users in the opened user database that match the query string.\n
\n
Query format is standardized as follows:\n
\n
BOOLEAN syntax is used, so you may use AND and OR operators in the query,
as well as the * wildcard.\n
\n
In addition, NULL characters will be accepted, so be careful with NULLs.\n
\n
Username=<i>username</i>\n
<i>The username to look for.  Use double quotes for usernames with spaces.</i>\n
\n
ID=<i>userid</i>\n
<i>the user id to look for</i>\n
\n
There might be more supported by inheriting interfaces. \n
\n
\n
This function can call a user-defined callback function on every failed
deletion, return an array of users that were successfully deleted, or both.
Unlike FindUsers(), this function will not fail if both FuncToCall and
RetVal are NULL, unless one of the following happen:

- A catastrophic error occurs
- No users matched the query string
- The user executing this function does not have write access to the DB.
\n
The TekUserDBFunc callback implementation standard is:\n
<b><i>int TekUserDBFunc(TekUser *) {}</i></b>\n
The called function can view the TekUser * variable, and from there,
decide what to do with it.  However, the return value must be one of the
following:\n
\n
- <b>0</b> - to stop the search and deletion.\n
- <b>1</b> - to continue on with the search and deletion.
*/
TEKERR TekUserDBUnix::DeleteUsers(
  const uchar_t * SearchString,
  TekUserDBFunc * FuncToCall,
  struct TekArray ** RetVal
)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::put_Filename(const uchar_t * NewFilename)

Sets the filename to access.  If this is not set before Open()
is called, the inheriting interfaces can choose a default
filename, or fail.
*/
TEKERR TekUserDBUnix::put_Filename(const uchar_t * NewFilename)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::get_Filename(uchar_t ** Filename)

Retrieves the filename to access.
*/
TEKERR TekUserDBUnix::get_Filename(uchar_t ** Filename)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::get_ReadOnly(bool * ReadOnlyStat)

Retrieves the read-only status of the entire User DB.
*/
TEKERR TekUserDBUnix::get_ReadOnly(bool * ReadOnlyStat)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::get_FileInterfaceUUID(uuid_t * FileUUID)

Retrieves the uuid of the interface to access.\n
\n
NOTE: On unknown final interfaces, you should first attempt
to use get_GenericFileType first.  It is more efficient in
the long run, in most cases.
*/
TEKERR TekUserDBUnix::get_FileInterfaceUUID(uuid_t * FileUUID)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::put_FileInterfaceUUID(const uuid_t * FileUUID)

Sets the uuid of the interface to access.
*/
TEKERR TekUserDBUnix::put_FileInterfaceUUID(const uuid_t * FileUUID)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::get_GenericFileType(TekFileType * CurrentFileType)

Retrieves the generic file type, if available.
*/
TEKERR TekUserDBUnix::get_GenericFileType(TekFileType * CurrentFileType)
{
	return TEKERR_NOTIMPL;
}

/**
\fn TekUserDBUnix::put_GenericFileType(TekFileType CurrentFileType)

Sets the generic file type, if allowed by the inheriting interface.
*/
TEKERR TekUserDBUnix::put_GenericFileType(TekFileType CurrentFileType)
{
	return TEKERR_NOTIMPL;
}

