/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#define	LIBTEKLTI_EXPORT	(0)

#include "teklti.h"


#ifdef	USE_386_ASM


static const void * _tfbtmp = NULL;
const void * tek_asm_null = NULL;


uint64_t tekzerovar = 0;


/**
FIXME: Complete the coding for this function.
*/

TEKLTI_DECLSPEC TEKERR TekStdCheckAndRecieveProcessorInfoIntel (
	struct TekStdProcessorInfoIntel * ProcessorInfoArray,
	size_t ProcessorInfoArrayCount,
	TEKSTDPROCESSORINFO_FAIL_CALLBACK * CallbackFunction
)
{
	/* First, let's check the count for accuracy. */
	/* Retrieve the count. */
	__asm__ ( " movl %0, %%eax " : "=m" (ProcessorInfoArrayCount) );
	/* Run a comparison - eax < 0. */
	__asm__ ( " cmpl $0, %eax " );
	/* If sucessful, run the next comparison. */
	__asm__ ( " jl .TekStdCheckAndRecieveProcessorInfoIntel_Fatal2 " );
	/* Run a comparison - eax < 3. */
	__asm__ ( " cmpl $4, %eax " );
	/* If sucessful, run the CPUID. */
	__asm__ ( " jl .TekStdCheckAndRecieveProcessorInfoIntel_CPUID " );
	/* Used for staging eax. */
	__asm__ ( " .TekStdCheckAndRecieveProcessorInfoIntel_Fatal2: " );
	/* If failed, set eax. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_POINTER) );
	/* Jump to fatal return area. */
	__asm__ ( " jmp .TekStdCheckAndRecieveProcessorInfoIntel_Fatal " );

	/* Second, let's obtain the CPUID's. */
	/* Used to bypass first error stop. */
	__asm__ ( " .TekStdCheckAndRecieveProcessorInfoIntel_CPUID: " );
	/* Push ebx and edx onto the stack. */
	__asm__ ( " pushl %ebx " );
	__asm__ ( " pushl %edx " );
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %edi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Get array location. */
	__asm__ ( " movl 8(%ebp), %edi " );
	/* Set eax = sizeof(struct TekStdProcessorInfoIntel) */\
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : 
		"i" (sizeof(struct TekStdProcessorInfoIntel)) );
	/* Set the sizeof parameter. */
	__asm__ ( " movl %eax, (%edi) " );

	/* Set eax == 0 to get initial info on processor. */
	__asm__ ( " movl $0, %eax " );
	/* Call CPUID. */
	__asm__ ( " cpuid " );
	/* Move all characters onto the strings. */

	/* Copy first four characters. */
	__asm__ ( " movl %ebx, 12(%edi) " );
	/* Copy second four characters. */
	__asm__ ( " movl %edx, 16(%edi) " );
	/* Copy third four characters. */
	__asm__ ( " movl %ecx, 20(%edi) " );
	/* Make a NULL character. */
	__asm__ ( " movl $0, %eax " );
	/* NULL-terminate the string. */
	__asm__ ( " movl %eax, 24(%edi) " );

	/* Set eax to 1. */
	__asm__ ( " movl $1, %eax " );
	/* Call CPUID. */
	__asm__ ( " cpuid " );
	/* Copy version info to structure. */
	__asm__ ( " movl %eax, 4(%edi) " );
	/* Copy feature info to structure. */
	__asm__ ( " movl %edx, 8(%edi) " );
#ifdef	USE_386_ASM_MMX
	/* Test for MMX support. */
	__asm__ ( " bt $23, %edx " );
	/* If the test passed, perform a normal cleanup. */
	__asm__ ( " jc .TekStdCheckAndRecieveProcessorInfoIntel_Success " );

	/* Get the callback function address. */
	__asm__ ( " movl %0, %%ecx " : "=m" (CallbackFunction) );
	/* Test to see if it is NULL. */
	__asm__ ( " testl %ecx, %ecx " );
	/* Set retval to worst case scenario. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_UNEXPECTED) );
	/* If it is, just call exit(1). */
	__asm__ ( " je .TekStdCheckAndRecieveProcessorInfoIntel_CallExit " );

	/* Call the callback function. */
	__asm__ ( " call *%ecx " );
	/* See what we need to do. */
	__asm__ ( " testl %eax, %eax " );
	/* Set retval to worst case scenario (again). */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_UNEXPECTED) );
	/* If retval == 0, we do nothing. */
	__asm__ ( " je .TekStdCheckAndRecieveProcessorInfoIntel_Fatal3 " );

	/* Used to call the exit() function. */
	__asm__ ( " .TekStdCheckAndRecieveProcessorInfoIntel_CallExit: " );
	/* Set up EXIT_FAILURE in eax. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (EXIT_FAILURE) );
	/* Put the value onto the stack. */
	__asm__ ( " pushl %eax " );
	/* and then call exit(). */
	__asm__ ( " call exit " );
#endif	/* USE_386_ASM_MMX */

	/* Used for normal returns. */
	__asm__ ( " .TekStdCheckAndRecieveProcessorInfoIntel_Success: " );

#ifdef	USE_386_ASM_MMX
	/* 
	   Copy the nullified quadword to mm6 and mm7.
	   Registers mm6 and mm7 will, under libteklti, be
	   considered the registers used for optimization.
	*/
	__asm__ ( " movq %0, %%mm7 " : "=m" (tekzerovar) );
	__asm__ ( " movq %0, %%mm6 " : "=m" (tekzerovar) );
	__asm__ ( " movq %0, %%mm5 " : "=m" (tekzerovar) );
	/* Exit the mmx state so that we don't screw things up. */
	__asm__ ( " emms " );

#endif	/* USE_386_ASM_MMX */

	/* Set retval to TEKERR_OK. */
	__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_OK) );
	/* Used for fatal returns. */
	__asm__ ( " .TekStdCheckAndRecieveProcessorInfoIntel_Fatal3: " );
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " popl %edi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Push ebx and edx onto the stack. */
	__asm__ ( " popl %edx " );
	__asm__ ( " popl %ebx " );

	/* Used for fatal returns. */
	__asm__ ( " .TekStdCheckAndRecieveProcessorInfoIntel_Fatal: " );
}


const char _mkuuid_t_uuidstr_null[] = 
"POTENTIAL SEGFAULT in _mkuuid_t: uuid_str is NULL!\n";
const char _mkuuid_t_uuidstr_overrun[] = 
"POTENTIAL OVERRUN in _mkuuid_t: uuid_str will cause a buffer overrun!\n";


TEKLTI_DECLSPEC void _mkuuid_t ( const char * uuid_str, uuid_t uuid_raw )
{
	/* Push an ebx onto the stack. */
	__asm__ ( " _mkuuid_t_passpushpop: " );
	__asm__ ( " subl $20, %esp " );

#ifndef	NO_SIZE_T_CHECKS
	__asm__ ( " pushl %ebx " );
	/* Copy src pointer to ebx. */
	__asm__ ( " movl %0, %%ebx " : "=m" (uuid_str) );
	/* Test if ebx is NULL. */
	__asm__ ( " testl %ebx, %ebx " );
#ifdef	DEBUG_USE_FERROR
	/* If ebx is not NULL, check the length.fwrite */
	__asm__ ( " jne ._mkuuid_t_len " );

	/* Copy the uuidstr_null chr pointer to param 0. */
	__asm__ ( " movl $_mkuuid_t_uuidstr_null, (%esp) " );
	/* Copy the stderr address to eax. */
	__asm__ ( " movl stderr, %eax " );
	/* Then to param 3. */
	__asm__ ( " movl %eax, 4(%esp) " );
	/* Call fputs to output the error to stderr. */
	__asm__ ( " call fputs " );
	/* Jump to return area. */
	__asm__ ( " jmp ._mkuuid_t_ret " );

	/* LABEL Check length */
	__asm__ ( " ._mkuuid_t_len: " );
#else	/* not DEBUG_USE_FERROR */
	/* If ebx is NULL, nothing to do. */
	__asm__ ( " je ._mkuuid_t_ret " );
#endif	/* not DEBUG_USE_FERROR */

	/* Set count register ecx to 40. */
	__asm__ ( " movl $40, %ecx " );
	/* Set al register to null-terminator. */
	__asm__ ( " movb $0, %al " );
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " pushl %edi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* Copy ebx to the edi register for scasb. */
	__asm__ ( " movl %ebx, %edi " );
	/* Clear the direction flag. */
	__asm__ ( " cld " );
	/* Try to find the end of the string. */
	__asm__ ( " repne scasb " );
#ifdef	USE_386_ASM_PUSHPOP
	__asm__ ( " popl %edi " );
#endif	/* USE_386_ASM_PUSHPOP */
	/* If length is okay, parse the string to a uuid. */
	__asm__ ( " je ._mkuuid_t_parse " );

#ifdef	DEBUG_USE_FERROR
	/* We should be at these five instructions only
	   if we could not find the null character. */
	/* Copy the stderr address to eax. */
	__asm__ ( " movl stderr, %eax " );
	/* Then to param 1. */
	__asm__ ( " movl %eax, 4(%esp) " );
	/* Copy the uuidstr_null chr pointer to param 0. */
	__asm__ ( " movl $_mkuuid_t_uuidstr_overrun, (%esp) " );
	/* Call fputs to output the error to stderr. */
	__asm__ ( " call fputs " );
#endif	/* DEBUG_USE_FERROR */
	/* Jump to return area. */
	__asm__ ( " jmp ._mkuuid_t_ret " );

	/* JUMP execute uuid_parse(). */
	__asm__ ( " ._mkuuid_t_parse: " );

	/* Clean up from checks. */
	__asm__ ( " popl %ebx " );
	__asm__ ( " addl $20, %esp " );
#endif	/* not NO_SIZE_T_CHECKS */

	/* General clean up.
	   ALSO NOTE that these are the only instructions
	   executed when NO_SIZE_T_CHECKS is defined. */
	__asm__ ( " movl %ebp, %esp " );
	__asm__ ( " popl %ebp " );
	/* Call uuid_parse. */
	__asm__ ( " jmp uuid_parse " );

#ifndef	NO_SIZE_T_CHECKS
	/* LABEL Return. */
	__asm__ ( " ._mkuuid_t_ret: " );
	/* Pop ebx off the stack. */
	__asm__ ( " popl %ebx " );
	__asm__ ( " addl $20, %esp " );
#endif	/* not NO_SIZE_T_CHECKS */
}

#endif	/* USE_386_ASM */


