/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TEKFILEASCII_H
#define TEKFILEASCII_H

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */


TEKUUIDIMPORT(UTekFileASCII);


/**
This is the interface defining the standard for accessing ASCII Files.

This interface is <b>INHERITABLE</b>.

@author Kevin McBride
*/
class TekFileASCII : public TekFile
{
public:

/**
Instantizer.
*/
TekFileASCII();


/**
Destructor.
*/
~TekFileASCII();


#ifndef	TEKFILE_INTERNAL
#ifndef	TEKFILEASCII_INTERNAL
virtual TEKERR ReadLine(uchar_t** Buffer, unsigned long ReadMax) = 0;
virtual TEKERR WriteLine(const uchar_t* Buffer) = 0;

virtual TEKERR Close() = 0;
virtual TEKERR Flush() = 0;
virtual TEKERR get_FILE(FILE** FileDescriptor) = 0;
virtual TEKERR get_Filename(uchar_t** Name) = 0;
virtual TEKERR get_Mode(TekFileMode* ModeID) = 0;
virtual TEKERR get_Type(TekFileType* FileTypePointer) = 0;
virtual TEKERR Open() = 0;
virtual TEKERR Open64() = 0;
virtual TEKERR put_FILE(FILE* FileDescriptor) = 0;
virtual TEKERR put_Filename(uchar_t* Name) = 0;
virtual TEKERR put_Mode(TekFileMode ModeID) = 0;
virtual TEKERR Read64(void* Buffer, uint64_t BytesToRead, uint64_t* BytesRead) = 0;
virtual TEKERR Read(void* Buffer, unsigned long BytesToRead, unsigned long* BytesRead) = 0;
virtual TEKERR Seek64(TekFileSeek SeekWhere, int64_t NewLocation) = 0;
virtual TEKERR Seek(TekFileSeek SeekWhere, signed long NewLocation) = 0;
virtual TEKERR Write64(void* Buffer, uint64_t BytesToWrite, uint64_t* BytesWrote) = 0;
virtual TEKERR Write(void* Buffer, unsigned long BytesToWrite, unsigned long* BytesWrote) = 0;
virtual TEKERR get_Location(unsigned long * Location) = 0;
virtual TEKERR get_Location64(uint64_t * Location) = 0;
#endif	/* not TEKFILEASCII_INTERNAL */
#endif	/* not TEKFILE_INTERNAL */

public:

TEKSTD_HEADER_VARS;
};

#endif	/* not TEKFILEASCII_H */
