/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TEKFILEASCIIBARE_H
#define TEKFILEASCIIBARE_H

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */


TEKUUIDIMPORT(UTekFileASCIIBare);


/**
This is the bare-bones implementation of reading and writing ASCII files.

This interface is <b>FINAL</b>.

@author Kevin McBride
*/
class TekFileASCIIBare : public TekFileASCII
{
private:
    uchar_t PrivFileName;
    FILE * PrivFileDesc;
    TekFileMode PrivFileMode;
    TekFileType PrivTekFileType;
    uchar_t PrivBuffer;
    uchar_t PrivBufferPtr;

public:
    TekFileASCIIBare();

    ~TekFileASCIIBare();

    virtual TEKERR ReadLine(uchar_t** Buffer, unsigned long ReadMax);
    virtual TEKERR WriteLine(const uchar_t* Buffer);

    virtual TEKERR Close();
    virtual TEKERR Flush();
    virtual TEKERR get_FILE(FILE** FileDescriptor);
    virtual TEKERR get_Filename(uchar_t** Name);
    virtual TEKERR get_Mode(TekFileMode* ModeID);
    virtual TEKERR get_Type(TekFileType* FileTypePointer);
    virtual TEKERR Open();
    virtual TEKERR Open64();
    virtual TEKERR put_FILE(FILE* FileDescriptor);
    virtual TEKERR put_Filename(uchar_t* Name);
    virtual TEKERR put_Mode(TekFileMode ModeID);
    virtual TEKERR Read64(void* Buffer, uint64_t BytesToRead, uint64_t* BytesRead);
    virtual TEKERR Read(void* Buffer, unsigned long BytesToRead, unsigned long* BytesRead);
    virtual TEKERR Seek64(TekFileSeek SeekWhere, int64_t NewLocation);
    virtual TEKERR Seek(TekFileSeek SeekWhere, signed long NewLocation);
    virtual TEKERR Write64(void* Buffer, uint64_t BytesToWrite, uint64_t* BytesWrote);
    virtual TEKERR Write(void* Buffer, unsigned long BytesToWrite, unsigned long* BytesWrote);
    virtual TEKERR get_Location(unsigned long * Location);
    virtual TEKERR get_Location64(uint64_t * Location);

    TEKSTD_HEADER_VARS;
};

#endif
