/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TEKFILEBINARY_H_D60710C0_E5EA_11D9_8325_000BDBC434D9
#define TEKFILEBINARY_H_D60710C0_E5EA_11D9_8325_000BDBC434D9

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */


TEKUUIDIMPORT(UTekFileBinary);


/**
Contains code for performing I/O on files in the most basic way - binary.

This interface is <b>FINAL</b>.

@author Kevin McBride
*/
class TekFileBinary : public TekFile
{
private:
    uchar_t PrivFileName;
    FILE * PrivFileDesc;
    TekFileMode PrivFileMode;
    TekFileType PrivTekFileType;
public:
    TekFileBinary();

    ~TekFileBinary();

    TEKERR ConvertToPipe();

    virtual TEKERR Close();
    virtual TEKERR Flush();
    virtual TEKERR get_FILE(FILE ** FileDescriptor);
    virtual TEKERR get_Filename(uchar_t ** Name);
    virtual TEKERR get_Mode(TekFileMode * ModeID);
    virtual TEKERR get_Type(TekFileType * FileTypePointer);
    virtual TEKERR Open();
    virtual TEKERR Open64();
    virtual TEKERR put_FILE(FILE * FileDescriptor);
    virtual TEKERR put_Filename(uchar_t * Name);
    virtual TEKERR put_Mode(TekFileMode ModeID);
    virtual TEKERR Read64(void * Buffer, uint64_t BytesToRead, uint64_t * BytesRead);
    virtual TEKERR Read(void * Buffer, unsigned long BytesToRead, unsigned long * BytesRead);
    virtual TEKERR Seek64(TekFileSeek SeekWhere, int64_t NewLocation);
    virtual TEKERR Seek(TekFileSeek SeekWhere, signed long NewLocation);
    virtual TEKERR Write64(void * Buffer, uint64_t BytesToWrite, uint64_t * BytesWrote);
    virtual TEKERR Write(void * Buffer, unsigned long BytesToWrite, unsigned long * BytesWrote);
    virtual TEKERR get_Location(unsigned long * Location);
    virtual TEKERR get_Location64(uint64_t * Location);

//TEKSTD_HEADER_VARSANDFUNC(TekFileBinary);
TEKSTD_HEADER_VARS;
};

#endif /* not TEKFILEBINARY_H_D60710C0_E5EA_11D9_8325_000BDBC434D9 */


