/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TEKFILEBZ2_H_D5A00EBC_2C7F_11DA_9138_000BDBC434D9
#define TEKFILEBZ2_H_D5A00EBC_2C7F_11DA_9138_000BDBC434D9

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */

#ifdef	TEKLTI_USE_BZIP2


/* Define the error codes, then the building block of BZIP2. */

#define	TEKERR_BZIP2_NOTASTREAM 	0x01000000
#define	TEKERR_BZIP2_UNEXPECTEDEOF	0x02000000


TEKUUIDIMPORT(UTekFileBZ2);


/**
This interface defines a standard for accessing bzip2-compressed files

This interface is <b>INHERITABLE</b>.

@author Kevin McBride
*/
class TekFileBZ2 : public TekFile
{
public:
/**
Instantizer.
*/
TekFileBZ2();

/**
Destructor.
*/
~TekFileBZ2();

#ifndef	TEKSTD_INTERNAL
#ifndef	TEKFILE_INTERNAL
#ifdef	TEKFILEBZ2_INTERNAL
#if	TEKFILEBZ2_INTERNAL != 0
#error Compilation fault!  TEKFILEBZ2_INTERNAL can not be defined!
#endif	/* TEKFILEBZ2_INTERNAL != 0 */
#else	/* not TEKFILEBZ2_INTERNAL */
//TEKSTD_HEADER_VARSANDFUNC(TekFileBZ2)

virtual TEKERR get_BytesIn(uint64_t * RetVal) = 0;
virtual TEKERR get_BytesOut(uint64_t * RetVal) = 0;
virtual TEKERR put_UseLessMemory(unsigned int NewVal) = 0;
virtual TEKERR get_UseLessMemory(unsigned int * RetVal) = 0;
virtual TEKERR put_WorkFactor(unsigned int NewVal) = 0;
virtual TEKERR get_WorkFactor(unsigned int * RetVal) = 0;
virtual TEKERR put_Verbosity(unsigned int NewVal) = 0;
virtual TEKERR get_Verbosity(unsigned int * RetVal) = 0;
virtual TEKERR put_BlockSize(unsigned int NewVal) = 0;
virtual TEKERR get_BlockSize(unsigned int * RetVal) = 0;
virtual TEKERR CloseStream() = 0;
virtual TEKERR OpenStream() = 0;
virtual TEKERR get_FILE(FILE ** FileDescriptor) = 0;
virtual TEKERR get_Filename(uchar_t ** Name) = 0;
virtual TEKERR get_Mode(TekFileMode * ModeID) = 0;
virtual TEKERR get_Type(TekFileType * FileTypePointer) = 0;
virtual TEKERR put_FILE(FILE * FileDescriptor) = 0;
virtual TEKERR put_Filename(uchar_t * Name) = 0;
virtual TEKERR put_Mode(TekFileMode ModeID) = 0;

virtual TEKERR Close() = 0;
virtual TEKERR Flush() = 0;
virtual TEKERR Open() = 0;
virtual TEKERR Open64() = 0;
virtual TEKERR Read64(
	void * Buffer,
	uint64_t BytesToRead,
	uint64_t * BytesRead
) = 0;
virtual TEKERR Read(
	void * Buffer,
	unsigned long BytesToRead,
	unsigned long * BytesRead
) = 0;
virtual TEKERR Seek64(TekFileSeek SeekWhere, int64_t NewLocation) = 0;
virtual TEKERR Seek(TekFileSeek SeekWhere, signed long NewLocation) = 0;
virtual TEKERR Write64(
	void * Buffer,
	uint64_t BytesToWrite,
	uint64_t * BytesWrote
) = 0;
virtual TEKERR Write(
	void * Buffer,
	unsigned long BytesToWrite,
	unsigned long * BytesWrote
) = 0;
virtual TEKERR get_Location(unsigned long * Location) = 0;
virtual TEKERR get_Location64(uint64_t * Location) = 0;
#endif	/* not TEKFILEBZ2_INTERNAL */
#endif	/* not TEKFILE_INTERNAL */
#endif	/* not TEKSTD_INTERNAL */

/**
This macro contains the generic implementation for TekStd.\n
It is much easier to use as opposed to creating the\n
implementation by hand.
*/
//TEKSTD_HEADER_VARSANDFUNC(TekFile);
TEKSTD_HEADER_VARS

};

#endif	/* TEKLTI_USE_BZIP2 */
#endif	/* TEKFILEBZ2_H_D5A00EBC_2C7F_11DA_9138_000BDBC434D9 */
