/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef	TEKFILEBZ2ASCII_H_6CC3729C_2D12_11DA_887B_000BDBC434D9
#define	TEKFILEBZ2ASCII_H_6CC3729C_2D12_11DA_887B_000BDBC434D9

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */

#ifdef	TEKLTI_USE_BZIP2

#define NULLTEST	0


TEKUUIDIMPORT(UTekFileBZ2ASCII);


/**
This is the implementation of TekFileBZ2 that can compress and decompress
ASCII files and strings.\n
\n
This interface is <b>FINAL</b>.\n
\n
This is a <b>Type II</b> interface.

@author Kevin McBride
*/
class TekFileBZ2ASCII : public TekFileBZ2, public TekFileASCII
{
private:
FILE * PrivFileDesc;
BZFILE * PrivBZ2FileDesc;

unsigned long PrivFlags;
unsigned long PrivBlockSize;

uint64_t PrivBytesIn;
uint64_t PrivBytesOut;

uint8_t * PrivUnused;
int PrivUnusedLen;

int PrivWorkFactor;
int PrivVerbosity;

uchar_t PrivFilename;

public:
TekFileBZ2ASCII();

~TekFileBZ2ASCII();

/**
\fn TEKSTD_HEADER_VARSANDFUNC(TekFileBZ2ASCII)

This indicates that this is a type II interface.
*/
TEKSTD_HEADER_VARSANDFUNC(TekFileBZ2ASCII);

virtual TEKERR ReadLine(uchar_t** Buffer, unsigned long ReadMax);
virtual TEKERR WriteLine(const uchar_t* Buffer);

virtual TEKERR get_BytesIn(uint64_t * RetVal);
virtual TEKERR get_BytesOut(uint64_t * RetVal);
virtual TEKERR put_UseLessMemory(unsigned int NewVal);
virtual TEKERR get_UseLessMemory(unsigned int * RetVal);
virtual TEKERR put_WorkFactor(unsigned int NewVal);
virtual TEKERR get_WorkFactor(unsigned int * RetVal);
virtual TEKERR put_Verbosity(unsigned int NewVal);
virtual TEKERR get_Verbosity(unsigned int * RetVal);
virtual TEKERR put_BlockSize(unsigned int NewVal);
virtual TEKERR get_BlockSize(unsigned int * RetVal);
virtual TEKERR CloseStream();
virtual TEKERR OpenStream();
virtual TEKERR get_FILE(FILE ** FileDescriptor);
virtual TEKERR get_Filename(uchar_t ** Name);
virtual TEKERR get_Mode(TekFileMode * ModeID);
virtual TEKERR get_Type(TekFileType * FileTypePointer);
virtual TEKERR put_FILE(FILE * FileDescriptor);
virtual TEKERR put_Filename(uchar_t * Name);
virtual TEKERR put_Mode(TekFileMode ModeID);

virtual TEKERR Close();
virtual TEKERR Flush();
virtual TEKERR Open();
virtual TEKERR Open64();
virtual TEKERR Read64(
	void * Buffer,
	uint64_t BytesToRead,
	uint64_t * BytesRead
);
virtual TEKERR Read(
	void * Buffer,
	unsigned long BytesToRead,
	unsigned long * BytesRead
);
virtual TEKERR Seek64(TekFileSeek SeekWhere, int64_t NewLocation);
virtual TEKERR Seek(TekFileSeek SeekWhere, signed long NewLocation);
virtual TEKERR Write64(
	void * Buffer,
	uint64_t BytesToWrite,
	uint64_t * BytesWrote
);
virtual TEKERR Write(
	void * Buffer,
	unsigned long BytesToWrite,
	unsigned long * BytesWrote
);
virtual TEKERR get_Location(unsigned long * Location);
virtual TEKERR get_Location64(uint64_t * Location);
};

#endif	/* TEKLTI_USE_BZIP2 */

#endif	/* TEKFILEBZ2ASCII_H_6CC3729C_2D12_11DA_887B_000BDBC434D9 */
