/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#define	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9

#define	TEKSTD_MAXIMPL		10

#if	defined(__cplusplus) && !defined(_cplusplus)
#define	_cplusplus	(1)
#endif	/* defined(__cplusplus) && !defined(_cplusplus) */

#ifdef	_WINDOWS
#include <windows.h>

#ifdef	LIBTEKLTI_EXPORT
#define	TEKLTI_DECLSPEC	__declspec(dllexport)
#ifdef	HAVE_CONFIG_H
#include <config.h>
#endif	/* HAVE_CONFIG_H */
#else	/* not LIBTEKLTI_EXPORT */
#define	TEKLTI_DECLSPEC	__declspec(dllimport)
#endif	/* not LIBTEKLTI_EXPORT */

#ifndef	USE_UUID_T_FROM_SYSTEM
typedef unsigned char uuid_t[16];
#endif	/* not USE_UUID_T_FROM_SYSTEM */
#else	/* not _WINDOWS */
#ifdef	LIBTEKLTI_EXPORT
#ifdef	HAVE_CONFIG_H
#include <config.h>
#endif	/* HAVE_CONFIG_H */

#ifdef	TEKLTI_NO_SIZE_T_CHECKS
#define	NO_SIZE_T_CHECKS
#endif	/* TEKLTI_NO_SIZE_T_CHECKS */

#ifdef	USE_386_ASM
#define	TEKLTI_USE_386_ASM	(1)
#else	/* not USE_386_ASM */
#ifdef	TEKLTI_USE_386_ASM
#if	TEKLTI_USE_386_ASM != 0
#define	USE_386_ASM	(1)
#endif	/* TEKLTI_USE_386_ASM != 0 */
#endif	/* TEKLTI_USE_386_ASM */
#endif	/* not USE_386_ASM */

#ifdef	USE_386_ASM_MMX
#define	TEKLTI_USE_386_ASM_MMX	(1)
#else	/* not USE_386_ASM_MMX */
#ifdef	TEKLTI_USE_386_ASM_MMX
#if	TEKLTI_USE_386_ASM_MMX != 0
#define	USE_386_ASM_MMX	(1)
#endif	/* TEKLTI_USE_386_ASM_MMX != 0 */
#endif	/* TEKLTI_USE_386_ASM_MMX */
#endif	/* not USE_386_ASM_MMX */

#ifdef	TEKLTI_ENFORCE_PRIVACY	
#define	USE_386_ASM_ENFORCE_PRIVACY	(1)
#endif	/* TEKLTI_ENFORCE_PRIVACY */

#ifdef	TEKLTI_USE_386_ASM_FPUTS_FIX1
#define	USE_386_ASM_FPUTS_FIX1	(1)
#endif	/* TEKLTI_USE_386_ASM_FPUTS_FIX1 */

#ifdef	TEKLTI_USE_386_ASM_MALLOC_FIX1
#define	USE_386_ASM_MALLOC_FIX1
#endif	/* TEKLTI_USE_386_ASM_MALLOC_FIX1 */

#ifdef	TEKLTI_USE_386_ASM_MALLOC_FIX2
#define	USE_386_ASM_MALLOC_FIX2
#endif	/* TEKLTI_USE_386_ASM_MALLOC_FIX2 */

/* Handle the uuid.h includes. */
#ifdef	TEKLTI_UUID_H_LOC
#if	TEKLTI_UUID_H_LOC == 2
#include <uuid.h>
#else	/* not TEKLTI_UUID_H_LOC == 2 */
#include <uuid/uuid.h>
#endif	/* not TEKLTI_UUID_H_LOC == 2  */
#else	/* TEKLTI_UUID_H_LOC */
#include <uuid.h>
#endif	/* TEKLTI_UUID_H_LOC */
#else	/* LIBTEKLTI_EXPORT */
#ifndef	TEKLTI_DO_NOT_INCLUDE_SYS_HEADERS
#ifdef	TEKLTI_UUID_H_NOTRAIL
#include <uuid.h>
#else	/* not TEKLTI_UUID_H_NOTRAIL */
#include <uuid/uuid.h>
#endif	/* not TEKLTI_UUID_H_NOTRAIL */
#endif	/* not TEKLTI_DO_NOT_INCLUDE_SYS_HEADERS */
#endif	/* LIBTEKLTI_EXPORT */

#define	TEKLTI_DECLSPEC

#ifndef	TEKLTI_DO_NOT_INCLUDE_SYS_HEADERS
/* Include all of the other standard includes. */
#ifdef	HAVE_STDLIB_H
#include <stdlib.h>
#endif	/* HAVE_STDLIB_H */

#ifdef	HAVE_STRINGS_H
#include <string.h>
#endif	/* HAVE_STRINGS_H */

#ifdef	HAVE_INTTYPES_H
#include <inttypes.h>
#endif	/* HAVE_INTTYPES_H */

#ifdef	HAVE_STDIO_H
#ifdef	_cplusplus
#include <iostream>
#else	/* not _cplusplus */
#include <stdio.h>
#endif	/* not _cplusplus */
#endif	/* HAVE_STDIO_H */

#ifdef	HAVE_STDINT_H
#if	HAVE_STDINT_H != 0
#include <stdint.h>
#endif	/* HAVE_STDINT_H != 0 */
#endif	/* HAVE_STDINT_H */

#ifdef	HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif	/* HAVE_SYS_STAT_H */
#endif	/* not TEKLTI_DO_NOT_INCLUDE_SYS_HEADERS */

#ifndef	TEKLTI_DO_NOT_DEFINE_INTTYPES
#ifndef	HAVE_U_INT64_T
typedef unsigned long long int u_int64_t;
#endif	/* HAVE_U_INT64_T */
#ifndef HAVE_UINT64_T
typedef unsigned long long int uint64_t;
#endif  /* HAVE_U_INT64_T */
#ifndef HAVE_INT64_T
typedef signed long long int int64_t;
#endif  /* HAVE_INT64_T */

#ifndef HAVE_U_INT32_T
typedef unsigned long u_int32_t;
#endif  /* HAVE_U_INT32_T */
#ifndef HAVE_UINT32_T
typedef unsigned long uint32_t;
#endif  /* HAVE_UINT32_T */
#ifndef HAVE_INT32_T
typedef signed long int32_t;
#endif  /* HAVE_INT32_T */

#ifndef HAVE_U_INT16_T
typedef unsigned short u_int16_t;
#endif  /* HAVE_U_INT16_T */
#ifndef HAVE_UINT16_T
typedef unsigned short uint16_t;
#endif  /* HAVE_UINT16_T */
#ifndef HAVE_INT16_T
typedef signed long int16_t;
#endif  /* HAVE_INT16_T */

#ifndef HAVE_U_INT8_T
typedef unsigned char u_int8_t;
#endif  /* HAVE_U_INT8_T */
#ifndef HAVE_UINT8_T
typedef unsigned char uint8_t;
#endif  /* HAVE_UINT8_T */
#ifndef HAVE_INT8_T
typedef signed char int8_t;
#endif  /* HAVE_INT8_T */
#endif	/* not TEKLTI_DO_NOT_DEFINE_INTTYPES */

/* Ignore next three lines; they were necessary to
   get kdevelop to generate a diagram. */
/*#if (!defined(TEKSTD_MAXIMP))
#include <
#endif*/

#endif	/* not _WINDOWS */


/*
   BZIP2 SPECS
*/

#ifdef	TEKLTI_USE_BZIP2
#ifdef	TEKLTI_USE_PROVIDED_BZIP2
#include "../bzip2/bzlib.h"
#else	/* not TEKLTI_USE_PROVIDED_BZIP2 */
#include <bzlib.h>
#endif	/* not TEKLTI_USE_PROVIDED_BZIP2 */
#endif	/* TEKLTI_USE_BZIP2 */


#ifdef	_cplusplus
extern "C"
{
#endif	/* _cplusplus */

#ifdef	COMPILING_LIBTEKLTI
/*!
Used for 64-bit values.
*/
struct i64
{
	/*!
	Lower value.
	*/
	unsigned int i64_a;
	/*!
	Upper value.
	*/
	unsigned int i64_b;
};
#endif	/* COMPILING_LIBTEKLTI */

/*
   Before defining variables, global functions, structs, and classes,
   check some of the defines to be sure that teklti.h will compile
   properly.
 */

#if	!defined(USE_386_ASM) && defined(USE_386_ASM_MMX)
#error USE_386_ASM_MMX cannot be defined unless USE_386_ASM is defined.
#endif	/* !defined(USE_386_ASM_MMX) && defined(USE_386_ASM_MMX_RESET_MM7) */

#if	!defined(USE_386_ASM_MMX) && defined(USE_386_ASM_MMX_RESET_MM7)
#error USE_386_ASM_MMX_RESET_MM7 cannot be defined unless USE_386_ASM_MMX is defined.
#endif	/* !defined(USE_386_ASM_MMX) && defined(USE_386_ASM_MMX_RESET_MM7) */


#ifdef	TEKLTI_USE_386_ASM_MMX_FPUTS_SAFE
#ifndef	TEKLTI_USE_386_ASM_FPUTS_FIX1
#error TEKLTI_USE_386_ASM_MMX_FPUTS_SAFE cannot be defined unless TEKLTI_USE_386_ASM_FPUTS_FIX1 is defined.
#endif	/* not TEKLTI_USE_386_ASM_FPUTS_FIX1 */
#define USE_386_ASM_MMX_FPUTS_SAFE	(1)
#endif	/* TEKLTI_USE_386_ASM_MMX_FPUTS_SAFE */


/**
This structure defines the uchar_t type.  A uchar_t is intended to be a standard for passing human-readable strings in ascii (and unicode, if UNICODE is defined during compilation of libTekLTI).

@author Kevin McBride
*/
typedef struct _uchar_t
{
/**
	Contains a pointer to where the ascii-version of the string is located.
*/
	char * uchar_t_ascii;
/**
	Contains the size of the memory referenced by uchar_t_ascii.
*/
	size_t uchar_t_asciilen;
#ifdef	UNICODE
/**
	Contains a pointer to where the unicode-version of the string is located.
*/
	wchar_t * uchar_t_unicode;
/**
	Contains the size of the memory referenced by uchar_t_ascii.
*/
	size_t uchar_t_unicodelen;
#endif	/* UNICODE */
} uchar_t;

/* Define the error codes and error type first. */

typedef unsigned long TEKERR;

/* Error codes are defined as follows on the octal from the right:
 0x00000000
 
 First digit:   TekStd Codes
 Second digit:  TekStd Codes
 Third digit:   System Codes
 Fourth digit:  System Codes
 Fifth digit:   System Codes
 Sixth digit:   System Codes
 Seventh digit: User Defined Codes
 Eigth digit:   User Defined Codes
 
 (64-bit NOTE: The upper 32 bits of TEKERR is User Defined Codes.)
 
 WARNING!!!!!  The user defined codes are not guaranteed to be unique!
*/

#define	TEKERR_OK		0x00000000

#define	TEKERR_NOTIMPL		0x00000001

#define	TEKERR_FAIL		0x00000002

#define	TEKERR_UNEXPECTED	0x00000004

#define	TEKERR_MEMORY		0x00000008

#define	TEKERR_ACCESS		0x00000010

#define	TEKERR_POINTER		0x00000020

#define	TEKERR_UNAVAILABLE	0x00000040

#define	TEKERR_SEQUENCE		0x00000080


#define	TEKERR_DB_CANTCONNECT	0x00000100

#define	TEKERR_DB_ACCESSDENIED	0x00000200

#define	TEKERR_DB_NOTALLOWED	0x00000400

#define	TEKERR_DB_CORRUPT	0x00000800


#define	TEKERR_FILE_DISKFULL	0x00001000

#define	TEKERR_FILE_READONLY	0x00002000
#define	TEKERR_FILE_EOF 	0x00002000

#define	TEKERR_FILE_IO  	0x00004000

#define	TEKERR_FILE_PIPE	0x00008000
#define	TEKERR_NO_SUCH_FILE	0x00008000


/* Versioning macros for the libTekLTI. */

#define	TEKLTI_VER_MAJOR	1
#define	TEKLTI_VER_MINOR	0
#define	TEKLTI_VER_REVISION	0
#define	TEKLTI_VER_PATCHNO	4
#ifdef	DEBUG
#define	TEKLTI_VER_MISCINFO	"libTekLTI 1.0-0 pre5 Debug Build"
#else	/* not DEBUG */
#define	TEKLTI_VER_MISCINFO	"libTekLTI 1.0-0 pre5"
#endif	/* not DEBUG */

#define	TEKLTI_VER_MATCH(s,m,i,r,p) (((s->TekStdGlobalVarsVersion.TekStdVerMajor >= m) && (s->TekStdGlobalVarsVersion.TekStdVerMinor >= i)) && ((s->TekStdGlobalVarsVersion.TekStdVerRev >= r) && (s->TekStdGlobalVarsVersion.TekStdVerPatchNo >= p)))


/* Now define the structures. */

/**
This structure is passed in to TekStdGetLibraryVersion by the caller.  The 
TekLTI Library will then look up the library that TekStdVerUUID represents 
and if found, calls the library's TekStdLibGetVersion() function to fill 
in the structure with.

@author Kevin McBride
*/
typedef struct TekStdVersion
{
/**
Must contain the sizeof(TekStdVersion).\n
\n
WARNING!!!!!  TekStdGetGlobalVariables() may change this value based on what it actually sets, so DO NOT rely on this value to release memory using calls that ask for amount of memory to release.
*/
	size_t TekStdVerSize;
/**
Used to figure out what library to check.\n
\n
NOTE: Not used in calls to TekStdGetGlobalVariables.
*/
	uuid_t TekStdVerUUID;
/**
1 or -1 = Version did not match\n
0 = Version matched\n
\n
NOTE: Not Used in calls to TekStdGetGlobalVariables.
*/
	int TekStdVerVersionOK;
/**
Will contain the error code in the event of an error.\n
\n
NOTE: Not used in calls to TekStdGetGlobalVariables.
*/
	TEKERR TekStdVerErrCode;
/**
Will contain the major version number.
*/
	unsigned int TekStdVerMajor;
/**
Will contain the minor version number.
*/
	unsigned int TekStdVerMinor;
/**
Will contain the revision number.
*/
	unsigned int TekStdVerRev;
/**
Will contain the patch number.
*/
	unsigned int TekStdVerPatchNo;
/**
Will contain a string bearing miscellaneous version info.
*/
	char TekStdVerMisc[64];
} _TekStdVersion;

typedef struct TekStdVersion * PTekStdVersion;

/**
This structure is passed in to TekStdCreateInstance() so that instances of
an interface(s) can be created.

@author Kevin McBride
*/
typedef struct TekStdCIInput
{
/**
Used to figure out what instance to load, as well as to make\n
sure that all interfaces selected are implemented in the\n
requested interface.  TekStdCIUUIDArray[0]
*/
	const uuid_t * TekStdCIUUIDArray;
/**
Contains amount of elements in the UUIDArray.
*/
	size_t TekStdCIUUIDArrayCount;
/**
Contains amount of instances to create.  If '0', will be\n
assumed '1'.  However, it is best to never indicate '0' here.
*/
	size_t TekStdCIInstanceCount;
/**
Contains any flags to use when creating the instance(s)
*/
	int TekStdCIFlags;
/**
Contains any error codes causing failure over creating the
particular interface shown above.
*/
	TEKERR TekStdCIError;
/**
Contains version info to use for checking against the library.
*/
	struct TekStdVersion TekStdCIVersion;
} _TekStdCIInput;

typedef struct TekStdCIInput * PTekStdCIInput;
typedef const struct TekStdCIInput * CPTekStdCIInput;

/**
This structure is passed in to TekStdCreateInstance() so that instances of
an interface(s) can be created.

@author Kevin McBride
*/
typedef struct TekStdGlobalVars
{
/**
Used as the versioning mechanism for setting up the structure.\n
\n
WARNING!!!!!  TekStdGetGlobalVariables() may change this value based on what it actually sets, so DO NOT rely on this value to release memory using calls that ask for amount of memory to release.
*/
	size_t TekStdGlobalVarsSize;
/**
Version info structure.
*/
	struct TekStdVersion TekStdGlobalVarsVersion;
/**
Maximum implementations TekStd will allow.
*/
	unsigned int TekStdGlobalVarsMaxImpl;
/**
1 if library was compiled with the Unicode option, 0 otherwise.
*/
	short TekStdGlobalVarsUnicode;
/**
1 if library was compiled with MMX code, 0 otherwise.
*/
	short TekStdGlobalVarsMMX;
/**
1 if library was compiled with MMX code, but does not reset register <b>mm7</b> to zero before nullifying a memory location.
*/
	short TekStdGlobalVarsMMXResetMM7;
/**
1 if checking internal NULLs, 0 otherwise.
*/
	short TekStdGlobalVarsInternalChecks;
/**
1 if checking passed in pointers for NULLs, 0 otherwise.
*/
	short TekStdGlobalVarsPassInPointerChecks;
/**
1 if pushing and poping esi and edi registers on use, 0 otherwise.
*/
	short TekStdGlobalVarsPushPopEnforced;
/**
1 if nullifying memory after use for intention of privacy, 0 otherwise.
*/
	short TekStdGlobalVarsPrivacyEnforced;
} _TekStdGlobalVars;


/**
This structure is the base for getting info about a computer's processor.

@author Kevin McBride
*/
typedef struct TekStdProcessorInfo
{
/**
Used as the versioning mechanism for setting up the structure.\n
\n
WARNING!!!!!  TekStdCheckProcessorFeatures() may change this value based on what it actually sets, so DO NOT rely on this value to release memory using calls that ask for amount of memory to release.
*/
	size_t TekStdProcessorInfoSize;
/**
Holds the processor type.
*/
	unsigned int TekStdProcessorInfoType;
/**
Holds the feature information.
*/
	unsigned int TekStdProcessorInfoFeatures;
/**
Holds the description information.
*/
	char TekStdProcessorInfoDesc[116];
} _TekStdProcessorInfo;


/**
This structure is the last-resort means of obtaining a UUID.

@author Kevin McBride
*/

typedef struct UUID_C
{
/**
Holds the uuid_l.
*/
	unsigned int uuid_l;
/**
Holds the uuid_s1.
*/
	unsigned short uuid_s1;
/**
Holds the uuid_s2.
*/
	unsigned short uuid_s2;
/**
Holds the uuid_s3.
*/
	unsigned short uuid_s3;
/**
Holds the uuid_c1.
*/
	unsigned char uuid_c1;
/**
Holds the uuid_c2.
*/
	unsigned char uuid_c2;
/**
Holds the uuid_c3.
*/
	unsigned char uuid_c3;
/**
Holds the uuid_c4.
*/
	unsigned char uuid_c4;
/**
Holds the uuid_c5.
*/
	unsigned char uuid_c5;
/**
Holds the uuid_c6.
*/
	unsigned char uuid_c6;
} _UUID_C;

typedef const struct UUID_C CUUID;

#define	TEKARRAY_MACRODEF	;

/**
This structure is used to maintain arrays in memory.

@author Kevin McBride
*/

typedef struct TekArray
{
/**
Holds the current size of the array.
*/
	unsigned long TekArraySize;
/**
Holds the area to access the elements in.
*/
	uint8_t ** TekArrayAccessPoint;
/**
Holds the location where the array is accessible in memory.
*/
	uint8_t * TekArrayMemoryLoc;
/**
Holds the maximum element number allowed in the array.
*/
	unsigned long TekArrayMaxElements;
/**
Holds the size of each element.
*/
	unsigned long TekArrayElementSize;
/**
Holds the item number for enumeration purposes.
*/
	unsigned long TekArrayEnumLoc;
/**
Holds the amount of references attatched to the array.
*/
	unsigned int TekArrayRef;
/**
\n
<b>TekArray Macros.</b> \n
\n
\n
<b>DEFINETEKARRAY(d)</b> - Defines a TekArray element with name of d. \n
<b>INITTEKARRAY(s, r, t)</b> - Initializes an array of size s, with each 
element r bytes long, and returns the result in t.\n
\n
<b>GETTEKARRAYELEMENT(a, i)</b> - Retrieves element number i from array a.\n
\n
<b>ADDTEKARRAYELEMENT(a, e)</b> - Adds element e to array a.\n
<b>REMOVETEKARRAYELEMENT(a, i, n)</b> - Removes element number i from array a.
 n is a unsigned long to use for the deletion. \n
<b>CLEARTEKARRAY(a)</b> - Removes all elements from array a.\n
\n
<b>ADDREFTEKARRAY(a)</b> - Adds a reference to a TekArray. \n
<b>RELEASETEKARRAY(a)</b> - Releases a reference from a TekArray, and if 0,
 the entire array is destroyed. \n
\n
<b>FOREACH_ELEMENT_IN_TEKARRAY(a, i)</b> - Starts a "for each" block, putting
 next available element in i.\n
<b>FOREACH_TEKSTD_IN_TEKARRAY(a, i)</b> - Starts a "for each" block for TekStd
elements in array a, putting next available element in i.\n
<b>ENDFOR_TEKARRAY(a)</b> - Ends a "for each" block. \n
\n
<i><b>Note:</b> These six macros should be used with arrays containing TekStd
inheriting classes.</i>\n
<b>INITTEKARRAY_TEKSTD(s, t)</b> - Initializes an array of size s, with each
element aligned for TekStd-inheriting classes, and returns the result in t.\n
<b>ADDTEKARRAYELEMENT_TEKSTD(a, e)</b> - Adds TekStd element e to array a.\n
<b>REMOVETEKARRAYELEMENT_TEKSTD(a, i, n, t)</b> - Removes TekStd element
number i from a.\n
t is a TekStd * variable to borrow.\n
<b>CLEARTEKARRAY_TEKSTD(a, n, t)</b> - Removes all TekStd elements from array
a.\n
n is a unsigned long to use for the releasing.\n
t is a TekStd * variable to borrow.\n
<b>ADDREFTEKARRAY_TEKSTD(a)</b> - Adds a reference to a TekArray.\n
<b>RELEASETEKARRAY_TEKSTD(a, n, t)</b> - Releases a reference from a
TekArray, and if 0, the entire array is destroyed, and all references to held
TekStd interfaces are Released.
*/
TEKARRAY_MACRODEF;
} _TekArray;


/**
This structure is used to generate a TekUser instance.

@author Kevin McBride
*/
typedef struct TekUserInfo
{
/**
Used to determine whether or not the structure can be used,
so this variable needs to be set to sizeof(struct TekUserInfo).
*/
	unsigned long TekUserInfo_Size;
/**
The related TekUserDB, for writing data.  If NULL, no writing
will be allowed by the created instance.
*/
	void * TekUserInfo_DB;
/**
The description, usually the full name, of the user.
*/
	uchar_t * TekUserInfo_Description;
/**
The username of the user.
*/
	uchar_t * TekUserInfo_Username;
/**
The home directory of the user.
*/
	uchar_t * TekUserInfo_HomeDir;
/**
The userid of the user.
*/
	uid_t TekUserInfo_UserID;
/**
The primary groupid of the user.
*/
	gid_t TekUserInfo_GroupID;
/**
The password of the user.  Will always be set to NULL.
*/
	uchar_t * TekUserInfo_Password;
} _TekUserInfo;


/* Let's define our variables. */

#ifdef	USE_386_ASM
/* The below externs helps out in assembly. */
extern const void * tek_asm_null;

extern uint64_t tekzerovar;
#endif	/* USE_386_ASM */


/* Now, to define the functions. */

extern void _mkuuid_t (
	const char *,
	uuid_t
);

extern uchar_t * char2uchar ( const char * );

extern uchar_t * char2ucharlen ( const char *, size_t );

extern void ucharempty ( uchar_t * );

extern uchar_t * uchardup ( const uchar_t * );

#define	uchar2char(uchr)	uchr->uchar_t_ascii

#ifdef	UNICODE
#define	mkucharnull(uchr, extradw) \
uchr.uchar_t_ascii = NULL; \
uchr.uchar_t_unicode = NULL \
uchr.uchar_t_asciilen = uchr.uchar_t_unicodelen = 0;
#else	/* not UNICODE */
#define	mkucharnull(uchr, extradw) \
uchr.uchar_t_ascii = NULL; \
uchr.uchar_t_asciilen = 0;
#endif	/* not UNICODE */


#ifdef	USE_386_ASM_MMX_RESET_MM7
#define	tekresetmm7	__asm__ ( " movq %0, %%mm7 " : "=m" (tekzerovar) )
#define	tekresetmm7withemms \
tekresetmm7; \
__asm__ ( " emms " );
#else	/* not USE_386_ASM_MMX_RESET_MM7 */
#define	tekresetmm7	;
#define	tekresetmm7withemms	;
#endif	/* not USE_386_ASM_MMX_RESET_MM7 */


extern TEKERR TekStdGetLibraryVersion (
	PTekStdVersion *,
	size_t
);
extern TEKERR TekStdCreateInstance (
	CPTekStdCIInput,
	size_t,
	void **,
	size_t,
	const uuid_t *,
	size_t,
	unsigned int,
	PTekStdVersion
);
extern TEKERR TekStdGetGlobalVariables ( 
	struct TekStdGlobalVars *
);


#ifndef	ANSI_ONLY
TEKLTI_DECLSPEC void _mkuuid_t (
	const char * uuid_str,
	uuid_t uuid_raw
);

TEKLTI_DECLSPEC uchar_t * char2uchar ( const char * src );

TEKLTI_DECLSPEC uchar_t * char2ucharlen ( const char * src, size_t len );

TEKLTI_DECLSPEC void ucharempty ( uchar_t * uchrtofree );

TEKLTI_DECLSPEC uchar_t * uchardup ( const uchar_t * src );

TEKLTI_DECLSPEC TEKERR TekStdGetLibraryVersion (
	PTekStdVersion * VersionStruct,
	size_t VersionStructCount
);
TEKLTI_DECLSPEC TEKERR TekStdCreateInstance (
	CPTekStdCIInput InterfaceStructs,
	size_t InterfaceStructCount,
	void ** InstanceArray,
	size_t InstanceArrayCount,
	const uuid_t * UUIDArray,
	size_t UUIDArrayCount,
	unsigned int Flags,
	PTekStdVersion VersionStruct
);

TEKLTI_DECLSPEC TEKERR TekStdGetGlobalVariables ( 
	struct TekStdGlobalVars * RetVal
);

#endif	/* not ANSI_ONLY */

#ifdef	_cplusplus
}

/*
Now for the macros defining things.
*/

/*
------------
UUID Macros.
------------

MKTEKUUID(name, s) - Turns a string UUID into a string with a variable.
TEKUUIDIMPORT(name) - Imports a string UUID from a library.  Usually
                      found in an instance's header file.
GETTEKUUID(name, ret) - Convert string UUID made from the MKTEKUUID or
                        TEKUUIDIMPORT macros to a binary UUID.
*/

#define	MKTEKUUID(name, s)	const char name[] = s;

#define TEKUUIDIMPORT(name)	extern const char name[];

#define GETTEKUUID(name, ret)	_mkuuid_t(name, ret);

/*
--------------------
TekFileASCII Macros.
--------------------
 
TEKFILEASCII_STDBUFLEN - (size_t)ASCII Standard Buffer Length.
*/

#define	TEKFILEASCII_STDBUFLEN	1024


/*
-----------------
Debugging Macros.
-----------------

MKTEKDEBUGSTRING(name, s) - Turns string s into a string with
                            a variable as long as debug is on.
TEKDEBUGSTRING(name) - Retrieves string from a variable.
*/

#ifdef	DEBUG_USE_FERROR
#define	MKTEKDEBUGSTRING(name, s) \
static const char name[] = s;

#define	TEKDEBUGSTRING(name)	name
#else	/* not DEBUG_USE_FERROR */
#define	MKTEKDEBUGSTRING(name, s)

#define	TEKDEBUGSTRING(name)
#endif	/* not DEBUG_USE_FERROR */


/*
----------------
TekArray Macros.
----------------

DEFINETEKARRAY(d) - Defines a TekArray element with name of d.
INITTEKARRAY(s, r, t) - Initializes an array of size s, with each element
                        r bytes long, and returns the result in t.

GETTEKARRAYELEMENT(a, i) - Retrieves element number i from array a.

ADDTEKARRAYELEMENT(a, e) - Adds element e to array a.
REMOVETEKARRAYELEMENT(a, i, n) - Removes element number i from array a.
                                 n is a unsigned long to use for the deletion.
CLEARTEKARRAY(a) - Removes all elements from array a.

ADDREFTEKARRAY(a) - Adds a reference to a TekArray.
RELEASETEKARRAY(a) - Releases a reference from a TekArray, and if 0,
                     the entire array is destroyed.

FOREACH_ELEMENT_IN_TEKARRAY(a, i) - Starts a "for each" block, putting
                                    next available element in i.
FOREACH_TEKSTD_IN_TEKARRAY(a, i) - Starts a "for each" block for TekStd
                                   elements in array a, putting next
                                   available element in i.
ENDFOR_TEKARRAY(a) - Ends a "for each" block.

Note: These six macros should be used with arrays containing TekStd
inheriting classes.
INITTEKARRAY_TEKSTD(s, t) - Initializes an array of size s, with each
                            element aligned for TekStd-inheriting classes,
                            and returns the result in t.
ADDTEKARRAYELEMENT_TEKSTD(a, e) - Adds TekStd element e to array a.
REMOVETEKARRAYELEMENT_TEKSTD(a, i, n, t) - Removes TekStd element number i
                                           from a.
                                           t is a TekStd * variable to borrow.
CLEARTEKARRAY_TEKSTD(a, n, t) - Removes all TekStd elements from array a.
                                n is a unsigned long to use for the releasing.
                                t is a TekStd * variable to borrow.
ADDREFTEKARRAY_TEKSTD(a) - Adds a reference to a TekArray.
RELEASETEKARRAY_TEKSTD(a, n, t) - Releases a reference from a TekArray, and if
                            0, the entire array is destroyed, and all
                            references to held TekStd interfaces are Released.
*/

#define	DEFINETEKARRAY(d)	struct TekArray d;

#define	INITTEKARRAY(s, r, t) \
if ( ( t = (struct TekArray *)malloc(sizeof(struct _TekArray)) ) != NULL ) \
{ \
  if ( ( t->TekArrayAccessPoint = t->TekArrayMemoryLoc = \
       (uint8_t *)calloc(s, r) ) != NULL ) \
  { \
    t->TekArraySize = t->TekArrayEnumLoc = 0; \
    t->TekArrayMax = s;  \
    t->TekArrayRef = 1; \
  } else { \
    free(t); t = NULL;  \
  } \
}

#define	INITTEKARRAY_TEKSTD(s, t)	INITTEKARRAY(s, sizeof(TekStd *), t)

#define	GETTEKARRAYELEMENT(a, i)	= \
    (void *)a->TekArrayAccessPoint[i * a->TekArrayElementSize]

#define	ADDTEKARRAYELEMENT(a, e) \
if ( a->TekArraySize < a->TekArrayMaxElements ) { \
a->TekArraySize++; \
memcpy( \
  a->TekArrayAccessPoint[a->TekArraySize * a->TekArrayElementSize], \
  e, \
  a->TekArrayElementSize \
); \
}

#define	REMOVETEKARRAYELEMENT(a, i, n) \
if ( i <= TekArraySize ) { \
for ( n=i; n < a->TekArraySize; n++ ) \
{ \
  memcpy( \
    a->TekArrayAccessPoint[n * a->TekArrayElementSize], \
    a->TekArrayAccessPoint[(n * a->TekArrayElementSize)+1], \
    a->TekArrayElementSize); \
  ); \
} \
memset( \
  a->TekArrayAccessPoint[a->TekArraySize * a->TekArrayElementSize], \
  '\0', \
  a->TekArrayElementSize \
); \
a->TekArraySize--; \
}

#define	CLEARTEKARRAY(a) \
memset( \
  a->TekArrayMemoryLoc, \
  '\0', \
  a->TekArrayElementSize * a->TekArrayMaxElements \
); \
a->TekArraySize = 0;


#define	ADDTEKARRAYELEMENT_TEKSTD(a, e) \
e->AddRef(); \
ADDTEKARRAYELEMENT(a, e)

#define	REMOVETEKARRAYELEMENT_TEKSTD(a, i, n, t) \
t = (TekStd *)a->TekArrayAccessPoint[n]; \
t->Release(); \
REMOVETEKARRAYELEMENT(a, i, n)

#define	CLEARTEKARRAY_TEKSTD(a, n, t) \
for ( n=0; n <= a->TekArraySize; n++ ) \
{ \
  t = (TekStd *)a->TekArrayAccessPoint[n * sizeof(TekStd *)]; \
  t->Release(); \
} \
CLEARTEKARRAY(a)


#define	ADDREFTEKARRAY(a)	a->TekArrayRef++;

#define	RELEASETEKARRAY(a) \
a->TekArrayRef--; \
if ( a->TekArrayRef == 0 ) \
{ \
  CLEARTEKARRAY(a) \
  free(a->TekArrayMemoryLoc); free(a); \
}

#define	ADDREFTEKARRAY_TEKSTD(a)	a->TekArrayRef++;

#define	RELEASETEKARRAY_TEKSTD(a, n, t) \
a->TekArrayRef--; \
if ( a->TekArrayRef == 0 ) \
{ \
  CLEARTEKARRAY_TEKSTD(a) \
  free(a->TekArrayMemoryLoc); free(a); \
}

#define	FOREACH_ELEMENT_IN_TEKARRAY(a, i) \
for ( a->TekArrayEnumLoc=0; a->TekArrayEnumLoc <= a->TekArraySize; a++ ) \
{ \
  i = (void *)a->TekArrayAccessPoint[a->TekArrayEnumLoc * \
    a->TekArrayElementSize]; \
  if ( i == NULL ) \
    break;

#define	FOREACH_TEKSTD_IN_TEKARRAY(a, i) \
for ( a->TekArrayEnumLoc=0; a->TekArrayEnumLoc <= a->TekArraySize; a++ ) \
{ \
  i = (void *)a->TekArrayAccessPoint[a->TekArrayEnumLoc * \
    sizeof(TekStd *)]; \
  if ( i == NULL ) \
    break;

#define	ENDFOR_TEKARRAY(a)	}

/*
---------------------
Implementation Macros
---------------------

TEKSTD_IMPLEMENT_BEGIN(name) - Predefines the interface we're working on.
TEKSTD_IMPLEMENT_INTERFACE(name) - Predefines a derived class.
TEKSTD_IMPLEMENT_END - Compile all the predefines into a single array.
TEKSTD_IMPLEMENT_FREE - Frees the array when the destructor is called.

*_MYSELF - Same as above, but uses "this->" strictly.
*/
#define	TEKSTD_IMPLEMENT_BEGIN \
this->__uuidbeginsize = 1; \
this->__uuidbegin = (uuid_t *)calloc(TEKSTD_MAXIMPL, sizeof(uuid_t)); \
if ( __uuidbegin == NULL ) \
	throw; \
_mkuuid_t(UTekStd, this->__uuidbegin[0]);

#define	TEKSTD_IMPLEMENT_BEGIN_MYSELF \
TEKSTD_IMPLEMENT_BEGIN

#ifdef	NO_SIZE_T_CHECKS
#define	TEKSTD_IMPLEMENT_INTERFACE(name) \
_mkuuid_t(name, TekStd::__uuidbegin[TekStd::__uuidbeginsize]); \
TekStd::__uuidbeginsize++;
#define	TEKSTD_IMPLEMENT_INTERFACE_MYSELF(name) \
_mkuuid_t(name, this->__uuidbegin[this->__uuidbeginsize]); \
this->__uuidbeginsize++;
#else /* not NO_SIZE_T_CHECKS */
#define	TEKSTD_IMPLEMENT_INTERFACE(name) \
if ( TekStd::__uuidbeginsize >= TEKSTD_MAXIMPL ) {\
	throw; }\
_mkuuid_t(name, TekStd::__uuidbegin[TekStd::__uuidbeginsize]); \
TekStd::__uuidbeginsize++;
#define	TEKSTD_IMPLEMENT_INTERFACE_MYSELF(name) \
if ( this->__uuidbeginsize >= TEKSTD_MAXIMPL ) {\
	throw; }\
_mkuuid_t(name, this->__uuidbegin[this->__uuidbeginsize]); \
this->__uuidbeginsize++;
#endif	/* not NO_SIZE_T_CHECKS */

/*TekStd::__uuidarray = (uuid_t *)realloc( \
	(void *)TekStd::__uuidbegin, \
	sizeof(uuid_t) * TekStd::__uuidbeginsize \
);*/
#define	TEKSTD_IMPLEMENT_ENDBASE \
TekStd::__uuidarray = (uuid_t *)TekStd::__uuidbegin; \
TekStd::__uuidarraycount = TekStd::__uuidbeginsize;
#define	TEKSTD_IMPLEMENT_ENDBASE_MYSELF \
this->__uuidarray = (uuid_t *)this->__uuidbegin; \
this->__uuidarraycount = this->__uuidbeginsize;

#define	TEKSTD_IMPLEMENT_ENDVARS \
TekStd::__instancecount = 1;
/* this->__uuidarraycount = __uuidbeginsize; */
#define	TEKSTD_IMPLEMENT_ENDVARS_MYSELF \
this->__instancecount = 1;

#define	TEKSTD_IMPLEMENT_FREE \
free(this->__uuidarray);

#define	TEKSTD_IMPLEMENT_END \
TEKSTD_IMPLEMENT_ENDBASE \
TEKSTD_IMPLEMENT_ENDVARS
#define	TEKSTD_IMPLEMENT_END_MYSELF \
TEKSTD_IMPLEMENT_ENDBASE_MYSELF \
TEKSTD_IMPLEMENT_ENDVARS_MYSELF

/*
----------------------------
TekStd Implementation Macros
----------------------------

TEKSTD_HEADER_VARS - Private variable template for any interface
                     implementing TekStd.  To be put in headers.
TEKSTD_HEADER_VARSANDFUNC(cls) - Variable and function template.
                                 To be put in headers.
TEKSTD_SOURCE_FUNC - Function template including source code for
                     implementing the TekStd interface.  The
                     macro is intended to be used in source files.
TEKSTD_SOURCE_FUNC_CALLFUNC - Function template including source
                              code for "TEKERR_NOTIMPL" retval of
                              CallFunc().
TEKSTD_PUREVIRTUAL_FUNC_V1 - Used to define virtual functions for
                             TekStd in a more clean manner.
TEKSTD_CHECKFOR_UUIDNO - Retrieves the UUIDArray element number
                         that caused CheckFor() to fail.
TEKSTD_CHECKFOR_ERRNO - Retrieves the error number that explains
                        why CheckFor() failed.
*/

#define	TEKSTD_HEADER_VARS \
protected: \
uuid_t * __uuidarray; \
uuid_t * __uuidbegin; \
uuid_t __uuidtmp; \
size_t __uuidarraycount; \
size_t __uuidbeginsize; \
unsigned int __instancecount;

#define	TEKSTD_HEADER_FUNC(cls) \
public: \
\
virtual unsigned int AddRef(); \
virtual TEKERR CheckFor( \
	const uuid_t * UUIDArray, \
	size_t UUIDArraySize, \
	unsigned short Flags = 0x0000, \
	void ** RetVal = (void **)NULL, \
	unsigned int ** RefCountPtrRet = (unsigned int **)NULL \
); \
virtual unsigned int Release(); \
virtual TEKERR CallFunc( \
	const uchar_t * FuncName, \
	void * RetVal, \
	unsigned short ParamsCount, \
	void ** Params \
);

#define	TEKSTD_PUREVIRTUAL_FUNC_V1 \
virtual TEKERR CallFunc(const uchar_t* FuncName, void* RetVal, unsigned short ParamsCount, void** Params) = 0; \
virtual TEKERR CheckFor(const uuid_t* UUIDArray, size_t UUIDArraySize, unsigned short Flags, void** RetVal, unsigned int** RefCountPtrRet) = 0; \
virtual unsigned int AddRef() = 0; \
virtual unsigned int Release() = 0;

#define	TEKSTD_HEADER_VARSANDFUNC(cls) \
TEKSTD_HEADER_VARS \
TEKSTD_HEADER_FUNC(cls)

#ifdef	NO_SIZE_T_CHECKS
#define	TEKSTD_SOURCE_FUNC_CHECKFOR(cls)
#else	/* not NO_SIZE_T_CHECKS */
#ifdef	DEBUG_USE_FERROR
#define	TEKSTD_SOURCE_FUNC_CHECKFOR \
if ( UUIDArray == NULL ) { \
	fprintf( \
		stderr, \
		"POTENTIAL SEGFAULT in interface %s, function CheckFor(): UUIDArray is null!\n", \
		"TekStd" \
	); \
	return TEKERR_POINTER; \
} \
\
if ( Flags ) { \
	if ( RetVal == NULL ) { \
	fprintf( \
		stderr, \
		"POTENTIAL SEGFAULT in interface %s, function CheckFor(): RetVal is null!\n", \
		"TekStd" \
	); \
	return TEKERR_POINTER; \
} \
}
#else	/* not DEBUG_USE_FERROR */
#define	TEKSTD_SOURCE_FUNC_CHECKFOR \
if ( UUIDArray == NULL ) { \
	return TEKERR_POINTER; \
} \
\
if ( Flags ) { \
	if ( RetVal == NULL ) { \
	return TEKERR_POINTER; \
} \
}
#endif	/* not DEBUG_USE_FERROR */
#endif	/* not NO_SIZE_T_CHECKS */

#define	TEKSTD_SOURCE_FUNC_CALLFUNC(cls) \
TEKERR cls::CallFunc( \
	const uchar_t * FuncName, \
	void * RetVal, \
	unsigned short ParamsCount, \
	void ** Params \
) { \
	return TEKERR_NOTIMPL; \
}

#define	TEKSTD_SOURCE_FUNC(cls) \
unsigned int cls::AddRef() { this->__instancecount++; return this->__instancecount; } \
TEKERR cls::CheckFor( \
	const uuid_t * UUIDArray, \
	size_t UUIDArraySize, \
	unsigned short Flags, \
	void ** RetVal, \
	unsigned int ** RefCountPtrRet \
) { \
	TEKERR result; \
	size_t i; \
	size_t j; \
	TEKSTD_SOURCE_FUNC_CHECKFOR \
	for ( i=0; i < UUIDArraySize; i++ ) \
	{ \
		for ( j=0; j < this->__uuidarraycount; j++ ) \
			if ( uuid_compare(this->__uuidarray[j], UUIDArray[i]) == 0 ) \
				goto FoundUUID; \
\
		i++; \
		result = i << (8 * sizeof(short)); \
		result |= TEKERR_NOTIMPL; \
		return result; \
FoundUUID: \
		; \
	} \
\
	if ( Flags ) { \
		this->AddRef(); \
		*RetVal = this; \
	} \
\
	if ( RefCountPtrRet != (unsigned int **)NULL ) \
		*RefCountPtrRet = &this->__instancecount; \
\
	return TEKERR_OK; \
} \
unsigned int cls::Release() { \
	this->__instancecount--; \
	if ( this->__instancecount == 0 ) \
	{ \
		delete this; \
		return 0; \
	} \
	return this->__instancecount; \
} \
TEKSTD_SOURCE_FUNC_CALLFUNC(cls)

#define	TEKSTD_CHECKFOR_UUIDNO(err)	(unsigned short)((err >> 8 * sizeof(short))
#define	TEKSTD_CHECKFOR_ERRNO(err)	(unsigned short)((err << 8 * sizeof(short))



TEKUUIDIMPORT(UTekStd);

/**
 * The official TekStd interface.
 *
 * This interface defines the standard for, at minimum, passing interface
 * pointers to something that is referencable to any function requiring an
 * interface instantizable from the teklti library.
 *
 * This interface is <b>INHERITABLE</b>.
 *
 * @author Kevin McBride
*/
class TekStd
{
TEKSTD_HEADER_VARS
public:
/**
Instantizer.
*/
TekStd();
/**
Destructor.
*/
~TekStd();
#ifndef	TEKSTD_INTERNAL
/**
Adds a reference to the instance.
*/
virtual unsigned int AddRef();
/**
Checks the instance for support of a particular set of interfaces.\n
\n
If RetVal != NULL and Flags are set to 1, then CheckFor() will create a pointer to the instance and set it in the memory reference provided by RetVal.\n
\n
Unlike most functions, CheckFor() will return a TEKERR value based on the return condition:\n
\n
- On sucessful completion, a flat TEKERR_OK is returned in the TEKERR value.\n
\n
- If RetVal is NULL when Flags is 1, a flat TEKERR_POINTER may be returned in the TEKERR value.\n
\n
- If an element in UUIDArray is not found in <b>__uuidarray</b>, TEKERR will be set as follows:\n
  <b>0x00020001</b>\n
  Where <b>0x0001</b> is set to TEKERR_NOTIMPL, cast to an unsigned short.\n
  Where <b>0x0002</b> will be set to the array element causing the error.\n
  So, in the above example, it reads "UUIDArray[1] did not match anything in __uuidarray." \n
  <i>TEKLTI_CHECKFOR_FAILING_ELEMENT(i)</i> can be used to retrieve the element number,
but only works when the TEKERR_NOTIMPL error occurs.
*/
virtual TEKERR CheckFor(
	const uuid_t * UUIDArray,
	size_t UUIDArraySize,
	unsigned short Flags = 0x0000,
	void ** RetVal = (void **)NULL,
	unsigned int ** RefCountPtrRet = (unsigned int **)NULL
);
/**
Removes a reference to the instance.
*/
virtual unsigned int Release();
/**
Calls a function in the instance.\n
Useful when trying to test for a feature.\n
WARNING!  Use of this function will cause speed to suffer!\n
In addition, it can't guarantee that a certain interface is\n
derived from TekStd.
*/
virtual TEKERR CallFunc(
	const uchar_t * FuncName,
	void * RetVal,
	unsigned short ParamsCount,
	void ** Params
);
#endif	/* not TEKSTD_INTERNAL */
};


#ifdef	COMPILING_LIBTEKLTI
/*
  START INTERNAL INCLUSIONS
*/
/*
  from TekEnum:
*/
#include "tekenum.h"

/*
  from TekFile*:
*/
#include "tekfile.h"
#include "tekfilebinary.h"
#include "tekfileascii.h"
#include "tekfileasciibare.h"

/*
  from TekUser*:
*/
#include "tekuser.h"
#include "tekuserunixro.h"
#include "tekuserunixrw.h"

/*
  from TekUserDB*:
*/
#include "tekuserdb.h"
#ifdef	_WINDOWS
#include "tekuserdbwindows.h"
#endif	/* not _WINDOWS */
#include "tekuserdbunix.h"

/*
  from TekStatFile*:
*/
#include "tekstatfile.h"
#include "tekstatfileposix.h"

/*
  from TekFileBZ2* (BZIP2 specifics)
*/
#ifdef	TEKLTI_USE_BZIP2
#include "tekfilebz2.h"
#include "tekfilebz2binary.h"
#include "tekfilebz2ascii.h"
#endif	/* TEKLTI_USE_BZIP2 */
#else	/* not COMPILING_LIBTEKLTI */
/*
  START INTERNAL INCLUSIONS
*/
/*
  from TekEnum:
*/
#include <tekenum.h>

/*
  from TekFile*:
*/
#include <tekfile.h>
#include <tekfilebinary.h>
#include <tekfileascii.h>
#include <tekfileasciibare.h>

/*
  from TekUser*:
*/
#include <tekuser.h>
#include <tekuserunixro.h>
#include <tekuserunixrw.h>

/*
  from TekUserDB*:
*/
#include <tekuserdb.h>
#ifdef	_WINDOWS
#include <tekuserdbwindows.h>
#endif	/* not _WINDOWS */
#include <tekuserdbunix.h>

/*
  from TekStatFile*:
*/
#include <tekstatfile.h>
#include <tekstatfileposix.h>

/*
  from TekFileBZ2* (BZIP2 specifics)
*/
#ifdef	TEKLTI_USE_BZIP2
#include <tekfilebz2.h>
#include <tekfilebz2binary.h>
#include <tekfilebz2ascii.h>
#endif	/* TEKLTI_USE_BZIP2 */
#endif	/* not COMPILING_LIBTEKLTI */
#else	/* not _cplusplus */
/* -------------------------
   Now, for our TekFileType.
   ------------------------- */
typedef unsigned int TekFileType;

#define	TekFileType_Binary		0x0000
#define	TekFileType_ASCII		0x0001
#define	TekFileType_ConfigASCII 	0x0002
#define	TekFileType_UNICODE		0x0004
#define	TekFileType_ConfigUNICODE	0x0008
#define	TekFileType_BinaryPipe  	0x0010
#define	TekFileType_ASCIIPipe   	0x0020
#define	TekFileType_UnicodePipe 	0x0040
#define	TekFileType_BZIP2		0x0100

TEKLTI_DECLSPEC TEKERR TekFileCreate(TekFileType FileType, void ** RetVal, uchar_t * FileName);


/* -------------------------
   Now, for our TekUserType.
   ------------------------- */

typedef unsigned int TekUserType;

#define	TekUserType_Any  	0x0000
#define	TekUserType_POSIX	0x0001
#define	TekUserType_Linux	0x0002
#define	TekUserType_Windows	0x0004

TEKLTI_DECLSPEC TEKERR TekUserInfoCreate(
	struct TekUserInfo * UserInfo,
	void ** RetVal,
	TekUserType UserType
);
#endif	/* not _cplusplus */

#define	TEKLTI_CHECKFOR_FAILING_ELEMENT(i)	i >> 16

#ifdef	TEKLTI_USE_386_ASM
#ifdef	COMPILING_LIBTEKLTI
#include "teklti386.h"
#else	/* not COMPILING_LIBTEKLTI */
#include <teklti386.h>
#endif	/* not COMPILING_LIBTEKLTI */
#else	/* not TEKLTI_USE_386_ASM */
#define	TekStdCheckAndRecieveProcessorInfo(a, b, c)	;

typedef	void * TekStdProcessorInfoGeneric;
#endif	/* not TEKLTI_USE_386_ASM */

#endif	/* not TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */

