/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*
	This file contains intel-specific function prototypes and
	structures for use with the libTekLTI, mostly for checking
	features of a processor.
*/


#ifndef	TEKLTI386_H_01EF7B32_F612_11D9_8CCC_000BDBC434D9
#define	TEKLTI386_H_01EF7B32_F612_11D9_8CCC_000BDBC434D9

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>, or have <teklti.h> declared first.
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */


/* First, we need to define the structures. */

#ifdef	_cplusplus
extern "C"
{
#endif	/* _cplusplus */
/**
This structure is used for getting info about an intel (or compatible) processor.

@author Kevin McBride
*/
typedef struct TekStdProcessorInfoIntel
{
/**
Used as the versioning mechanism for setting up the structure.\n
\n
WARNING!!!!!  TekStdCheckProcessorFeatures() will change this value to TEKSTD_PROCESSOR_INTEL, so do not rely on this value to free memory!
*/
	size_t TekStdProcessorInfoSize;
/**
Holds the processor type.
*/
	unsigned int TekStdProcessorInfoType;
/**
Holds the feature information.
*/
	unsigned int TekStdProcessorInfoFeatures;
/**
Holds the description information.
*/
	char TekStdProcessorInfoDesc[116];
/**
Holds the cache and TLB info.
*/
	unsigned long TekStdProcessorInfoTLB[32];
} _TekStdProcessorInfoIntel;

/* Second, we need to define the prototypes. */

typedef int (TEKSTDPROCESSORINFO_FAIL_CALLBACK)(void);

TEKERR TekStdCheckAndRecieveProcessorInfoIntel (
	struct TekStdProcessorInfoIntel * ProcessorInfoArray,
	size_t ProcessorInfoArrayCount,
	TEKSTDPROCESSORINFO_FAIL_CALLBACK * CallbackFunction
);

/* Third, define the generics to assist in code compatibility. */

#define	TekStdCheckAndRecieveProcessorInfo	TekStdCheckAndRecieveProcessorInfoIntel

typedef	struct TekStdProcessorInfoIntel TekStdProcessorInfoGeneric;


/* Finally, define some macros to make programming libTekLTI a bit easier. */

#if	TEKERR_OK == 0x00000000
#define	TEKLTI_RETVAL_TEKERR_OK \
__asm__ ( "xorl %eax, %eax" );
#else
#define	TEKLTI_RETVAL_TEKERR_OK \
__asm__ ( " movl %1, %%eax " : "=m" (_tfbtmp) : "i" (TEKERR_OK) );
#endif

/*
  NOTE: The defining of PUSHPOP is a TEMPORARY change.
*/

#ifndef	USE_386_ASM_PUSHPOP
#define	USE_386_ASM_PUSHPOP	(1)
#endif	/* not USE_386_ASM_PUSHPOP */

#ifdef	_cplusplus
}
#endif	/* _cplusplus */

#endif	/* TEKLTI386_H_01EF7B32_F612_11D9_8CCC_000BDBC434D9 */


