/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef TEKSTATFILE_H_E369BDA_3789_11DA_8436_000BDBC434D9
#define TEKSTATFILE_H_E369BDA_3789_11DA_8436_000BDBC434D9

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */


TEKUUIDIMPORT(UTekStatFile)



/**
This interface defines the standard for copying and testing files, as well as viewing file information as it stands on a device.\n
\n
This interface is <b>INHERITABLE</b>.\n
\n
<b>NOTE:</b> Most interfaces implementing TekStatFile might give out a TEKERR_ACCESS if
you do not put_Filename() or put_FILE().
 
@author Kevin McBride
*/
class TekStatFile : public TekStd
{
public:
  TekStatFile();
  ~TekStatFile();

  TEKSTD_PUREVIRTUAL_FUNC_V1

  virtual TEKERR put_Filename(const uchar_t * Filename) = 0;
  virtual TEKERR put_FILE(FILE * FileDescriptor) = 0;
  virtual TEKERR put_UserInfoToAccess(uuid_t * UUIDOfUserInfo) = 0;

  virtual TEKERR MakeTekFile(TekFileType TekType, TekFile ** RetVal) = 0;

  virtual TEKERR get_Dev(dev_t * Dev) = 0;
  virtual TEKERR get_DevNo(dev_t * DevNo) = 0;
  virtual TEKERR get_FileSerialNo(ino_t * SerialNo) = 0;
  virtual TEKERR get_Mode(mode_t * FileMode) = 0;
  virtual TEKERR get_ModeString(uchar_t ** FileModeString) = 0;
  virtual TEKERR put_Mode(mode_t NewFileMode) = 0;
  virtual TEKERR put_ModeString(const uchar_t * NewFileModeString) = 0;
  virtual TEKERR get_LinkCount(nlink_t * LinkCount) = 0;
  virtual TEKERR get_UID(uid_t * UID) = 0;
  virtual TEKERR put_UID(uid_t UID) = 0;
  virtual TEKERR get_GID(gid_t * GID) = 0;
  virtual TEKERR put_GID(gid_t GID) = 0;
  virtual TEKERR get_UIDString(uchar_t ** UIDString) = 0;
  virtual TEKERR put_UIDString(const uchar_t * UIDString) = 0;
  virtual TEKERR get_GIDString(uchar_t ** GIDString) = 0;
  virtual TEKERR put_GIDString(const uchar_t * GIDString) = 0;
  virtual TEKERR get_Size(unsigned long * FileSize) = 0;
  virtual TEKERR get_Size64(uint64_t * FileSize) = 0;
  virtual TEKERR get_BlockSize(blksize_t * FileBlockSize) = 0;
  virtual TEKERR get_BlockCount(blkcnt64_t * FileBlockCount) = 0;
  virtual TEKERR get_TimeOfLastAccessRaw(unsigned long ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastModificationRaw(unsigned long ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastStatChangeRaw(unsigned long ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastAccess(uchar_t ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastModification(uchar_t ** RetVal) = 0;
  virtual TEKERR get_TimeOfLastStatChange(uchar_t ** RetVal) = 0;
  //virtual TEKERR 
};

#endif /* TEKSTATFILE_H_E369BDA_3789_11DA_8436_000BDBC434D9 */
