/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TEKUSER_H_061B46F4_3D58_11DA_9D30_000BDBC434D9
#define TEKUSER_H_061B46F4_3D58_11DA_9D30_000BDBC434D9

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */


TEKUUIDIMPORT(UTekUser);


enum TekUserType
{
	TekUserType_Any = 0x0000,
	TekUserType_POSIX = 0x0001,
	TekUserType_Linux = 0x0002,
	TekUserType_POSIX_RO = 0x0004,
	TekUserType_Linux_RO = 0x0008,
	TekUserType_Windows = 0x0010
};


/**
This interface defines the standard for accessing information about a user.
 
This interface is <b>INHERITABLE</b>.
 
@author Kevin McBride
*/
class TekUser : public TekStd
{
public:
  TekUser();
  ~TekUser();

    virtual TEKERR put_TekUserInfo(struct TekUserInfo * SUInfo) = 0;
    virtual TEKERR put_Description(const uchar_t * NewDescription) = 0;
    virtual TEKERR get_Description(uchar_t ** RetVal) = 0;
    virtual TEKERR get_GroupID(gid_t * RetVal) = 0;
    virtual TEKERR get_HomeDir(uchar_t ** RetVal) = 0;
    virtual TEKERR get_UserID(uid_t * RetVal) = 0;
    virtual TEKERR get_Username(uchar_t ** RetVal) = 0;
    virtual TEKERR put_GroupID(gid_t NewGroupID) = 0;
    virtual TEKERR put_HomeDir(const uchar_t * NewHomeDir) = 0;
    virtual TEKERR put_Password(uchar_t * NewPassword) = 0;
    virtual TEKERR put_UserID(uid_t NewID) = 0;
    virtual TEKERR put_Username(const uchar_t * NewUsername) = 0;
    virtual TEKERR Save() = 0;

};


TEKLTI_DECLSPEC TEKERR TekUserInfoCreate(
	struct TekUserInfo * UserInfo,
	TekUser ** RetVal,
	TekUserType UserType = TekUserType_Any
);

#endif /* TEKUSER_H_061B46F4_3D58_11DA_9D30_000BDBC434D9 */

