/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TEKUSERDBUNIX_H_714F5DDE_4280_11DA_9100_000BDBC434D9
#define TEKUSERDBUNIX_H_714F5DDE_4280_11DA_9100_000BDBC434D9

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */

/**
Contains the TekUserDB format for user information stored inside a /etc/passwd .\n
\n
This interface is <b>FINAL</b>.
 
@author Kevin McBride
*/
class TekUserDBUnix : public TekUserDB
{
public:
  TekUserDBUnix();

  ~TekUserDBUnix();

  virtual TEKERR Back(void** RetVal);
  virtual TEKERR Clone(TekEnum** RetVal);
  virtual TEKERR Close();
  virtual TEKERR DeleteUsers(const uchar_t* SearchString, TekUserDBFunc* FuncToCall, struct TekArray** RetVal);
  virtual TEKERR DeleteUser(TekUser* UserInfo);
  virtual TEKERR EnumNo(unsigned long ItemNo);
  virtual TEKERR FindUser(const uchar_t* Username, TekUser* RetVal);
  virtual TEKERR FindUsers(const uchar_t* SearchString, TekUserDBFunc* FuncToCall, struct TekArray** RetVal);
  virtual TEKERR FindUsersFree(TekUser** UserInfoArray);
  virtual TEKERR Flush();
  virtual TEKERR get_FileInterfaceUUID(uuid_t* FileUUID);
  virtual TEKERR get_Filename(uchar_t** Filename);
  virtual TEKERR get_GenericFileType(TekFileType* CurrentFileType);
  virtual TEKERR get_ReadOnly(bool* ReadOnlyStat);
  virtual TEKERR Next(void** RetVal);
  virtual TEKERR Open();
  virtual TEKERR OpenAndLoadAll();
  virtual TEKERR put_FileInterfaceUUID(const uuid_t* FileUUID);
  virtual TEKERR put_Filename(const uchar_t* NewFilename);
  virtual TEKERR put_GenericFileType(TekFileType CurrentFileType);
  virtual TEKERR Reset();
  virtual TEKERR WriteUsers(TekUser** UserInfoArray, unsigned long Count);
  virtual TEKERR WriteUser(TekUser* UserInfo);

};

#endif /* TEKUSERDBUNIX_H_714F5DDE_4280_11DA_9100_000BDBC434D9 */

