/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TEKUSERUNIXRW_H_76184080_3E87_11DA_9E50_000BDBC434D9
#define TEKUSERUNIXRW_H_76184080_3E87_11DA_9E50_000BDBC434D9

#ifndef	TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9
#error	This file must be included from <teklti.h>
#endif	/* TEKLTI_H_C35A2A4C_D475_11D9_90BC_000BDBC434D9 */

TEKUUIDIMPORT(UTekUserUnixRW);

/**
Defines the TekUser format for unix and linux platforms, and provides read-write access.
 
This interface is <b>FINAL</b>.
 
@author Kevin McBride
*/

class TekUserUnixRW : public TekUser
{
public:
  TekUserUnixRW();

  ~TekUserUnixRW();

  virtual TEKERR get_Description(uchar_t** RetVal);
  virtual TEKERR get_GroupID(gid_t* RetVal);
  virtual TEKERR get_HomeDir(uchar_t** RetVal);
  virtual TEKERR get_UserID(uid_t* RetVal);
  virtual TEKERR get_Username(uchar_t** RetVal);
  virtual TEKERR put_Description(const uchar_t* NewDescription);
  virtual TEKERR put_GroupID(gid_t NewGroupID);
  virtual TEKERR put_HomeDir(const uchar_t* NewHomeDir);
  virtual TEKERR put_Password(uchar_t* NewPassword);
  virtual TEKERR put_TekUserInfo(struct TekUserInfo* SUInfo);
  virtual TEKERR put_UserID(uid_t NewID);
  virtual TEKERR put_Username(const uchar_t* NewUsername);
  virtual TEKERR Save();

private:
  struct TekUserInfo Priv_UserInfo;
};

#endif /* TEKUSERUNIXRW_H_76184080_3E87_11DA_9E50_000BDBC434D9 */

