/***************************************************************************
 *   Copyright (C) 2005 by Kevin McBride                                   *
 *   kevin@planetsaphire.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as       *
 *   published by the Free Software Foundation; either version 2 of the    *
 *   License, or (at your option) any later version.                       *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Library General Public     *
 *   License along with this program; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#define	NUM_OF_MAIN_HUNKS	6
#define	NUM_OF_TEKFILEBINARY_HUNKS	23
#define	NUM_OF_TEKFILEASCIIBARE_HUNKS	24
#define	NUM_OF_TEKFILEBZ2BINARY_HUNKS	12
#define	NUM_OF_TEKFILEBZ2ASCII_HUNKS	15

#ifdef	DEBUG
#define	SLEEP_LENGTH	0
#else	/* not DEBUG */
#define	SLEEP_LENGTH	1
#endif	/* not DEBUG */


#ifdef	HAVE_CONFIG_H
#define	LIBTEKLTI_EXPORT	0
#include <config.h>
#endif	/* HAVE_CONFIG_H */

#ifdef	TEKLTI_USE_OLDSTYLE_INCLUDE
#include <iostream.h>
#include <stdlib.h>
#else	/* not TEKLTI_USE_OLDSTYLE_INCLUDE */
#include <iostream>
#include <cstdlib>
#include <signal.h>
#endif	/* not TEKLTI_USE_OLDSTYLE_INCLUDE */
#include <errno.h>
#include <stdint.h>

#define	_cplusplus

#include <uuid/uuid.h>

#include <teklti.h>


typedef void(freext)(void *);


#define PRINTHUNK(n, s)	\
fprintf(stdout, "Hunk %d: %s -- ", n + 1, s); \
fflush(stdout); \
sleep(SLEEP_LENGTH);

#define PRINTPASS(array, n) \
fprintf(stdout, "Passed.\n"); \
fflush(stdout); \
array[n] = true; \
sleep(SLEEP_LENGTH);

#ifdef	USE_386_ASM
#define	TEKRAISETRAP	__asm__ ( " int $3 " );
#else	/* USE_386_ASM */
#define	TEKRAISETRAP	raise(SIGTRAP);
#endif	/* USE_386_ASM */

#define PRINTFAIL(array, n, err) \
fprintf(stdout, "Failed.\n"); \
fflush(stdout); \
fprintf(stderr, "TEKERR was: %s\n", gettekerrstr(err));\
if ( err == TEKERR_UNEXPECTED ) \
	TEKRAISETRAP \
array[n] = false; \
sleep(SLEEP_LENGTH);


const char * gettekerrstr ( TEKERR ErrorCode );
void printucharerror();
int processorcheckfail ( void );
void checkprocessor ( void );
void uchar_sigsegv ( int signum );
void verstructfatal ( void );
void incorrectverfatal ( void );
void implfatal ( void );
unsigned int checkverstruct ( void );

